
/*  A Bison parser, made from Gmsh.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	tDOUBLE	257
#define	tSTRING	258
#define	tBIGSTR	259
#define	tEND	260
#define	tAFFECT	261
#define	tDOTS	262
#define	tPi	263
#define	tMPI_Rank	264
#define	tMPI_Size	265
#define	tEuclidian	266
#define	tCoordinates	267
#define	tExp	268
#define	tLog	269
#define	tLog10	270
#define	tSqrt	271
#define	tSin	272
#define	tAsin	273
#define	tCos	274
#define	tAcos	275
#define	tTan	276
#define	tRand	277
#define	tAtan	278
#define	tAtan2	279
#define	tSinh	280
#define	tCosh	281
#define	tTanh	282
#define	tFabs	283
#define	tFloor	284
#define	tCeil	285
#define	tFmod	286
#define	tModulo	287
#define	tHypot	288
#define	tPrintf	289
#define	tSprintf	290
#define	tStrCat	291
#define	tStrPrefix	292
#define	tStrRelative	293
#define	tBoundingBox	294
#define	tDraw	295
#define	tToday	296
#define	tPoint	297
#define	tCircle	298
#define	tEllipse	299
#define	tLine	300
#define	tSphere	301
#define	tPolarSphere	302
#define	tSurface	303
#define	tSpline	304
#define	tVolume	305
#define	tCharacteristic	306
#define	tLength	307
#define	tParametric	308
#define	tElliptic	309
#define	tPlane	310
#define	tRuled	311
#define	tTransfinite	312
#define	tComplex	313
#define	tPhysical	314
#define	tUsing	315
#define	tBump	316
#define	tProgression	317
#define	tPlugin	318
#define	tRotate	319
#define	tTranslate	320
#define	tSymmetry	321
#define	tDilate	322
#define	tExtrude	323
#define	tDuplicata	324
#define	tLoop	325
#define	tRecombine	326
#define	tDelete	327
#define	tCoherence	328
#define	tAttractor	329
#define	tLayers	330
#define	tHole	331
#define	tAlias	332
#define	tAliasWithOptions	333
#define	tText2D	334
#define	tText3D	335
#define	tInterpolationScheme	336
#define	tTime	337
#define	tGrain	338
#define	tCombine	339
#define	tBSpline	340
#define	tBezier	341
#define	tNurbs	342
#define	tOrder	343
#define	tKnots	344
#define	tColor	345
#define	tColorTable	346
#define	tFor	347
#define	tIn	348
#define	tEndFor	349
#define	tIf	350
#define	tEndIf	351
#define	tExit	352
#define	tReturn	353
#define	tCall	354
#define	tFunction	355
#define	tShow	356
#define	tHide	357
#define	tGetValue	358
#define	tGMSH_MAJOR_VERSION	359
#define	tGMSH_MINOR_VERSION	360
#define	tGMSH_PATCH_VERSION	361
#define	tAFFECTPLUS	362
#define	tAFFECTMINUS	363
#define	tAFFECTTIMES	364
#define	tAFFECTDIVIDE	365
#define	tOR	366
#define	tAND	367
#define	tEQUAL	368
#define	tNOTEQUAL	369
#define	tLESSOREQUAL	370
#define	tGREATEROREQUAL	371
#define	tPLUSPLUS	372
#define	tMINUSMINUS	373
#define	UNARYPREC	374

#line 1 "Gmsh.y"

// $Id: Gmsh.tab.cpp,v 1.314 2007/03/24 12:42:02 geuzaine Exp $
//
// Copyright (C) 1997-2007 C. Geuzaine, J.-F. Remacle
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA.
// 
// Please report all bugs and problems to <gmsh@geuz.org>.

#include <stdarg.h>
#include <time.h>
#include "PluginManager.h"
#include "ParUtil.h"
#include "Gmsh.h"
#include "Numeric.h"
#include "Context.h"
#include "GModel.h"
#include "Geo.h"
#include "GeoInterpolation.h"
#include "Generator.h"
#include "Draw.h"
#include "Views.h"
#include "Options.h"
#include "Colors.h"
#include "Parser.h"
#include "OpenFile.h"
#include "CommandLine.h"
#include "FunctionManager.h"
#include "ColorTable.h"
#include "OS.h"
#include "CreateFile.h"
#include "gmshSurface.h"
#include "Attractors.h"

Tree_T *Symbol_T = NULL;

extern Context_T CTX;
extern Mesh *THEM;
extern GModel *GMODEL;

static ExtrudeParams extr;

static Post_View *View;
static List_T *ViewValueList;
static double ViewCoord[100];
static int *ViewNumList, ViewNumNodes, ViewNumComp, ViewNumListTmp;
static int ViewCoordIdx, ViewElementIdx;
static int ViewErrorFlags[VIEW_NB_ELEMENT_TYPES];

#define MAX_RECUR_LOOPS 100
static int ImbricatedLoop = 0;
static gmshSurface *myGmshSurface = 0;
static fpos_t yyposImbricatedLoopsTab[MAX_RECUR_LOOPS];
static int yylinenoImbricatedLoopsTab[MAX_RECUR_LOOPS];
static double LoopControlVariablesTab[MAX_RECUR_LOOPS][3];
static char *LoopControlVariablesNameTab[MAX_RECUR_LOOPS];

void yyerror(char *s);
void yymsg(int type, char *fmt, ...);
void skip_until(char *skip, char *until);
int PrintListOfDouble(char *format, List_T *list, char *buffer);
int CheckViewErrorFlags(Post_View *v);

#line 78 "Gmsh.y"
typedef union {
  char *c;
  int i;
  unsigned int u;
  double d;
  double v[5];
  Shape s;
  List_T *l;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		1223
#define	YYFLAG		-32768
#define	YYNTBASE	141

#define YYTRANSLATE(x) ((unsigned)(x) <= 374 ? yytranslate[x] : 210)

static const short yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   126,     2,   136,     2,   125,     2,     2,   131,
   132,   123,   121,   137,   122,   135,   124,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,   117,
     2,   119,   112,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
   133,     2,   134,   130,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   138,     2,   139,   140,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
    97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
   107,   108,   109,   110,   111,   113,   114,   115,   116,   118,
   120,   127,   128,   129
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     5,     6,     9,    11,    13,    15,    17,    19,
    21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
    41,    44,    50,    58,    66,    76,    83,    92,    93,    96,
    99,   102,   105,   108,   111,   113,   117,   119,   123,   124,
   125,   136,   138,   142,   143,   157,   159,   163,   164,   180,
   189,   190,   197,   204,   206,   208,   210,   212,   214,   216,
   218,   223,   231,   241,   248,   255,   259,   266,   271,   278,
   288,   295,   305,   311,   320,   329,   341,   348,   358,   368,
   378,   380,   382,   390,   399,   406,   413,   420,   428,   436,
   444,   454,   462,   472,   490,   498,   506,   518,   527,   536,
   545,   554,   558,   563,   574,   582,   590,   599,   608,   617,
   625,   634,   640,   652,   658,   668,   670,   672,   674,   675,
   678,   685,   692,   699,   706,   711,   718,   725,   732,   737,
   744,   748,   753,   759,   763,   767,   772,   777,   781,   789,
   797,   801,   809,   813,   816,   819,   835,   838,   845,   854,
   863,   874,   876,   879,   881,   885,   890,   892,   898,   910,
   924,   925,   933,   934,   948,   949,   965,   966,   973,   974,
   985,   994,  1003,  1012,  1025,  1038,  1051,  1066,  1081,  1096,
  1097,  1110,  1111,  1124,  1125,  1138,  1139,  1156,  1157,  1174,
  1175,  1192,  1193,  1212,  1213,  1232,  1233,  1252,  1254,  1257,
  1263,  1271,  1281,  1284,  1294,  1301,  1311,  1321,  1330,  1340,
  1349,  1358,  1365,  1370,  1381,  1392,  1403,  1414,  1417,  1419,
  1423,  1426,  1429,  1432,  1436,  1440,  1444,  1448,  1452,  1456,
  1460,  1464,  1468,  1472,  1476,  1480,  1484,  1488,  1494,  1499,
  1504,  1509,  1514,  1519,  1524,  1529,  1534,  1539,  1544,  1551,
  1556,  1561,  1566,  1571,  1576,  1581,  1588,  1595,  1602,  1607,
  1612,  1617,  1622,  1627,  1632,  1637,  1642,  1647,  1652,  1657,
  1664,  1669,  1674,  1679,  1684,  1689,  1694,  1701,  1708,  1715,
  1720,  1722,  1724,  1726,  1728,  1730,  1732,  1734,  1736,  1742,
  1747,  1752,  1755,  1761,  1765,  1772,  1777,  1785,  1792,  1794,
  1797,  1800,  1804,  1808,  1820,  1830,  1838,  1846,  1848,  1852,
  1854,  1856,  1859,  1863,  1868,  1874,  1877,  1881,  1885,  1891,
  1896,  1898,  1900,  1902,  1906,  1913,  1915,  1917,  1921,  1925,
  1935,  1943,  1945,  1951,  1955,  1962,  1964,  1968,  1970,  1972,
  1974,  1976,  1983,  1988,  1993,  1998,  2005,  2012
};

static const short yyrhs[] = {   142,
     0,     1,     6,     0,     0,   142,   143,     0,   146,     0,
   145,     0,   165,     0,   167,     0,   168,     0,   171,     0,
   172,     0,   173,     0,   174,     0,   177,     0,   194,     0,
   195,     0,   196,     0,   176,     0,   175,     0,   119,     0,
   119,   119,     0,    35,   131,     5,   132,     6,     0,    35,
   131,     5,   132,   144,   208,     6,     0,    35,   131,     5,
   137,   204,   132,     6,     0,    35,   131,     5,   137,   204,
   132,   144,   208,     6,     0,     4,     5,   138,   147,   139,
     6,     0,     4,     5,     4,   199,   138,   147,   139,     6,
     0,     0,   147,   150,     0,   147,   154,     0,   147,   157,
     0,   147,   159,     0,   147,   160,     0,   147,   162,     0,
   197,     0,   148,   137,   197,     0,   197,     0,   149,   137,
   197,     0,     0,     0,     4,   151,   131,   148,   132,   152,
   138,   149,   139,     6,     0,   208,     0,   153,   137,   208,
     0,     0,    80,   131,   197,   137,   197,   137,   197,   132,
   155,   138,   153,   139,     6,     0,   208,     0,   156,   137,
   208,     0,     0,    81,   131,   197,   137,   197,   137,   197,
   137,   197,   132,   158,   138,   156,   139,     6,     0,    82,
   138,   201,   139,   138,   201,   139,     6,     0,     0,    83,
   161,   138,   149,   139,     6,     0,    84,   131,   197,   132,
   202,     6,     0,     7,     0,   108,     0,   109,     0,   110,
     0,   111,     0,   127,     0,   128,     0,     4,   163,   197,
     6,     0,     4,   133,   197,   134,   163,   197,     6,     0,
     4,   133,   138,   204,   139,   134,   163,   202,     6,     0,
     4,   133,   134,     7,   202,     6,     0,     4,   133,   134,
   108,   202,     6,     0,     4,   164,     6,     0,     4,   133,
   197,   134,   164,     6,     0,     4,     7,   209,     6,     0,
     4,   135,     4,     7,   209,     6,     0,     4,   133,   197,
   134,   135,     4,     7,   209,     6,     0,     4,   135,     4,
   163,   197,     6,     0,     4,   133,   197,   134,   135,     4,
   163,   197,     6,     0,     4,   135,     4,   164,     6,     0,
     4,   133,   197,   134,   135,     4,   164,     6,     0,     4,
   135,    91,   135,     4,     7,   205,     6,     0,     4,   133,
   197,   134,   135,    91,   135,     4,     7,   205,     6,     0,
     4,   135,    92,     7,   206,     6,     0,     4,   133,   197,
   134,   135,    92,     7,   206,     6,     0,    64,   131,     4,
   132,   135,     4,     7,   197,     6,     0,    64,   131,     4,
   132,   135,     4,     7,   209,     6,     0,   197,     0,   209,
     0,    43,   131,   197,   132,     7,   199,     6,     0,    60,
    43,   131,   166,   132,     7,   202,     6,     0,    75,    43,
   202,     7,   202,     6,     0,    75,    46,   202,     7,   202,
     6,     0,    52,    53,   202,     7,   197,     6,     0,    46,
   131,   197,   132,     7,   202,     6,     0,    50,   131,   197,
   132,     7,   202,     6,     0,    44,   131,   197,   132,     7,
   202,     6,     0,    44,   131,   197,   132,     7,   202,    56,
   199,     6,     0,    45,   131,   197,   132,     7,   202,     6,
     0,    45,   131,   197,   132,     7,   202,    56,   199,     6,
     0,    54,   131,   197,   132,     7,   138,   197,   137,   197,
   137,     5,   137,     5,   137,     5,   139,     6,     0,    86,
   131,   197,   132,     7,   202,     6,     0,    87,   131,   197,
   132,     7,   202,     6,     0,    88,   131,   197,   132,     7,
   202,    90,   202,    89,   197,     6,     0,    46,    71,   131,
   197,   132,     7,   202,     6,     0,    60,    46,   131,   166,
   132,     7,   202,     6,     0,    56,    49,   131,   197,   132,
     7,   202,     6,     0,    57,    49,   131,   197,   132,     7,
   202,     6,     0,    12,    13,     6,     0,    13,    49,   197,
     6,     0,    54,    49,   131,   197,   132,     7,     5,     5,
     5,     6,     0,    47,   131,   197,   132,     7,   202,     6,
     0,    48,   131,   197,   132,     7,   202,     6,     0,    49,
    71,   131,   197,   132,     7,   202,     6,     0,    60,    49,
   131,   166,   132,     7,   202,     6,     0,    59,    51,   131,
   197,   132,     7,   202,     6,     0,    51,   131,   197,   132,
     7,   202,     6,     0,    60,    51,   131,   166,   132,     7,
   202,     6,     0,    66,   199,   138,   169,   139,     0,    65,
   138,   199,   137,   199,   137,   197,   139,   138,   169,   139,
     0,    67,   199,   138,   169,   139,     0,    68,   138,   199,
   137,   197,   139,   138,   169,   139,     0,   171,     0,   170,
     0,   168,     0,     0,   170,   167,     0,   170,    43,   138,
   204,   139,     6,     0,   170,    46,   138,   204,   139,     6,
     0,   170,    49,   138,   204,   139,     6,     0,   170,    51,
   138,   204,   139,     6,     0,    70,   138,   170,   139,     0,
    70,     4,   133,   197,   134,     6,     0,    78,     4,   133,
   197,   134,     6,     0,    79,     4,   133,   197,   134,     6,
     0,    73,   138,   170,   139,     0,    73,     4,   133,   197,
   134,     6,     0,    73,     4,     6,     0,    73,     4,     4,
     6,     0,    91,   205,   138,   170,   139,     0,   102,   208,
     6,     0,   103,   208,     6,     0,   102,   138,   170,   139,
     0,   103,   138,   170,   139,     0,     4,   209,     6,     0,
     4,     4,   133,   197,   134,   208,     6,     0,     4,     4,
     4,   133,   197,   134,     6,     0,     4,   197,     6,     0,
    64,   131,     4,   132,   135,     4,     6,     0,    85,     4,
     6,     0,    98,     6,     0,    40,     6,     0,    40,   138,
   197,   137,   197,   137,   197,   137,   197,   137,   197,   137,
   197,   139,     6,     0,    41,     6,     0,    93,   131,   197,
     8,   197,   132,     0,    93,   131,   197,     8,   197,     8,
   197,   132,     0,    93,     4,    94,   138,   197,     8,   197,
   139,     0,    93,     4,    94,   138,   197,     8,   197,     8,
   197,   139,     0,    95,     0,   101,     4,     0,    99,     0,
   100,     4,     6,     0,    96,   131,   197,   132,     0,    97,
     0,    69,   199,   138,   170,   139,     0,    69,   138,   199,
   137,   199,   137,   197,   139,   138,   170,   139,     0,    69,
   138,   199,   137,   199,   137,   199,   137,   197,   139,   138,
   170,   139,     0,     0,    69,   199,   138,   170,   178,   192,
   139,     0,     0,    69,   138,   199,   137,   199,   137,   197,
   139,   138,   170,   179,   192,   139,     0,     0,    69,   138,
   199,   137,   199,   137,   199,   137,   197,   139,   138,   170,
   180,   192,   139,     0,     0,    69,   138,   170,   181,   192,
   139,     0,     0,    69,     4,   133,   197,   134,   138,   170,
   182,   192,   139,     0,    69,    43,   138,   197,   137,   199,
   139,     6,     0,    69,    46,   138,   197,   137,   199,   139,
     6,     0,    69,    49,   138,   197,   137,   199,   139,     6,
     0,    69,    43,   138,   197,   137,   199,   137,   199,   137,
   197,   139,     6,     0,    69,    46,   138,   197,   137,   199,
   137,   199,   137,   197,   139,     6,     0,    69,    49,   138,
   197,   137,   199,   137,   199,   137,   197,   139,     6,     0,
    69,    43,   138,   197,   137,   199,   137,   199,   137,   199,
   137,   197,   139,     6,     0,    69,    46,   138,   197,   137,
   199,   137,   199,   137,   199,   137,   197,   139,     6,     0,
    69,    49,   138,   197,   137,   199,   137,   199,   137,   199,
   137,   197,   139,     6,     0,     0,    69,    43,   138,   197,
   137,   199,   139,   183,   138,   192,   139,     6,     0,     0,
    69,    46,   138,   197,   137,   199,   139,   184,   138,   192,
   139,     6,     0,     0,    69,    49,   138,   197,   137,   199,
   139,   185,   138,   192,   139,     6,     0,     0,    69,    43,
   138,   197,   137,   199,   137,   199,   137,   197,   139,   186,
   138,   192,   139,     6,     0,     0,    69,    46,   138,   197,
   137,   199,   137,   199,   137,   197,   139,   187,   138,   192,
   139,     6,     0,     0,    69,    49,   138,   197,   137,   199,
   137,   199,   137,   197,   139,   188,   138,   192,   139,     6,
     0,     0,    69,    43,   138,   197,   137,   199,   137,   199,
   137,   199,   137,   197,   139,   189,   138,   192,   139,     6,
     0,     0,    69,    46,   138,   197,   137,   199,   137,   199,
   137,   199,   137,   197,   139,   190,   138,   192,   139,     6,
     0,     0,    69,    49,   138,   197,   137,   199,   137,   199,
   137,   199,   137,   197,   139,   191,   138,   192,   139,     6,
     0,   193,     0,   192,   193,     0,    76,   138,   197,   139,
     6,     0,    76,   138,   202,   137,   202,   139,     6,     0,
    76,   138,   202,   137,   202,   137,   202,   139,     6,     0,
    72,     6,     0,    77,   131,   197,   132,     7,   202,    61,
   197,     6,     0,    58,    46,   202,     7,   197,     6,     0,
    58,    46,   202,     7,   197,    61,    63,   197,     6,     0,
    58,    46,   202,     7,   197,    61,    62,   197,     6,     0,
    58,    49,   138,   197,   139,     7,   202,     6,     0,    58,
    49,   138,   197,   139,     7,   202,     4,     6,     0,    55,
    49,   138,   197,   139,     7,   202,     6,     0,    58,    51,
   138,   197,   139,     7,   202,     6,     0,    72,    49,   202,
     7,   197,     6,     0,    72,    49,   202,     6,     0,    43,
   138,   204,   139,    94,    49,   138,   197,   139,     6,     0,
    46,   138,   204,   139,    94,    49,   138,   197,   139,     6,
     0,    46,   138,   204,   139,    94,    51,   138,   197,   139,
     6,     0,    49,   138,   204,   139,    94,    51,   138,   197,
   139,     6,     0,    74,     6,     0,   198,     0,   131,   197,
   132,     0,   122,   197,     0,   121,   197,     0,   126,   197,
     0,   197,   122,   197,     0,   197,   121,   197,     0,   197,
   123,   197,     0,   197,   124,   197,     0,   197,   125,   197,
     0,   197,   130,   197,     0,   197,   117,   197,     0,   197,
   119,   197,     0,   197,   118,   197,     0,   197,   120,   197,
     0,   197,   115,   197,     0,   197,   116,   197,     0,   197,
   114,   197,     0,   197,   113,   197,     0,   197,   112,   197,
     8,   197,     0,    14,   131,   197,   132,     0,    15,   131,
   197,   132,     0,    16,   131,   197,   132,     0,    17,   131,
   197,   132,     0,    18,   131,   197,   132,     0,    19,   131,
   197,   132,     0,    20,   131,   197,   132,     0,    21,   131,
   197,   132,     0,    22,   131,   197,   132,     0,    24,   131,
   197,   132,     0,    25,   131,   197,   137,   197,   132,     0,
    26,   131,   197,   132,     0,    27,   131,   197,   132,     0,
    28,   131,   197,   132,     0,    29,   131,   197,   132,     0,
    30,   131,   197,   132,     0,    31,   131,   197,   132,     0,
    32,   131,   197,   137,   197,   132,     0,    33,   131,   197,
   137,   197,   132,     0,    34,   131,   197,   137,   197,   132,
     0,    23,   131,   197,   132,     0,    14,   133,   197,   134,
     0,    15,   133,   197,   134,     0,    16,   133,   197,   134,
     0,    17,   133,   197,   134,     0,    18,   133,   197,   134,
     0,    19,   133,   197,   134,     0,    20,   133,   197,   134,
     0,    21,   133,   197,   134,     0,    22,   133,   197,   134,
     0,    24,   133,   197,   134,     0,    25,   133,   197,   137,
   197,   134,     0,    26,   133,   197,   134,     0,    27,   133,
   197,   134,     0,    28,   133,   197,   134,     0,    29,   133,
   197,   134,     0,    30,   133,   197,   134,     0,    31,   133,
   197,   134,     0,    32,   133,   197,   137,   197,   134,     0,
    33,   133,   197,   137,   197,   134,     0,    34,   133,   197,
   137,   197,   134,     0,    23,   133,   197,   134,     0,     3,
     0,     9,     0,    10,     0,    11,     0,   105,     0,   106,
     0,   107,     0,     4,     0,     4,   140,   138,   197,   139,
     0,     4,   133,   197,   134,     0,   136,     4,   133,   134,
     0,     4,   164,     0,     4,   133,   197,   134,   164,     0,
     4,   135,     4,     0,     4,   133,   197,   134,   135,     4,
     0,     4,   135,     4,   164,     0,     4,   133,   197,   134,
   135,     4,   164,     0,   104,   131,     5,   137,   197,   132,
     0,   200,     0,   122,   199,     0,   121,   199,     0,   199,
   122,   199,     0,   199,   121,   199,     0,   138,   197,   137,
   197,   137,   197,   137,   197,   137,   197,   139,     0,   138,
   197,   137,   197,   137,   197,   137,   197,   139,     0,   138,
   197,   137,   197,   137,   197,   139,     0,   131,   197,   137,
   197,   137,   197,   132,     0,   202,     0,   201,   137,   202,
     0,   197,     0,   203,     0,   138,   139,     0,   138,   204,
   139,     0,   122,   138,   204,   139,     0,   197,   123,   138,
   204,   139,     0,   122,   203,     0,   197,   123,   203,     0,
   197,     8,   197,     0,   197,     8,   197,     8,   197,     0,
    43,   138,   197,   139,     0,   168,     0,   171,     0,   177,
     0,     4,   133,   134,     0,     4,   133,   138,   204,   139,
   134,     0,   197,     0,   203,     0,   204,   137,   197,     0,
   204,   137,   203,     0,   138,   197,   137,   197,   137,   197,
   137,   197,   139,     0,   138,   197,   137,   197,   137,   197,
   139,     0,     4,     0,     4,   135,    91,   135,     4,     0,
   138,   207,   139,     0,     4,   133,   197,   134,   135,    92,
     0,   205,     0,   207,   137,   205,     0,   209,     0,     4,
     0,     5,     0,    42,     0,    37,   131,   208,   137,   208,
   132,     0,    38,   131,   208,   132,     0,    39,   131,   208,
   132,     0,    36,   131,   208,   132,     0,    36,   131,   208,
   137,   204,   132,     0,    36,   131,     4,   135,     4,   132,
     0,    36,   131,     4,   133,   197,   134,   135,     4,   132,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   143,   145,   150,   152,   155,   157,   158,   159,   160,   161,
   162,   163,   164,   165,   166,   167,   168,   169,   170,   173,
   178,   184,   190,   205,   218,   246,   254,   263,   271,   272,
   273,   274,   275,   276,   279,   282,   286,   289,   293,   484,
   502,   512,   518,   525,   533,   539,   545,   552,   560,   566,
   574,   579,   583,   592,   594,   595,   596,   597,   600,   602,
   605,   640,   679,   733,   750,   768,   779,   796,   803,   817,
   834,   860,   887,   901,   918,   932,   949,   969,   992,  1002,
  1016,  1021,  1029,  1055,  1071,  1100,  1131,  1153,  1171,  1189,
  1207,  1233,  1251,  1277,  1297,  1321,  1345,  1371,  1388,  1407,
  1425,  1464,  1469,  1474,  1480,  1502,  1524,  1540,  1560,  1577,
  1594,  1614,  1620,  1625,  1630,  1637,  1639,  1640,  1643,  1648,
  1652,  1675,  1698,  1721,  1748,  1761,  1767,  1773,  1784,  1794,
  1804,  1820,  1838,  1852,  1859,  1865,  1874,  1887,  1938,  1953,
  1964,  1984,  1994,  2016,  2020,  2025,  2030,  2040,  2057,  2073,
  2099,  2126,  2158,  2165,  2170,  2176,  2180,  2188,  2197,  2205,
  2213,  2217,  2225,  2229,  2237,  2241,  2249,  2253,  2260,  2264,
  2276,  2283,  2290,  2297,  2304,  2311,  2318,  2325,  2332,  2339,
  2343,  2350,  2354,  2361,  2365,  2372,  2376,  2383,  2387,  2394,
  2398,  2405,  2409,  2416,  2420,  2427,  2431,  2441,  2445,  2450,
  2460,  2482,  2506,  2510,  2533,  2552,  2570,  2588,  2617,  2652,
  2657,  2684,  2698,  2716,  2723,  2729,  2732,  2740,  2750,  2752,
  2753,  2754,  2755,  2756,  2757,  2758,  2759,  2766,  2767,  2768,
  2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,  2777,  2778,
  2779,  2780,  2781,  2782,  2783,  2784,  2785,  2786,  2787,  2788,
  2789,  2790,  2791,  2792,  2793,  2794,  2795,  2796,  2797,  2799,
  2800,  2801,  2802,  2803,  2804,  2805,  2806,  2807,  2808,  2809,
  2810,  2811,  2812,  2813,  2814,  2815,  2816,  2817,  2818,  2819,
  2824,  2829,  2830,  2831,  2832,  2833,  2834,  2838,  2854,  2869,
  2889,  2903,  2916,  2939,  2957,  2975,  2993,  3011,  3018,  3023,
  3027,  3031,  3035,  3041,  3046,  3050,  3054,  3060,  3066,  3073,
  3079,  3083,  3088,  3092,  3100,  3110,  3119,  3127,  3133,  3144,
  3164,  3174,  3184,  3194,  3211,  3237,  3243,  3247,  3251,  3263,
  3268,  3280,  3287,  3308,  3313,  3327,  3333,  3339,  3344,  3350,
  3355,  3363,  3371,  3385,  3399,  3403,  3422,  3444
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","tDOUBLE",
"tSTRING","tBIGSTR","tEND","tAFFECT","tDOTS","tPi","tMPI_Rank","tMPI_Size","tEuclidian",
"tCoordinates","tExp","tLog","tLog10","tSqrt","tSin","tAsin","tCos","tAcos",
"tTan","tRand","tAtan","tAtan2","tSinh","tCosh","tTanh","tFabs","tFloor","tCeil",
"tFmod","tModulo","tHypot","tPrintf","tSprintf","tStrCat","tStrPrefix","tStrRelative",
"tBoundingBox","tDraw","tToday","tPoint","tCircle","tEllipse","tLine","tSphere",
"tPolarSphere","tSurface","tSpline","tVolume","tCharacteristic","tLength","tParametric",
"tElliptic","tPlane","tRuled","tTransfinite","tComplex","tPhysical","tUsing",
"tBump","tProgression","tPlugin","tRotate","tTranslate","tSymmetry","tDilate",
"tExtrude","tDuplicata","tLoop","tRecombine","tDelete","tCoherence","tAttractor",
"tLayers","tHole","tAlias","tAliasWithOptions","tText2D","tText3D","tInterpolationScheme",
"tTime","tGrain","tCombine","tBSpline","tBezier","tNurbs","tOrder","tKnots",
"tColor","tColorTable","tFor","tIn","tEndFor","tIf","tEndIf","tExit","tReturn",
"tCall","tFunction","tShow","tHide","tGetValue","tGMSH_MAJOR_VERSION","tGMSH_MINOR_VERSION",
"tGMSH_PATCH_VERSION","tAFFECTPLUS","tAFFECTMINUS","tAFFECTTIMES","tAFFECTDIVIDE",
"'?'","tOR","tAND","tEQUAL","tNOTEQUAL","'<'","tLESSOREQUAL","'>'","tGREATEROREQUAL",
"'+'","'-'","'*'","'/'","'%'","'!'","tPLUSPLUS","tMINUSMINUS","UNARYPREC","'^'",
"'('","')'","'['","']'","'.'","'#'","','","'{'","'}'","'~'","All","GeoFormatItems",
"GeoFormatItem","SendToFile","Printf","View","Views","ElementCoords","ElementValues",
"Element","@1","@2","Text2DValues","Text2D","@3","Text3DValues","Text3D","@4",
"InterpolationMatrix","Time","@5","Grain","NumericAffectation","NumericIncrement",
"Affectation","PhysicalId","Shape","Transform","MultipleShape","ListOfShapes",
"Duplicata","Delete","Colorify","Visibility","Command","Loop","Extrude","@6",
"@7","@8","@9","@10","@11","@12","@13","@14","@15","@16","@17","@18","@19","ExtrudeParameters",
"ExtrudeParameter","Transfinite","Embedding","Coherence","FExpr","FExpr_Single",
"VExpr","VExpr_Single","RecursiveListOfListOfDouble","ListOfDouble","FExpr_Multi",
"RecursiveListOfDouble","ColorExpr","ListOfColor","RecursiveListOfColor","StringExprVar",
"StringExpr", NULL
};
#endif

static const short yyr1[] = {     0,
   141,   141,   142,   142,   143,   143,   143,   143,   143,   143,
   143,   143,   143,   143,   143,   143,   143,   143,   143,   144,
   144,   145,   145,   145,   145,   146,   146,   147,   147,   147,
   147,   147,   147,   147,   148,   148,   149,   149,   151,   152,
   150,   153,   153,   155,   154,   156,   156,   158,   157,   159,
   161,   160,   162,   163,   163,   163,   163,   163,   164,   164,
   165,   165,   165,   165,   165,   165,   165,   165,   165,   165,
   165,   165,   165,   165,   165,   165,   165,   165,   165,   165,
   166,   166,   167,   167,   167,   167,   167,   167,   167,   167,
   167,   167,   167,   167,   167,   167,   167,   167,   167,   167,
   167,   167,   167,   167,   167,   167,   167,   167,   167,   167,
   167,   168,   168,   168,   168,   169,   169,   169,   170,   170,
   170,   170,   170,   170,   171,   171,   171,   171,   172,   172,
   172,   172,   173,   174,   174,   174,   174,   175,   175,   175,
   175,   175,   175,   175,   175,   175,   175,   176,   176,   176,
   176,   176,   176,   176,   176,   176,   176,   177,   177,   177,
   178,   177,   179,   177,   180,   177,   181,   177,   182,   177,
   177,   177,   177,   177,   177,   177,   177,   177,   177,   183,
   177,   184,   177,   185,   177,   186,   177,   187,   177,   188,
   177,   189,   177,   190,   177,   191,   177,   192,   192,   193,
   193,   193,   193,   193,   194,   194,   194,   194,   194,   194,
   194,   194,   194,   195,   195,   195,   195,   196,   197,   197,
   197,   197,   197,   197,   197,   197,   197,   197,   197,   197,
   197,   197,   197,   197,   197,   197,   197,   197,   197,   197,
   197,   197,   197,   197,   197,   197,   197,   197,   197,   197,
   197,   197,   197,   197,   197,   197,   197,   197,   197,   197,
   197,   197,   197,   197,   197,   197,   197,   197,   197,   197,
   197,   197,   197,   197,   197,   197,   197,   197,   197,   197,
   198,   198,   198,   198,   198,   198,   198,   198,   198,   198,
   198,   198,   198,   198,   198,   198,   198,   198,   199,   199,
   199,   199,   199,   200,   200,   200,   200,   201,   201,   202,
   202,   202,   202,   202,   202,   203,   203,   203,   203,   203,
   203,   203,   203,   203,   203,   204,   204,   204,   204,   205,
   205,   205,   205,   206,   206,   207,   207,   208,   208,   209,
   209,   209,   209,   209,   209,   209,   209,   209
};

static const short yyr2[] = {     0,
     1,     2,     0,     2,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     2,     5,     7,     7,     9,     6,     8,     0,     2,     2,
     2,     2,     2,     2,     1,     3,     1,     3,     0,     0,
    10,     1,     3,     0,    13,     1,     3,     0,    15,     8,
     0,     6,     6,     1,     1,     1,     1,     1,     1,     1,
     4,     7,     9,     6,     6,     3,     6,     4,     6,     9,
     6,     9,     5,     8,     8,    11,     6,     9,     9,     9,
     1,     1,     7,     8,     6,     6,     6,     7,     7,     7,
     9,     7,     9,    17,     7,     7,    11,     8,     8,     8,
     8,     3,     4,    10,     7,     7,     8,     8,     8,     7,
     8,     5,    11,     5,     9,     1,     1,     1,     0,     2,
     6,     6,     6,     6,     4,     6,     6,     6,     4,     6,
     3,     4,     5,     3,     3,     4,     4,     3,     7,     7,
     3,     7,     3,     2,     2,    15,     2,     6,     8,     8,
    10,     1,     2,     1,     3,     4,     1,     5,    11,    13,
     0,     7,     0,    13,     0,    15,     0,     6,     0,    10,
     8,     8,     8,    12,    12,    12,    14,    14,    14,     0,
    12,     0,    12,     0,    12,     0,    16,     0,    16,     0,
    16,     0,    18,     0,    18,     0,    18,     1,     2,     5,
     7,     9,     2,     9,     6,     9,     9,     8,     9,     8,
     8,     6,     4,    10,    10,    10,    10,     2,     1,     3,
     2,     2,     2,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     5,     4,     4,
     4,     4,     4,     4,     4,     4,     4,     4,     6,     4,
     4,     4,     4,     4,     4,     6,     6,     6,     4,     4,
     4,     4,     4,     4,     4,     4,     4,     4,     4,     6,
     4,     4,     4,     4,     4,     4,     6,     6,     6,     4,
     1,     1,     1,     1,     1,     1,     1,     1,     5,     4,
     4,     2,     5,     3,     6,     4,     7,     6,     1,     2,
     2,     3,     3,    11,     9,     7,     7,     1,     3,     1,
     1,     2,     3,     4,     5,     2,     3,     3,     5,     4,
     1,     1,     1,     3,     6,     1,     1,     3,     3,     9,
     7,     1,     5,     3,     6,     1,     3,     1,     1,     1,
     1,     6,     4,     4,     4,     6,     6,     9
};

static const short yydefact[] = {     0,
     0,     1,     2,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   152,     0,   157,     0,   154,
     0,     0,     0,     0,     4,     6,     5,     7,     8,     9,
    10,    11,    12,    13,    19,    18,    14,    15,    16,    17,
   281,   288,   340,    54,   282,   283,   284,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   341,     0,   285,   286,   287,    55,    56,    57,
    58,     0,     0,     0,    59,    60,     0,     0,     0,     0,
     0,     0,     0,   219,     0,     0,     0,     0,   145,     0,
   147,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   299,     0,     0,     0,     0,
     0,     0,   119,     0,     0,   119,     0,     0,   119,   218,
     0,     0,     0,     0,     0,     0,     0,     0,   332,     0,
     0,     0,     0,     0,   144,     0,   153,   339,   340,   119,
     0,   338,   119,     0,     0,     0,     0,     0,   292,     0,
    28,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   288,
   222,   221,   223,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    66,   141,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   138,
   102,     0,     0,     0,     0,   288,     0,     0,   321,   322,
   323,   326,   327,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   310,     0,   311,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   301,   300,     0,     0,     0,
     0,   119,   119,     0,     0,     0,     0,     0,     0,     0,
     0,   167,     0,   119,     0,     0,     0,     0,   131,     0,
     0,     0,     0,     0,     0,   143,     0,     0,     0,     0,
     0,   119,     0,     0,     0,   155,     0,   134,     0,   135,
     0,     0,   294,     0,     0,     0,    68,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   339,
     0,     0,     0,     0,     0,     0,   220,     0,     0,     0,
     0,    54,     0,     0,     0,     0,     0,    61,     0,   237,
   236,   234,   235,   230,   232,   231,   233,   225,   224,   226,
   227,   228,   229,   103,     0,     0,     0,     0,     0,     0,
   221,   316,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   312,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    81,    82,     0,     0,     0,     0,     0,     0,
     0,   303,   302,   118,     0,   117,   116,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   120,     0,
     0,   161,     0,   125,   213,     0,   132,     0,   129,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   156,   136,   137,     0,   290,   296,     0,    28,    39,
     0,     0,     0,    51,     0,     0,    29,    30,    31,    32,
    33,    34,   239,   260,   240,   261,   241,   262,   242,   263,
   243,   264,   244,   265,   245,   266,   246,   267,   247,   268,
   259,   280,   248,   269,     0,     0,   250,   271,   251,   272,
   252,   273,   253,   274,   254,   275,   255,   276,     0,     0,
     0,     0,     0,     0,     0,     0,   345,     0,     0,   343,
   344,     0,     0,     0,     0,     0,    54,     0,     0,     0,
     0,     0,    73,     0,     0,     0,     0,   291,     0,    22,
    20,     0,     0,     0,     0,   324,     0,     0,   318,   226,
   317,   328,   329,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   313,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   112,   114,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   198,     0,   158,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   133,     0,     0,
     0,     0,   293,     0,   289,     0,     0,     0,     0,     0,
     0,     0,    26,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   290,    64,    65,     0,
     0,     0,     0,     0,    67,    69,    71,     0,     0,   336,
     0,    77,   238,    21,     0,     0,     0,     0,     0,   320,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   314,     0,    87,     0,     0,     0,
     0,     0,   205,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   119,     0,     0,     0,
     0,     0,     0,     0,   203,     0,     0,   168,   199,     0,
     0,   126,   212,   130,    85,    86,   127,   128,     0,     0,
     0,   333,     0,     0,     0,   148,   140,   295,   139,     0,
     0,     0,     0,     0,   308,     0,     0,   249,   270,   256,
   277,   257,   278,   258,   279,     0,   347,   346,   342,   298,
     0,    54,     0,     0,     0,     0,    62,     0,     0,     0,
   334,    23,    24,     0,     0,    83,     0,   319,     0,    90,
     0,    92,     0,     0,    88,     0,     0,   105,   106,     0,
     0,    89,   110,   315,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   142,     0,
     0,     0,     0,   119,   169,     0,   180,     0,   182,     0,
   184,     0,     0,     0,     0,   310,     0,     0,     0,     0,
   162,    95,    96,     0,     0,     0,     0,   297,    27,     0,
    35,     0,     0,     0,     0,     0,    37,     0,     0,     0,
     0,     0,    74,     0,     0,    75,     0,   337,     0,     0,
   325,     0,     0,     0,    98,     0,     0,   107,     0,     0,
     0,   210,   100,   101,     0,     0,     0,   208,   211,   109,
    84,    99,   108,   111,     0,     0,     0,   307,     0,   306,
     0,     0,     0,   171,     0,     0,   172,     0,     0,   173,
     0,   121,   122,   123,   124,     0,     0,     0,     0,     0,
     0,     0,   331,     0,   150,   149,    40,     0,     0,     0,
   309,     0,     0,     0,     0,     0,    63,    70,    72,     0,
    78,     0,    25,     0,     0,    91,    93,     0,     0,     0,
     0,     0,   207,   206,   209,    79,    80,   119,     0,   115,
     0,     0,     0,     0,     0,     0,     0,   200,     0,     0,
   119,     0,     0,     0,     0,     0,    36,     0,     0,     0,
    38,    52,    53,   348,     0,   335,     0,   214,   215,   216,
   217,   104,     0,     0,     0,   305,   170,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   163,
     0,     0,   330,   151,     0,     0,     0,     0,    76,     0,
     0,   113,     0,   186,     0,     0,   188,     0,     0,   190,
     0,     0,     0,   201,     0,   159,     0,   119,    97,     0,
    44,     0,    50,     0,     0,   304,   174,     0,     0,   181,
   175,     0,     0,   183,   176,     0,     0,   185,     0,     0,
     0,   165,     0,     0,     0,     0,     0,     0,   192,     0,
   194,     0,   196,   202,   204,   164,   160,     0,    41,     0,
    48,     0,     0,     0,   177,     0,     0,   178,     0,     0,
   179,     0,     0,     0,    42,     0,   146,     0,     0,     0,
     0,     0,     0,     0,   166,     0,     0,     0,     0,   187,
     0,   189,     0,   191,     0,    43,    45,     0,    46,    94,
     0,     0,     0,     0,     0,   193,   195,   197,    47,    49,
     0,     0,     0
};

static const short yydefgoto[] = {  1221,
     2,    55,   642,    56,    57,   386,   940,   946,   567,   727,
  1066,  1184,   568,  1154,  1208,   569,  1186,   570,   571,   731,
   572,   121,   209,    58,   502,   529,   299,   515,   516,   300,
    62,    63,    64,    65,    66,   301,   705,  1127,  1168,   530,
   992,   995,   998,  1001,  1138,  1142,  1146,  1176,  1179,  1182,
   701,   702,    68,    69,    70,   318,   124,   336,   166,   844,
   845,   320,   304,   191,   637,   761,   201,   202
};

static const short yypact[] = {  2708,
    61,  2785,-32768,  1879,    74,   -22,   -32,     7,   115,   -98,
    -6,    42,    36,   124,   128,    33,   142,   167,   272,   -34,
   102,   241,   284,   360,   302,    29,   248,   253,   -33,   -33,
   258,    57,    12,   350,    16,   434,   163,   430,   433,   440,
   324,   336,   364,    19,    25,-32768,   367,-32768,   500,-32768,
   508,   511,    14,    21,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,    20,    26,    32,-32768,-32768,-32768,   188,   208,   310,
   321,   327,   346,   363,   398,   401,   408,   411,   423,   428,
   456,   466,   471,   506,   516,   545,   567,   602,   393,   405,
   417,   438,-32768,   448,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,  2174,  2174,  2174,-32768,-32768,  2174,  1673,    17,   526,
  2174,   574,   662,-32768,   578,   585,  2174,   591,-32768,  2174,
-32768,  2174,  2013,  2174,  2174,   474,  2174,  2013,  2174,  2174,
   475,  2013,  2174,  2174,  1283,   484,  2174,   478,   488,   502,
  1283,   510,   517,   523,   548,   549,   554,   558,   688,   -33,
   -33,   -33,  2174,  2174,   -20,-32768,   196,   -33,   570,   566,
   569,   573,  1844,   240,   575,-32768,  1283,    35,-32768,-32768,
  1283,  1283,   579,   583,   724,  2174,  2174,  2174,   604,  2174,
   621,   651,  2174,  2174,-32768,   761,-32768,-32768,-32768,-32768,
   762,-32768,-32768,   766,   640,  2174,   789,   663,-32768,   -33,
-32768,   801,  2174,  2174,  2174,  2174,  2174,  2174,  2174,  2174,
  2174,  2174,  2174,  2174,  2174,  2174,  2174,  2174,  2174,  2174,
  2174,  2174,  2174,  2174,  2174,  2174,  2174,  2174,  2174,  2174,
  2174,  2174,  2174,  2174,  2174,  2174,  2174,  2174,  2174,  2174,
  2174,  2174,  2174,  2174,   588,   627,   627,   627,   812,   277,
   705,   705,   705,  5019,    27,  2013,  2798,   261,   683,   831,
   721,  1810,-32768,-32768,  2174,  2174,  2174,  2174,  2174,  2174,
  2174,  2174,  2174,  2174,  2174,  2174,  2174,  2174,  2174,-32768,
-32768,  1946,   -88,  3552,  5040,   716,   717,  2013,-32768,-32768,
-32768,  2485,-32768,   607,  5061,  5082,  2174,  5103,   617,  5124,
  5145,  2174,   625,  5166,  5187,  1413,  1152,  2504,   857,-32768,
  2174,  5208,  2174,  2174,  2174,   873,  2174,  2174,  2174,  2137,
  2137,  2137,  2137,   751,   244,-32768,-32768,  3578,  3604,   -33,
   -33,   682,   682,   383,  2174,  2174,  2174,  2174,  1844,  1844,
  2174,  2849,   551,-32768,  2174,  1051,    70,   878,-32768,  2174,
  1189,   894,   898,  2174,  2174,-32768,  5229,  5250,  5271,   796,
  3630,-32768,   768,  2523,  5292,-32768,  1320,-32768,  1450,-32768,
  2174,  4306,    80,  2174,   311,     1,-32768,  5313,  4329,  5334,
  4352,  5355,  4375,  5376,  4398,  5397,  4421,  5418,  4444,  5439,
  4467,  5460,  4490,  5481,  4513,  5502,  4536,  5523,  4559,  3656,
  3682,  5544,  4582,  5565,  4605,  5586,  4628,  5607,  4651,  5628,
  4674,  5649,  4697,  3708,  3734,  3760,  3786,  3812,  3838,   630,
   -13,   770,   776,   778,   774,  2174,-32768,  1283,  1283,   632,
   247,    32,  2174,   906,   909,    28,   782,-32768,  2542,   830,
   706,   844,   844,   736,   736,   736,   736,   520,   520,   705,
   705,   705,   705,-32768,    39,  2013,  2174,   910,  1708,  2174,
   705,-32768,  2174,  2013,  2013,   826,   915,   917,  5670,   918,
   832,   920,   921,  5691,   839,   927,   928,  2013,-32768,   657,
  1543,  2174,  5712,   929,  2611,  5733,  5754,  2174,  2910,  2938,
  5775,   805,  6027,-32768,   806,   807,   808,   822,   -33,  2174,
  2174,-32768,-32768,-32768,   804,  2849,-32768,   833,  2174,  4720,
  3864,  3890,  3916,  3526,   -65,   126,   125,    45,-32768,   546,
   -33,  1701,  4743,-32768,-32768,  2174,-32768,  4766,-32768,  1283,
  1283,  4789,  4812,   964,   966,   968,   841,  2174,  2270,  2174,
  2174,-32768,-32768,-32768,  4835,   265,-32768,  2966,-32768,-32768,
   846,   847,   842,-32768,   851,   977,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,  2174,  2174,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  2174,  2174,
  2174,  2174,  2174,  2174,  2174,   980,-32768,  2013,   627,-32768,
-32768,  2174,  4858,   979,   981,   852,-32768,    31,  2174,   983,
   984,  1985,-32768,   999,   858,    19,  1001,-32768,  2174,-32768,
   889,   627,   130,  3942,   -33,-32768,  2013,  2994,  2562,   705,
-32768,  2485,-32768,   963,  1283,  1283,  1008,  1283,   748,  1283,
  1283,  1013,   970,  1283,  1283,   661,-32768,  2013,  2105,  1030,
   900,  1032,  1033,  1035,   306,  1036,  1037,  1038,  1039,  1040,
  1042,  1045,  1050,   553,  3968,  3994,-32768,-32768,  3022,   922,
   -33,   -33,   -33,  2013,  2013,  2013,  2013,  1052,   923,   925,
    38,-32768,   560,-32768,   546,  1053,  2319,  1059,  1060,  1063,
  1064,  1065,  1283,  1283,  1283,  1068,  4020,-32768,  2581,  1513,
  1067,  1070,-32768,  1069,-32768,    10,   946,  2174,  2174,  1283,
   940,  2174,-32768,  5796,  4881,  5817,  4904,  5838,  4927,  5859,
  4950,  4973,   947,   159,   948,  5880,   -80,-32768,-32768,   184,
   353,   950,  1074,  2342,-32768,-32768,-32768,    19,  2174,-32768,
   671,-32768,  6027,-32768,  1076,    56,  2174,    48,   674,-32768,
  2174,   945,    30,    40,  1283,  1080,   949,   951,  1082,  1084,
  1283,   953,  1086,  1087,-32768,   675,-32768,  1101,  2174,  1283,
  1283,  1283,-32768,   323,  1283,  1283,  1283,  1283,  1283,  1283,
  1283,   556,  2174,  2174,  2174,   971,-32768,   276,   461,   464,
   709,   713,   726,   733,-32768,  1283,  2174,-32768,-32768,  1844,
   122,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  1106,  1107,
  1025,-32768,  2174,  2174,  2174,-32768,-32768,    80,-32768,  1112,
  2174,  4046,  4072,   737,-32768,  2174,  5901,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   986,-32768,-32768,-32768,-32768,
  1283,    32,  2174,  1113,  1118,    28,-32768,  1117,  4996,    19,
-32768,-32768,-32768,   627,  4098,-32768,   991,  6027,  2174,-32768,
   -33,-32768,   -33,  1121,-32768,  2174,  2174,-32768,-32768,  1122,
  2174,-32768,-32768,-32768,  1124,  4124,  1126,  1128,  1129,  2174,
  2174,   871,  1130,  1134,  1135,  1137,  1139,  1140,-32768,  2137,
  3050,  5922,  2826,   682,  2849,   -33,  1141,   -33,  1142,   -33,
  1143,  1145,  1147,  1151,  1153,   880,   993,  5943,  3078,   562,
-32768,-32768,-32768,  1283,  2854,   911,  5964,-32768,-32768,   173,
  6027,  2174,  2174,  1283,  1020,   742,  6027,  1283,  1160,  1159,
  1181,  2367,-32768,  1182,  1185,-32768,  1057,-32768,  1187,  2174,
-32768,  3106,    59,    89,-32768,  3134,  3162,-32768,  3190,  1183,
  2174,-32768,-32768,-32768,  2386,  2405,  1188,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,  2424,  1190,  1061,-32768,  2174,-32768,
  1058,   546,   565,-32768,  1062,   584,-32768,  1066,   592,-32768,
  1071,-32768,-32768,-32768,-32768,  1192,  1283,  1196,  1072,  2174,
  1116,  2174,-32768,  2174,-32768,-32768,-32768,  2174,  4150,  4176,
-32768,  1283,  2174,  1200,  1201,  1079,-32768,-32768,-32768,    19,
-32768,  1120,-32768,  4202,  1202,-32768,-32768,  1207,  1208,  1209,
  1210,  4228,-32768,-32768,-32768,-32768,-32768,   682,  2882,-32768,
   237,  1844,   546,  1844,   546,  1844,   546,-32768,   754,  1283,
-32768,  3218,  2174,  3246,  3274,  1085,  6027,  2174,  2174,   755,
  6027,-32768,-32768,-32768,  1218,-32768,  2174,-32768,-32768,-32768,
-32768,-32768,  1220,  1088,  2174,-32768,-32768,  3302,   603,   318,
  3330,   616,   331,  3358,   620,   374,  1283,  1222,  1165,  2290,
  1091,  2444,-32768,-32768,  2174,  5985,  4254,  1236,-32768,  4280,
  1110,-32768,  3386,  1238,  2174,  1244,  1245,  2174,  1246,  1247,
  2174,  1248,  1123,-32768,  2174,-32768,   546,-32768,-32768,   758,
-32768,  2174,-32768,  2174,  1250,-32768,-32768,  1125,  3414,-32768,
-32768,  1127,  3442,-32768,-32768,  1131,  3470,-32768,  1254,  2463,
   399,  2339,  1255,  1132,  6006,  3498,  1144,   546,  1260,   546,
  1261,   546,  1262,-32768,-32768,-32768,-32768,   546,-32768,   627,
-32768,  1265,  1267,   406,-32768,  1146,   416,-32768,  1157,   431,
-32768,  1158,   451,   759,-32768,  1180,-32768,  1150,  1273,   546,
  1274,   546,  1276,   546,-32768,   627,  1279,   627,  1284,-32768,
   481,-32768,   495,-32768,   501,-32768,-32768,   765,-32768,-32768,
  1313,  1314,  1315,   627,  1316,-32768,-32768,-32768,-32768,-32768,
  1323,  1324,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,   559,-32768,-32768,   771,-32768,   222,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,  -251,     4,-32768,   153,  1327,     0,  -333,  -172,     9,
-32768,-32768,-32768,-32768,-32768,  1329,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -321,  -637,-32768,-32768,-32768,    -1,-32768,    98,-32768,   312,
  -139,   235,    23,  -614,   469,-32768,   -54,     5
};


#define	YYLAST		6157


static const short yytable[] = {   204,
   352,    60,   123,   356,   560,   319,   361,   122,   125,   518,
    61,   326,   129,   560,   146,   175,   443,   198,   199,   178,
   268,   760,   189,   205,   198,   199,   127,   377,   192,   210,
   379,   635,   132,   438,   751,   880,   199,   357,   358,   133,
   359,   362,   363,   465,   640,   882,   115,   116,   466,    99,
   100,   101,   102,   876,   722,   103,    99,   100,   101,   102,
   169,   873,   103,   819,  1036,   132,     3,    99,   100,   101,
   102,   155,   694,   103,   156,   535,   536,   157,   212,   158,
   561,   562,   563,   564,   565,   881,   126,   161,   162,   561,
   562,   563,   564,   565,  1037,   883,   147,   163,   128,   170,
   340,   341,   171,   141,   164,   172,   136,   269,   270,   698,
   261,   262,   263,   699,   700,   264,   267,   342,   617,   272,
   131,   752,   753,   618,   134,   292,   165,   167,   294,   174,
   295,   302,   305,   306,   439,   308,   302,   310,   311,   566,
   302,   314,   315,   868,   130,   322,   115,   116,   840,   176,
   148,   200,   206,   179,   207,   193,   190,   641,   203,   208,
   309,   338,   339,   211,   313,   636,   137,   360,   340,   341,
   142,   339,   135,   138,   641,   144,   818,   161,   162,   340,
   341,   532,   697,   819,   367,   368,   369,   163,   371,   629,
   627,   374,   375,   698,   173,   141,   136,   699,   700,   549,
   431,   432,   433,   434,   382,   181,   115,   116,   182,   340,
   341,   388,   389,   390,   391,   392,   393,   394,   395,   396,
   397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
   407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
   417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
   427,   428,   429,   627,   139,   958,   137,   335,   140,   337,
   931,   766,   696,   695,   302,   344,   475,   442,   198,   199,
   353,   444,   143,   449,   450,   451,   452,   453,   454,   455,
   456,   457,   458,   459,   460,   461,   462,   463,   440,   149,
   858,   108,   109,   110,   111,   475,   471,   144,   624,   625,
    99,   100,   101,   102,  1017,   479,   103,   385,   698,  1018,
   484,   793,   699,   700,   471,   302,   340,   341,   213,   493,
   214,   495,   496,   497,   145,   499,   500,   501,   503,   503,
   503,   503,   150,   343,   504,   504,   504,   504,   215,   490,
   216,   514,   514,   520,   521,   522,   523,   261,   262,   524,
   517,   517,   154,   533,   108,   109,   110,   111,   538,   862,
   340,   341,   542,   543,   340,   341,   794,   303,   108,   109,
   110,   111,   303,   115,   116,  1087,   303,   354,   159,   555,
   509,   628,   558,   821,   900,   901,   557,   115,   116,   698,
   160,   115,   116,   699,   700,   168,   340,   341,   177,   722,
   709,   710,   698,   115,   116,   151,   699,   700,   152,   436,
   153,   207,   916,   819,   917,  1075,   208,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,   340,   341,   183,   623,   289,   184,   512,   513,   180,
   217,   632,   218,   185,   630,   698,   631,   337,   559,   699,
   700,   219,   819,   220,   186,   819,  1116,   221,   819,   222,
   108,   109,   110,   111,   302,   644,   187,   623,   648,  1119,
   698,   649,   650,   652,   699,   700,   223,   698,   224,   115,
   116,   699,   700,   505,   506,   507,   302,   698,   643,   650,
   669,   699,   700,   225,   188,   226,   675,   194,   861,   863,
   303,   724,   698,   340,   341,   195,   699,   700,   685,   686,
   666,   196,  1122,   819,   197,   773,   774,   689,   776,   519,
   779,   780,   698,   255,   783,   784,   699,   700,   227,   271,
   228,   229,   472,   230,   707,   256,   819,  1166,   231,   819,
   232,   233,   819,   234,  1189,   819,   717,   257,   719,   720,
   472,   303,   698,   235,  1191,   236,   699,   700,   237,   723,
   238,   909,   910,   819,   745,   819,   698,   819,   258,  1193,
   699,   700,   698,   829,   830,   831,   699,   700,   259,   273,
   991,   340,   341,   290,   340,   341,   239,   765,   240,  1195,
   291,   430,   199,   734,   735,   293,   241,   918,   242,   919,
   920,   243,   921,   244,   307,   312,   684,   736,   737,   738,
   739,   740,   741,   742,   321,   323,   302,   698,   324,  1211,
   746,   699,   700,    99,   100,   101,   102,   754,   703,   103,
   198,   199,   325,  1212,   915,   884,   245,   763,   246,  1213,
   744,   890,   286,   287,   288,   302,   247,   327,   248,   289,
   897,   898,   899,   329,   328,   902,   903,   904,   905,   906,
   907,   908,    99,   100,   101,   102,   302,   274,   103,   769,
  1051,   340,   341,   340,   341,   249,   927,   250,   330,   331,
   340,   341,   340,   341,   332,   340,   341,   531,   333,   803,
   786,   334,   302,   302,   302,   302,   820,   251,  1010,   252,
   303,  1052,   345,   346,   340,   341,   347,   355,   651,   653,
   348,   364,   340,   341,  1084,   365,   811,   812,   813,   814,
  1054,   950,   303,   340,   341,   651,   842,   843,  1056,   366,
   847,  1090,   253,  1093,   254,  1096,   340,   341,   370,  1115,
   340,   341,   768,   475,   373,   476,    28,    29,    30,    31,
   723,    33,  1118,   475,   864,   481,  1121,   869,   372,    38,
    39,   475,   615,   485,   616,   875,   376,   378,   475,   878,
   626,   380,   381,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,   896,   808,   809,
   810,   289,   383,   475,  1011,   667,   777,   475,   778,   785,
   384,   911,   912,   913,  1021,  1151,   387,   870,  1025,   871,
   475,   475,   877,   894,   926,   928,   435,   445,   929,   959,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,   935,   936,   937,   289,   289,  1174,   446,  1177,   941,
  1180,   938,   115,   116,   947,   475,  1183,   922,   469,   475,
   207,   923,   303,   447,   470,   208,   284,   285,   286,   287,
   288,   952,   475,   492,   924,   289,   951,  1059,  1201,   475,
  1203,   925,  1205,   944,   977,   945,   978,   962,  1023,   498,
  1024,   303,   508,   537,   966,   967,   547,   473,  1100,   969,
  1097,   944,  1098,  1108,  1023,  1196,  1153,  1197,   975,   976,
   540,  1214,   303,  1215,   541,   550,   619,   620,   985,   621,
   622,   633,   634,   514,   986,   638,   645,   930,  1014,   654,
  1099,   655,   517,   656,   658,   659,   660,   661,   303,   303,
   303,   303,   663,   664,   665,   671,   679,   680,   681,   682,
  1019,  1020,   687,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   286,   287,   288,  1152,   683,  1123,  1034,   289,
   280,   281,   282,   283,   284,   285,   286,   287,   288,  1042,
   713,   688,   714,   289,   715,   716,   728,   729,   963,   730,
   964,   732,   733,   743,   748,   750,   749,  1049,   755,   756,
   759,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   491,   287,   288,   758,   762,   764,  1062,   289,
  1064,   772,  1065,   993,   775,   996,  1067,   999,  1006,   781,
   782,  1071,   275,   276,   277,   278,   279,   280,   281,   282,
   283,   284,   285,   286,   287,   288,   788,   789,   790,   791,
   289,   792,   795,   796,   797,   798,   799,   514,   800,  1015,
  1088,   801,  1091,   802,  1094,   817,   517,   815,   822,   807,
   816,  1102,     5,     6,   824,   825,  1106,  1107,   826,   827,
   828,   832,   837,   838,   839,  1110,   841,   846,   857,   859,
   866,   872,   879,  1113,   865,   885,   886,   888,   887,   889,
   891,   892,   893,   525,    11,    12,   526,    14,    15,   527,
    17,   528,    19,   947,    20,   895,    22,    23,   914,    25,
    26,   932,   933,  1139,   934,  1185,  1143,   939,   953,  1147,
   949,   954,   956,  1150,   961,    37,   965,   968,   970,  1007,
  1155,   972,  1156,   973,   974,   979,    41,    42,    43,   980,
   981,  1206,   982,  1209,   983,   984,   994,   997,  1000,  1089,
  1002,  1092,  1003,  1095,    71,   296,  1004,  1022,  1005,  1219,
    75,    76,    77,  1026,  1027,    78,    79,    80,    81,    82,
    83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
    93,    94,    95,    96,    97,    98,  1028,  1041,  1030,   534,
  1031,  1032,  1033,  1045,   297,  1047,  1050,  1058,  1048,  1053,
     5,     6,  1060,  1055,  1063,  1072,  1073,  1078,  1057,  1061,
  1074,  1076,  1079,  1080,  1081,  1082,    28,    29,    30,    31,
    32,    33,  1105,  1109,  1111,  1125,  1112,  1124,  1128,    38,
    39,   525,    11,    12,   526,    14,    15,   527,    17,   528,
    19,  1133,    20,  1137,    22,    23,  1135,    25,    26,  1140,
  1141,  1144,  1145,  1148,  1157,   104,   105,   106,   107,  1164,
  1169,  1149,  1158,    37,  1160,  1175,  1178,  1181,  1162,  1170,
  1187,  1188,   112,   298,    41,    42,    43,   114,  1200,  1202,
  1173,  1204,   117,  1190,  1207,    71,   296,   120,  1199,  1210,
   489,    75,    76,    77,  1192,  1194,    78,    79,    80,    81,
    82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
    92,    93,    94,    95,    96,    97,    98,  1198,  1216,  1217,
  1218,  1220,  1222,  1223,   874,   297,  1130,   539,    59,   726,
    67,     5,     6,  1070,   955,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    28,    29,    30,
    31,    32,    33,     0,     0,     0,     0,     0,     0,     0,
    38,    39,   525,    11,    12,   526,    14,    15,   527,    17,
   528,    19,     0,    20,     0,    22,    23,     0,    25,    26,
     0,     0,     0,     0,     0,     0,   104,   105,   106,   107,
     0,     0,     0,     0,    37,     0,     0,     0,     0,     0,
     0,     0,     0,   112,   316,    41,    42,    43,   114,     0,
     0,     0,     0,   117,     0,    71,   296,     0,   120,     0,
   317,    75,    76,    77,     0,     0,    78,    79,    80,    81,
    82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
    92,    93,    94,    95,    96,    97,    98,     0,     0,     0,
     0,     0,     0,     0,     0,   297,     0,     0,   553,     0,
     0,     5,     6,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    28,    29,    30,
    31,    32,    33,     0,     0,     0,     0,     0,     0,     0,
    38,    39,   525,    11,    12,   526,    14,    15,   527,    17,
   528,    19,     0,    20,     0,    22,    23,     0,    25,    26,
     0,     0,     0,     0,     0,     0,   104,   105,   106,   107,
   835,     0,     0,     0,    37,     0,     0,     0,     0,     0,
     0,     0,     0,   112,   298,    41,    42,    43,   114,     0,
     0,     0,     0,   117,     0,    71,   296,     0,   120,     0,
   488,    75,    76,    77,     0,     0,    78,    79,    80,    81,
    82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
    92,    93,    94,    95,    96,    97,    98,     0,     0,     0,
     0,     0,     0,     0,     0,   297,     0,     0,   554,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    28,    29,    30,
    31,    32,    33,     0,     0,     0,     0,     0,     0,     0,
    38,    39,     0,     0,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   285,   286,   287,   288,     0,     0,
     0,     0,   289,     0,   836,     0,   104,   105,   106,   107,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   112,   298,     0,     0,     0,   114,     0,
     0,     0,     0,   117,     0,    71,   260,     0,   120,     0,
   668,    75,    76,    77,     0,     0,    78,    79,    80,    81,
    82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
    92,    93,    94,    95,    96,    97,    98,     0,     0,     0,
    71,   260,     5,     6,     0,     0,    75,    76,    77,     0,
     0,    78,    79,    80,    81,    82,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
    97,    98,     0,   525,    11,    12,   526,    14,    15,   527,
    17,   528,    19,     0,    20,     0,    22,    23,     0,    25,
    26,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    37,   104,   105,   106,   107,
     0,     0,     0,     0,     0,     0,    41,    42,    43,     0,
     0,     0,     0,   112,   113,     0,     0,     0,   114,     0,
     0,     0,     0,   117,     0,     0,   265,     0,   120,     0,
   266,   104,   105,   106,   107,   448,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   112,   113,
     0,     0,     0,   114,     0,     0,     0,     0,   117,   704,
     0,   646,     0,   120,     0,   647,    71,   260,     0,     0,
     0,     0,    75,    76,    77,     0,     0,    78,    79,    80,
    81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
    91,    92,    93,    94,    95,    96,    97,    98,     0,     0,
     0,    71,    72,    73,     0,    74,     0,    75,    76,    77,
     0,     0,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    96,    97,    98,     0,    99,   100,   101,   102,     0,     0,
   103,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   286,   287,   288,     0,     0,     0,     0,   289,
     0,     0,     0,     0,     0,     0,     0,   104,   105,   106,
   107,   464,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   349,   350,     0,     0,     0,   114,
     0,     0,     0,     0,   351,     0,     0,     0,     0,   120,
     0,   164,   104,   105,   106,   107,   108,   109,   110,   111,
   757,     0,     0,     0,     0,     0,     0,     0,     0,   112,
   113,     0,     0,     0,   114,   115,   116,     0,     0,   117,
     0,   118,     0,   119,   120,    71,   296,     0,     0,     0,
     0,    75,    76,    77,     0,     0,    78,    79,    80,    81,
    82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
    92,    93,    94,    95,    96,    97,    98,     0,     0,     0,
     0,     0,     0,     0,     0,   297,     0,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   289,     0,    28,    29,    30,
    31,    32,    33,     0,     0,     0,     0,     0,     0,     0,
    38,    39,     0,     0,     0,     0,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
   787,     0,     0,     0,   289,     0,   104,   105,   106,   107,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   112,   298,     0,     0,     0,   114,    71,
   260,   199,     0,   117,     0,    75,    76,    77,   120,     0,
    78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
    88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
    98,     0,    99,   100,   101,   102,    71,   260,   103,     0,
     0,     0,    75,    76,    77,     0,     0,    78,    79,    80,
    81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
    91,    92,    93,    94,    95,    96,    97,    98,     0,     0,
     0,     0,     0,     0,     0,     0,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     0,     0,     0,     0,   289,     0,     0,     0,     0,     0,
   104,   105,   106,   107,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   112,   113,     0,
     0,     0,   114,     0,     0,     0,     0,   117,     0,     0,
     0,     0,   120,     0,     0,     0,     0,   104,   105,   106,
   107,     5,     6,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   112,   113,     0,     0,     0,   114,
     0,     5,     6,     0,   117,     0,     0,     0,     0,   120,
     0,     0,   525,    11,    12,   526,    14,    15,   527,    17,
   528,    19,     0,    20,   823,    22,    23,     0,    25,    26,
     0,     0,   525,    11,    12,   526,    14,    15,   527,    17,
   528,    19,     0,    20,    37,    22,    23,   867,    25,    26,
     5,     6,     0,     0,     0,    41,    42,    43,     0,     0,
     0,     0,     0,     0,    37,     0,     0,     0,     0,     0,
     0,     0,  1029,     0,     0,    41,    42,    43,     0,     0,
     0,   525,    11,    12,   526,    14,    15,   527,    17,   528,
    19,  1043,    20,     0,    22,    23,     0,    25,    26,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   718,     0,
  1044,     0,     0,    37,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    41,    42,    43,     0,  1126,  1046,
   275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
   285,   286,   287,   288,     0,     0,     0,     0,   289,  1129,
     0,     0,     0,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,  1165,     0,
     0,   289,     0,     0,     0,     0,     0,  1167,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
   287,   288,   473,     0,     0,     0,   289,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,   473,     0,     0,     0,   289,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
   551,     0,     0,     0,   289,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,   639,
     0,     0,     0,   289,     0,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,   771,
     0,     0,     0,   289,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   285,   286,   287,   288,   834,     0,
     0,     0,   289,     0,     0,     0,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,   474,   287,   288,
     0,     0,     0,     0,   289,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   491,   287,   288,     0,
     0,     0,     0,   289,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   285,   286,   287,   288,     0,     0,
     0,     0,   289,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
     0,   289,     0,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
     0,   289,   275,   276,   277,   278,   279,   280,   281,   282,
   283,   284,   285,   286,   287,   288,     0,    -3,     1,     0,
   289,    -3,     0,     0,     0,     0,     0,     0,     0,    -3,
    -3,     0,   275,   276,   277,   278,   279,   280,   281,   282,
   283,   284,   285,   286,   287,   288,     0,     0,     0,     0,
   289,     0,    -3,     0,     0,     0,     0,    -3,    -3,   672,
    -3,    -3,    -3,    -3,    -3,    -3,    -3,    -3,    -3,    -3,
     0,    -3,    -3,    -3,    -3,    -3,    -3,    -3,     0,     0,
     0,    -3,    -3,    -3,    -3,    -3,    -3,    -3,     0,    -3,
    -3,    -3,    -3,     0,     0,    -3,    -3,     0,     4,     0,
     0,     0,    -3,    -3,    -3,    -3,     5,     6,    -3,     0,
    -3,     0,    -3,    -3,    -3,    -3,    -3,    -3,    -3,    -3,
    -3,     0,     0,     0,     0,     0,     0,     0,     0,     7,
     0,     0,     0,     0,     8,     9,     0,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,     0,    20,    21,
    22,    23,    24,    25,    26,     0,     0,     0,    27,    28,
    29,    30,    31,    32,    33,     0,    34,    35,    36,    37,
     5,     6,    38,    39,     0,     0,     0,     0,     0,    40,
    41,    42,    43,     0,     0,    44,     0,    45,     0,    46,
    47,    48,    49,    50,    51,    52,    53,    54,     0,     0,
     0,   525,    11,    12,   526,    14,    15,   527,    17,   528,
    19,     0,    20,     0,    22,    23,     0,    25,    26,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   286,   287,   288,    37,     0,     0,     0,   289,     0,     0,
     0,   441,     0,     0,    41,    42,    43,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   289,     0,     0,     0,     0,
     0,     0,   989,     0,   990,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     0,     0,     0,   289,     0,     0,     0,     0,     0,     0,
  1012,     0,  1013,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
     0,   289,     0,     0,     0,     0,     0,     0,  1085,     0,
  1086,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   286,   287,   288,     0,     0,     0,     0,   289,
     0,     0,     0,     0,     0,     0,     0,     0,   676,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   286,   287,   288,     0,     0,     0,     0,   289,     0,     0,
     0,     0,     0,     0,     0,     0,   677,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   289,     0,     0,     0,     0,
     0,     0,     0,     0,   725,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     0,     0,     0,   289,     0,     0,     0,     0,     0,     0,
     0,     0,   770,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
     0,   289,     0,     0,     0,     0,     0,     0,     0,     0,
   806,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   286,   287,   288,     0,     0,     0,     0,   289,
     0,     0,     0,     0,     0,     0,     0,     0,   987,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   286,   287,   288,     0,     0,     0,     0,   289,     0,     0,
     0,     0,     0,     0,     0,     0,  1009,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   289,     0,     0,     0,     0,
     0,     0,     0,     0,  1035,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     0,     0,     0,   289,     0,     0,     0,     0,     0,     0,
     0,     0,  1038,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
     0,   289,     0,     0,     0,     0,     0,     0,     0,     0,
  1039,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   286,   287,   288,     0,     0,     0,     0,   289,
     0,     0,     0,     0,     0,     0,     0,     0,  1040,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   286,   287,   288,     0,     0,     0,     0,   289,     0,     0,
     0,     0,     0,     0,     0,     0,  1101,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   289,     0,     0,     0,     0,
     0,     0,     0,     0,  1103,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     0,     0,     0,   289,     0,     0,     0,     0,     0,     0,
     0,     0,  1104,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
     0,   289,     0,     0,     0,     0,     0,     0,     0,     0,
  1114,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   286,   287,   288,     0,     0,     0,     0,   289,
     0,     0,     0,     0,     0,     0,     0,     0,  1117,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   286,   287,   288,     0,     0,     0,     0,   289,     0,     0,
     0,     0,     0,     0,     0,     0,  1120,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   289,     0,     0,     0,     0,
     0,     0,     0,     0,  1136,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     0,     0,     0,   289,     0,     0,     0,     0,     0,     0,
     0,     0,  1159,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
     0,   289,     0,     0,     0,     0,     0,     0,     0,     0,
  1161,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   286,   287,   288,     0,     0,     0,     0,   289,
     0,     0,     0,     0,     0,     0,     0,     0,  1163,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   286,   287,   288,     0,     0,     0,     0,   289,     0,     0,
     0,     0,     0,     0,     0,     0,  1172,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   289,     0,   437,     0,     0,
     0,     0,   510,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
     0,   289,     0,     0,     0,     0,     0,     0,   467,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   286,   287,   288,     0,     0,     0,     0,   289,     0,     0,
     0,     0,     0,     0,   510,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     0,     0,     0,   289,     0,     0,     0,     0,     0,     0,
   511,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   286,   287,   288,     0,     0,     0,     0,   289,
     0,     0,     0,     0,     0,     0,   548,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   289,     0,     0,     0,     0,
     0,     0,   595,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
     0,   289,     0,     0,     0,     0,     0,     0,   596,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   286,   287,   288,     0,     0,     0,     0,   289,     0,     0,
     0,     0,     0,     0,   609,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     0,     0,     0,   289,     0,     0,     0,     0,     0,     0,
   610,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   286,   287,   288,     0,     0,     0,     0,   289,
     0,     0,     0,     0,     0,     0,   611,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   289,     0,     0,     0,     0,
     0,     0,   612,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
     0,   289,     0,     0,     0,     0,     0,     0,   613,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   286,   287,   288,     0,     0,     0,     0,   289,     0,     0,
     0,     0,     0,     0,   614,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     0,     0,     0,   289,     0,     0,     0,     0,     0,     0,
   691,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   286,   287,   288,     0,     0,     0,     0,   289,
     0,     0,     0,     0,     0,     0,   692,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   289,     0,     0,     0,     0,
     0,     0,   693,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
     0,   289,     0,     0,     0,     0,     0,     0,   767,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   286,   287,   288,     0,     0,     0,     0,   289,     0,     0,
     0,     0,     0,     0,   804,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     0,     0,     0,   289,     0,     0,     0,     0,     0,     0,
   805,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   286,   287,   288,     0,     0,     0,     0,   289,
     0,     0,     0,     0,     0,     0,   833,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   289,     0,     0,     0,     0,
     0,     0,   942,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
     0,   289,     0,     0,     0,     0,     0,     0,   943,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   286,   287,   288,     0,     0,     0,     0,   289,     0,     0,
     0,     0,     0,     0,   960,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     0,     0,     0,   289,     0,     0,     0,     0,     0,     0,
   971,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   286,   287,   288,     0,     0,     0,     0,   289,
     0,     0,     0,     0,     0,     0,  1068,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   289,     0,     0,     0,     0,
     0,     0,  1069,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
     0,   289,     0,     0,     0,     0,     0,     0,  1077,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   286,   287,   288,     0,     0,     0,     0,   289,     0,     0,
     0,     0,     0,     0,  1083,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     0,     0,     0,   289,     0,     0,     0,     0,     0,     0,
  1132,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   286,   287,   288,     0,     0,     0,     0,   289,
     0,     0,     0,     0,     0,     0,  1134,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   289,     0,     0,     0,   556,
   275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
   285,   286,   287,   288,     0,     0,     0,     0,   289,     0,
     0,     0,   574,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
     0,   289,     0,     0,     0,   576,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     0,     0,     0,     0,   289,     0,     0,     0,   578,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   286,   287,   288,     0,     0,     0,     0,   289,     0,     0,
     0,   580,   275,   276,   277,   278,   279,   280,   281,   282,
   283,   284,   285,   286,   287,   288,     0,     0,     0,     0,
   289,     0,     0,     0,   582,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     0,     0,     0,   289,     0,     0,     0,   584,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
   287,   288,     0,     0,     0,     0,   289,     0,     0,     0,
   586,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   286,   287,   288,     0,     0,     0,     0,   289,
     0,     0,     0,   588,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   285,   286,   287,   288,     0,     0,
     0,     0,   289,     0,     0,     0,   590,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   289,     0,     0,     0,   592,
   275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
   285,   286,   287,   288,     0,     0,     0,     0,   289,     0,
     0,     0,   594,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
     0,   289,     0,     0,     0,   598,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     0,     0,     0,     0,   289,     0,     0,     0,   600,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   286,   287,   288,     0,     0,     0,     0,   289,     0,     0,
     0,   602,   275,   276,   277,   278,   279,   280,   281,   282,
   283,   284,   285,   286,   287,   288,     0,     0,     0,     0,
   289,     0,     0,     0,   604,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     0,     0,     0,   289,     0,     0,     0,   606,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
   287,   288,     0,     0,     0,     0,   289,     0,     0,     0,
   608,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   286,   287,   288,     0,     0,     0,     0,   289,
     0,     0,     0,   690,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   285,   286,   287,   288,     0,     0,
     0,     0,   289,     0,     0,     0,   706,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   289,     0,     0,     0,   708,
   275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
   285,   286,   287,   288,     0,     0,     0,     0,   289,     0,
     0,     0,   711,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
     0,   289,     0,     0,     0,   712,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     0,     0,     0,     0,   289,     0,     0,     0,   721,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   286,   287,   288,     0,     0,     0,     0,   289,     0,     0,
     0,   747,   275,   276,   277,   278,   279,   280,   281,   282,
   283,   284,   285,   286,   287,   288,     0,     0,     0,     0,
   289,     0,     0,     0,   849,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     0,     0,     0,   289,     0,     0,     0,   851,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
   287,   288,     0,     0,     0,     0,   289,     0,     0,     0,
   853,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   286,   287,   288,     0,     0,     0,     0,   289,
     0,     0,     0,   855,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   285,   286,   287,   288,     0,     0,
     0,     0,   289,     0,     0,     0,   856,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   289,     0,     0,     0,   957,
   275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
   285,   286,   287,   288,     0,     0,     0,     0,   289,     0,
   437,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   286,   287,   288,     0,     0,     0,     0,   289,
     0,   468,   275,   276,   277,   278,   279,   280,   281,   282,
   283,   284,   285,   286,   287,   288,     0,     0,     0,     0,
   289,     0,   477,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
     0,   289,     0,   478,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   285,   286,   287,   288,     0,     0,
     0,     0,   289,     0,   480,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     0,     0,     0,   289,     0,   482,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     0,     0,     0,     0,   289,     0,   483,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   289,     0,   486,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
   287,   288,     0,     0,     0,     0,   289,     0,   487,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   286,   287,   288,     0,     0,     0,     0,   289,     0,   494,
   275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
   285,   286,   287,   288,     0,     0,     0,     0,   289,     0,
   544,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   286,   287,   288,     0,     0,     0,     0,   289,
     0,   545,   275,   276,   277,   278,   279,   280,   281,   282,
   283,   284,   285,   286,   287,   288,     0,     0,     0,     0,
   289,     0,   546,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
     0,   289,     0,   552,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   285,   286,   287,   288,     0,     0,
     0,     0,   289,     0,   573,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     0,     0,     0,   289,     0,   575,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     0,     0,     0,     0,   289,     0,   577,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   289,     0,   579,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
   287,   288,     0,     0,     0,     0,   289,     0,   581,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   286,   287,   288,     0,     0,     0,     0,   289,     0,   583,
   275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
   285,   286,   287,   288,     0,     0,     0,     0,   289,     0,
   585,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   286,   287,   288,     0,     0,     0,     0,   289,
     0,   587,   275,   276,   277,   278,   279,   280,   281,   282,
   283,   284,   285,   286,   287,   288,     0,     0,     0,     0,
   289,     0,   589,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
     0,   289,     0,   591,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   285,   286,   287,   288,     0,     0,
     0,     0,   289,     0,   593,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     0,     0,     0,   289,     0,   597,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     0,     0,     0,     0,   289,     0,   599,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   289,     0,   601,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
   287,   288,     0,     0,     0,     0,   289,     0,   603,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   286,   287,   288,     0,     0,     0,     0,   289,     0,   605,
   275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
   285,   286,   287,   288,     0,     0,     0,     0,   289,     0,
   607,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   286,   287,   288,     0,     0,     0,     0,   289,
     0,   657,   275,   276,   277,   278,   279,   280,   281,   282,
   283,   284,   285,   286,   287,   288,     0,     0,     0,     0,
   289,     0,   662,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
     0,   289,     0,   670,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   285,   286,   287,   288,     0,     0,
     0,     0,   289,     0,   673,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     0,     0,     0,   289,     0,   674,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     0,     0,     0,     0,   289,     0,   678,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   289,     0,   848,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
   287,   288,     0,     0,     0,     0,   289,     0,   850,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   286,   287,   288,     0,     0,     0,     0,   289,     0,   852,
   275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
   285,   286,   287,   288,     0,     0,     0,     0,   289,     0,
   854,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,   286,   287,   288,     0,     0,     0,     0,   289,
     0,   860,   275,   276,   277,   278,   279,   280,   281,   282,
   283,   284,   285,   286,   287,   288,     0,     0,     0,     0,
   289,     0,   948,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,     0,     0,     0,
     0,   289,     0,   988,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   285,   286,   287,   288,     0,     0,
     0,     0,   289,     0,  1008,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     0,     0,     0,   289,     0,  1016,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     0,     0,     0,     0,   289,     0,  1131,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,     0,     0,     0,     0,   289,     0,  1171,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
   287,   288,     0,     0,     0,     0,   289
};

static const short yycheck[] = {    54,
   173,     2,     4,   176,     4,   145,   179,     4,     4,   343,
     2,   151,     6,     4,    49,     4,   268,     4,     5,     4,
     4,   636,     4,     4,     4,     5,    49,   200,     4,     4,
   203,     4,   131,     7,     4,     6,     5,   177,     4,   138,
     6,   181,   182,   132,     6,     6,   127,   128,   137,    36,
    37,    38,    39,     6,   135,    42,    36,    37,    38,    39,
     4,     6,    42,   701,     6,   131,     6,    36,    37,    38,
    39,    43,   138,    42,    46,     6,     7,    49,    74,    51,
    80,    81,    82,    83,    84,    56,    13,   121,   122,    80,
    81,    82,    83,    84,     6,    56,   131,   131,   131,    43,
   121,   122,    46,    71,   138,    49,    71,    91,    92,    72,
   112,   113,   114,    76,    77,   117,   118,   138,   132,   121,
     6,    91,    92,   137,   131,   127,    29,    30,   130,    32,
   132,   133,   134,   135,   108,   137,   138,   139,   140,   139,
   142,   143,   144,   758,   138,   147,   127,   128,   139,   138,
    49,   138,   133,   138,   135,   131,   138,   119,   138,   140,
   138,   163,   164,   138,   142,   138,   131,   133,   121,   122,
   138,   173,   131,   138,   119,   131,   139,   121,   122,   121,
   122,   354,   138,   821,   186,   187,   188,   131,   190,   441,
     7,   193,   194,    72,   138,    71,    71,    76,    77,   372,
   255,   256,   257,   258,   206,    43,   127,   128,    46,   121,
   122,   213,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
   232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
   242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
   252,   253,   254,     7,   131,   870,   131,   160,   131,   162,
   139,   132,   138,   138,   266,   168,   137,     7,     4,     5,
   173,   268,   131,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,   289,   266,    49,
   132,   108,   109,   110,   111,   137,   298,   131,   438,   439,
    36,    37,    38,    39,   132,   307,    42,   210,    72,   137,
   312,     6,    76,    77,   316,   317,   121,   122,   131,   321,
   133,   323,   324,   325,    53,   327,   328,   329,   330,   331,
   332,   333,    49,   138,   330,   331,   332,   333,   131,   317,
   133,   342,   343,   345,   346,   347,   348,   349,   350,   351,
   342,   343,    51,   355,   108,   109,   110,   111,   360,     7,
   121,   122,   364,   365,   121,   122,    61,   133,   108,   109,
   110,   111,   138,   127,   128,   139,   142,   138,   131,   381,
   137,   135,   384,   705,    62,    63,   383,   127,   128,    72,
   138,   127,   128,    76,    77,   138,   121,   122,    49,   135,
   540,   541,    72,   127,   128,    46,    76,    77,    49,   133,
    51,   135,   137,  1051,   139,  1030,   140,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,   121,   122,     4,   436,   130,     4,   340,   341,     6,
   131,   443,   133,     4,   441,    72,   442,   350,   138,    76,
    77,   131,  1090,   133,   131,  1093,   139,   131,  1096,   133,
   108,   109,   110,   111,   466,   467,   131,   469,   470,   139,
    72,   473,   474,   475,    76,    77,   131,    72,   133,   127,
   128,    76,    77,   331,   332,   333,   488,    72,   466,   491,
   492,    76,    77,   131,   131,   133,   498,   131,   750,   751,
   266,   556,    72,   121,   122,     6,    76,    77,   510,   511,
   488,     4,   139,  1151,     4,   655,   656,   519,   658,   137,
   660,   661,    72,   131,   664,   665,    76,    77,   131,     4,
   133,   131,   298,   133,   536,   131,  1174,   139,   131,  1177,
   133,   131,  1180,   133,   139,  1183,   548,   131,   550,   551,
   316,   317,    72,   131,   139,   133,    76,    77,   131,   556,
   133,     6,     7,  1201,   619,  1203,    72,  1205,   131,   139,
    76,    77,    72,   713,   714,   715,    76,    77,   131,     6,
   914,   121,   122,     6,   121,   122,   131,   642,   133,   139,
     6,     4,     5,   595,   596,     5,   131,   137,   133,   139,
   137,   131,   139,   133,   131,   131,   509,   609,   610,   611,
   612,   613,   614,   615,   131,   138,   618,    72,   131,   139,
   622,    76,    77,    36,    37,    38,    39,   629,   531,    42,
     4,     5,   131,   139,   807,   775,   131,   639,   133,   139,
   618,   781,   123,   124,   125,   647,   131,   138,   133,   130,
   790,   791,   792,   131,   138,   795,   796,   797,   798,   799,
   800,   801,    36,    37,    38,    39,   668,     6,    42,   647,
   992,   121,   122,   121,   122,   131,   816,   133,   131,   131,
   121,   122,   121,   122,   131,   121,   122,   137,   131,   137,
   668,     4,   694,   695,   696,   697,   137,   131,   137,   133,
   466,   137,   133,   138,   121,   122,   138,   133,   474,   475,
   138,   133,   121,   122,  1048,   133,   694,   695,   696,   697,
   137,   861,   488,   121,   122,   491,   728,   729,   137,     6,
   732,  1053,   131,  1055,   133,  1057,   121,   122,   135,   137,
   121,   122,   645,   137,    94,   139,    65,    66,    67,    68,
   747,    70,   137,   137,   751,   139,   137,   759,   138,    78,
    79,   137,   133,   139,   135,   767,     6,     6,   137,   771,
   139,     6,   133,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,   789,   691,   692,
   693,   130,     4,   137,   934,   139,    49,   137,    51,   139,
   138,   803,   804,   805,   944,  1127,     6,   137,   948,   139,
   137,   137,   139,   139,   816,   817,     5,   135,   820,   874,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,   833,   834,   835,   130,   130,  1158,     7,  1160,   841,
  1162,   838,   127,   128,   846,   137,  1168,   139,   133,   137,
   135,   139,   618,   133,   138,   140,   121,   122,   123,   124,
   125,   863,   137,     7,   139,   130,   862,  1007,  1190,   137,
  1192,   139,  1194,   137,     4,   139,     6,   879,   137,     7,
   139,   647,   132,     6,   886,   887,    91,     8,  1061,   891,
   137,   137,   139,   139,   137,   137,   139,   139,   900,   901,
     7,   137,   668,   139,     7,   138,   137,   132,   910,   132,
   137,     6,     4,   914,   910,   134,     7,   820,     8,    94,
  1060,     7,   914,     7,     7,    94,     7,     7,   694,   695,
   696,   697,    94,     7,     7,     7,   132,   132,   132,   132,
   942,   943,   139,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,  1128,   135,  1097,   960,   130,
   117,   118,   119,   120,   121,   122,   123,   124,   125,   971,
     7,   139,     7,   130,     7,   135,   131,   131,   881,   138,
   883,   131,     6,     4,     6,   134,     6,   989,     6,     6,
   133,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,     7,     6,   119,  1010,   130,
  1012,    49,  1014,   916,     7,   918,  1018,   920,   139,     7,
    51,  1023,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,     7,   138,     7,     7,
   130,     7,     7,     7,     7,     7,     7,  1048,     7,   139,
  1052,     7,  1054,     4,  1056,   131,  1048,     6,     6,   138,
   138,  1063,    12,    13,     6,     6,  1068,  1069,     6,     6,
     6,     4,     6,     4,     6,  1077,   131,   138,   132,   132,
     7,     6,   138,  1085,   135,     6,   138,     6,   138,     6,
   138,     6,     6,    43,    44,    45,    46,    47,    48,    49,
    50,    51,    52,  1105,    54,     5,    56,    57,   138,    59,
    60,     6,     6,  1115,    90,  1170,  1118,     6,     6,  1121,
   135,     4,     6,  1125,   134,    75,     6,     6,     5,   137,
  1132,     6,  1134,     6,     6,     6,    86,    87,    88,     6,
     6,  1196,     6,  1198,     6,     6,     6,     6,     6,  1052,
     6,  1054,     6,  1056,     3,     4,     6,   138,     6,  1214,
     9,    10,    11,     4,     6,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
    29,    30,    31,    32,    33,    34,     6,     5,     7,   139,
     6,   135,     6,     6,    43,     6,   139,     6,   138,   138,
    12,    13,     7,   138,    89,     6,     6,     6,   138,   138,
   132,    92,     6,     6,     6,     6,    65,    66,    67,    68,
    69,    70,   138,     6,     5,    61,   139,     6,   138,    78,
    79,    43,    44,    45,    46,    47,    48,    49,    50,    51,
    52,     6,    54,     6,    56,    57,   137,    59,    60,     6,
     6,     6,     6,     6,     5,   104,   105,   106,   107,     6,
     6,   139,   138,    75,   138,     6,     6,     6,   138,   138,
     6,     5,   121,   122,    86,    87,    88,   126,     6,     6,
   137,     6,   131,   138,     6,     3,     4,   136,   139,     6,
   139,     9,    10,    11,   138,   138,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    32,    33,    34,   138,     6,     6,
     6,     6,     0,     0,   766,    43,  1105,   139,     2,   559,
     2,    12,    13,  1022,   866,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    66,    67,
    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    78,    79,    43,    44,    45,    46,    47,    48,    49,    50,
    51,    52,    -1,    54,    -1,    56,    57,    -1,    59,    60,
    -1,    -1,    -1,    -1,    -1,    -1,   104,   105,   106,   107,
    -1,    -1,    -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   121,   122,    86,    87,    88,   126,    -1,
    -1,    -1,    -1,   131,    -1,     3,     4,    -1,   136,    -1,
   138,     9,    10,    11,    -1,    -1,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    32,    33,    34,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    43,    -1,    -1,   139,    -1,
    -1,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    66,    67,
    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    78,    79,    43,    44,    45,    46,    47,    48,    49,    50,
    51,    52,    -1,    54,    -1,    56,    57,    -1,    59,    60,
    -1,    -1,    -1,    -1,    -1,    -1,   104,   105,   106,   107,
     8,    -1,    -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   121,   122,    86,    87,    88,   126,    -1,
    -1,    -1,    -1,   131,    -1,     3,     4,    -1,   136,    -1,
   138,     9,    10,    11,    -1,    -1,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    32,    33,    34,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    43,    -1,    -1,   139,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    66,    67,
    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    78,    79,    -1,    -1,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,   132,    -1,   104,   105,   106,   107,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   121,   122,    -1,    -1,    -1,   126,    -1,
    -1,    -1,    -1,   131,    -1,     3,     4,    -1,   136,    -1,
   138,     9,    10,    11,    -1,    -1,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    32,    33,    34,    -1,    -1,    -1,
     3,     4,    12,    13,    -1,    -1,     9,    10,    11,    -1,
    -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
    33,    34,    -1,    43,    44,    45,    46,    47,    48,    49,
    50,    51,    52,    -1,    54,    -1,    56,    57,    -1,    59,
    60,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    75,   104,   105,   106,   107,
    -1,    -1,    -1,    -1,    -1,    -1,    86,    87,    88,    -1,
    -1,    -1,    -1,   121,   122,    -1,    -1,    -1,   126,    -1,
    -1,    -1,    -1,   131,    -1,    -1,   134,    -1,   136,    -1,
   138,   104,   105,   106,   107,     6,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   121,   122,
    -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,   131,   139,
    -1,   134,    -1,   136,    -1,   138,     3,     4,    -1,    -1,
    -1,    -1,     9,    10,    11,    -1,    -1,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    -1,    -1,
    -1,     3,     4,     5,    -1,     7,    -1,     9,    10,    11,
    -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
    32,    33,    34,    -1,    36,    37,    38,    39,    -1,    -1,
    42,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,   105,   106,
   107,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   121,   122,    -1,    -1,    -1,   126,
    -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,    -1,   136,
    -1,   138,   104,   105,   106,   107,   108,   109,   110,   111,
     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   121,
   122,    -1,    -1,    -1,   126,   127,   128,    -1,    -1,   131,
    -1,   133,    -1,   135,   136,     3,     4,    -1,    -1,    -1,
    -1,     9,    10,    11,    -1,    -1,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    32,    33,    34,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    43,    -1,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,    65,    66,    67,
    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    78,    79,    -1,    -1,    -1,    -1,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     6,    -1,    -1,    -1,   130,    -1,   104,   105,   106,   107,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   121,   122,    -1,    -1,    -1,   126,     3,
     4,     5,    -1,   131,    -1,     9,    10,    11,   136,    -1,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
    34,    -1,    36,    37,    38,    39,     3,     4,    42,    -1,
    -1,    -1,     9,    10,    11,    -1,    -1,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,
   104,   105,   106,   107,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   121,   122,    -1,
    -1,    -1,   126,    -1,    -1,    -1,    -1,   131,    -1,    -1,
    -1,    -1,   136,    -1,    -1,    -1,    -1,   104,   105,   106,
   107,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   121,   122,    -1,    -1,    -1,   126,
    -1,    12,    13,    -1,   131,    -1,    -1,    -1,    -1,   136,
    -1,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
    51,    52,    -1,    54,     6,    56,    57,    -1,    59,    60,
    -1,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
    51,    52,    -1,    54,    75,    56,    57,     6,    59,    60,
    12,    13,    -1,    -1,    -1,    86,    87,    88,    -1,    -1,
    -1,    -1,    -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,     6,    -1,    -1,    86,    87,    88,    -1,    -1,
    -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
    52,     6,    54,    -1,    56,    57,    -1,    59,    60,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,
     6,    -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    86,    87,    88,    -1,   139,     6,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,     6,
    -1,    -1,    -1,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,     6,    -1,
    -1,   130,    -1,    -1,    -1,    -1,    -1,   139,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,     8,    -1,    -1,    -1,   130,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,     8,    -1,    -1,    -1,   130,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     8,    -1,    -1,    -1,   130,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,     8,
    -1,    -1,    -1,   130,    -1,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,     8,
    -1,    -1,    -1,   130,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,     8,    -1,
    -1,    -1,   130,    -1,    -1,    -1,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,     0,     1,    -1,
   130,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    12,
    13,    -1,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,    35,    -1,    -1,    -1,    -1,    40,    41,   139,
    43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
    -1,    54,    55,    56,    57,    58,    59,    60,    -1,    -1,
    -1,    64,    65,    66,    67,    68,    69,    70,    -1,    72,
    73,    74,    75,    -1,    -1,    78,    79,    -1,     4,    -1,
    -1,    -1,    85,    86,    87,    88,    12,    13,    91,    -1,
    93,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
    -1,    -1,    -1,    -1,    40,    41,    -1,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    -1,    54,    55,
    56,    57,    58,    59,    60,    -1,    -1,    -1,    64,    65,
    66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
    12,    13,    78,    79,    -1,    -1,    -1,    -1,    -1,    85,
    86,    87,    88,    -1,    -1,    91,    -1,    93,    -1,    95,
    96,    97,    98,    99,   100,   101,   102,   103,    -1,    -1,
    -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
    52,    -1,    54,    -1,    56,    57,    -1,    59,    60,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    75,    -1,    -1,    -1,   130,    -1,    -1,
    -1,   134,    -1,    -1,    86,    87,    88,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,
    -1,    -1,   137,    -1,   139,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,
   137,    -1,   139,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,    -1,
   139,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,   139,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   139,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,   139,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
   139,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,   139,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   139,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,   139,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
   139,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,   139,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   139,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,   139,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
   139,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,   139,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   139,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,   139,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
   139,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,   139,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,   132,    -1,    -1,
    -1,    -1,   137,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,    -1,    -1,    -1,   137,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,
   137,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,    -1,    -1,    -1,   137,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,
    -1,    -1,   137,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,    -1,    -1,    -1,   137,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,
   137,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,    -1,    -1,    -1,   137,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,
    -1,    -1,   137,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,    -1,    -1,    -1,   137,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,
   137,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,    -1,    -1,    -1,   137,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,
    -1,    -1,   137,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,    -1,    -1,    -1,   137,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,
   137,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,    -1,    -1,    -1,   137,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,
    -1,    -1,   137,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,    -1,    -1,    -1,   137,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,
   137,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,    -1,    -1,    -1,   137,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,
    -1,    -1,   137,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,    -1,    -1,    -1,   137,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,
   137,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,    -1,    -1,    -1,   137,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
    -1,    -1,   134,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,   134,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,   134,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,    -1,    -1,   134,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
   134,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,    -1,    -1,   134,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
    -1,    -1,   134,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,   134,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,   134,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,    -1,    -1,   134,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
   134,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,    -1,    -1,   134,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
    -1,    -1,   134,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,   134,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,   134,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,    -1,    -1,   134,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
   134,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,    -1,    -1,   134,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
   132,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,   132,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,   132,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,   132,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,   132,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,   132,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,   132,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,   132,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,   132,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,   132,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
   132,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,   132,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,   132,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,   132,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,   132,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,   132,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,   132,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,   132,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,   132,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,   132,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
   132,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,   132,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,   132,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,   132,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,   132,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,   132,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,   132,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,   132,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,   132,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,   132,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
   132,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,   132,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,   132,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,   132,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,   132,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,   132,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,   132,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,   132,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,   132,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,   132,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
   132,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,   132,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,   132,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,   132,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,   132,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,   132,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,   132,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,   132,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 2:
#line 145 "Gmsh.y"
{ yyerrok; return 1; ;
    break;}
case 5:
#line 156 "Gmsh.y"
{ return 1; ;
    break;}
case 6:
#line 157 "Gmsh.y"
{ return 1; ;
    break;}
case 7:
#line 158 "Gmsh.y"
{ return 1; ;
    break;}
case 8:
#line 159 "Gmsh.y"
{ return 1; ;
    break;}
case 9:
#line 160 "Gmsh.y"
{ List_Delete(yyvsp[0].l); return 1; ;
    break;}
case 10:
#line 161 "Gmsh.y"
{ List_Delete(yyvsp[0].l); return 1; ;
    break;}
case 11:
#line 162 "Gmsh.y"
{ return 1; ;
    break;}
case 12:
#line 163 "Gmsh.y"
{ return 1; ;
    break;}
case 13:
#line 164 "Gmsh.y"
{ return 1; ;
    break;}
case 14:
#line 165 "Gmsh.y"
{ List_Delete(yyvsp[0].l); return 1; ;
    break;}
case 15:
#line 166 "Gmsh.y"
{ return 1; ;
    break;}
case 16:
#line 167 "Gmsh.y"
{ return 1; ;
    break;}
case 17:
#line 168 "Gmsh.y"
{ return 1; ;
    break;}
case 18:
#line 169 "Gmsh.y"
{ return 1; ;
    break;}
case 19:
#line 170 "Gmsh.y"
{ return 1; ;
    break;}
case 20:
#line 175 "Gmsh.y"
{
      yyval.c = "w";
    ;
    break;}
case 21:
#line 179 "Gmsh.y"
{
      yyval.c = "a";
    ;
    break;}
case 22:
#line 186 "Gmsh.y"
{
      Msg(DIRECT, yyvsp[-2].c);
      Free(yyvsp[-2].c);
    ;
    break;}
case 23:
#line 191 "Gmsh.y"
{
      char tmpstring[1024];
      FixRelativePath(yyvsp[-1].c, tmpstring);
      FILE *fp = fopen(tmpstring, yyvsp[-2].c);
      if(!fp){
	yymsg(GERROR, "Unable to open file '%s'", tmpstring);
      }
      else{
	fprintf(fp, "%s\n", yyvsp[-4].c);
	fclose(fp);
      }
      Free(yyvsp[-4].c);
      Free(yyvsp[-1].c);
    ;
    break;}
case 24:
#line 206 "Gmsh.y"
{
      char tmpstring[1024];
      int i = PrintListOfDouble(yyvsp[-4].c, yyvsp[-2].l, tmpstring);
      if(i < 0) 
	yymsg(GERROR, "Too few arguments in Printf");
      else if(i > 0)
	yymsg(GERROR, "%d extra argument%s in Printf", i, (i>1)?"s":"");
      else
	Msg(DIRECT, tmpstring);
      Free(yyvsp[-4].c);
      List_Delete(yyvsp[-2].l);
    ;
    break;}
case 25:
#line 219 "Gmsh.y"
{
      char tmpstring[1024];
      int i = PrintListOfDouble(yyvsp[-6].c, yyvsp[-4].l, tmpstring);
      if(i < 0) 
	yymsg(GERROR, "Too few arguments in Printf");
      else if(i > 0)
	yymsg(GERROR, "%d extra argument%s in Printf", i, (i>1)?"s":"");
      else{
	char tmpstring2[1024];
	FixRelativePath(yyvsp[-1].c, tmpstring2);
	FILE *fp = fopen(tmpstring2, yyvsp[-2].c);
	if(!fp){
	  yymsg(GERROR, "Unable to open file '%s'", tmpstring2);
	}
	else{
	  fprintf(fp, "%s\n", tmpstring);
	  fclose(fp);
	}
      }
      Free(yyvsp[-6].c);
      Free(yyvsp[-1].c);
      List_Delete(yyvsp[-4].l);
    ;
    break;}
case 26:
#line 248 "Gmsh.y"
{ 
      if(!strcmp(yyvsp[-5].c, "View") && !CheckViewErrorFlags(View)){
	EndView(View, 0, yyname, yyvsp[-4].c);
      }
      Free(yyvsp[-5].c); Free(yyvsp[-4].c);
    ;
    break;}
case 27:
#line 255 "Gmsh.y"
{
      if(!strcmp(yyvsp[-7].c, "View") && !CheckViewErrorFlags(View)){
	EndView(View, 0, yyname, yyvsp[-6].c);
      }
      Free(yyvsp[-7].c); Free(yyvsp[-6].c); Free(yyvsp[-5].c);
    ;
    break;}
case 28:
#line 265 "Gmsh.y"
{
      View = BeginView(1); 
      for(int i = 0; i < VIEW_NB_ELEMENT_TYPES; i++){
	ViewErrorFlags[i] = 0;
      }
    ;
    break;}
case 35:
#line 281 "Gmsh.y"
{ ViewCoord[ViewCoordIdx] = yyvsp[0].d; ViewCoordIdx++; ;
    break;}
case 36:
#line 283 "Gmsh.y"
{ ViewCoord[ViewCoordIdx] = yyvsp[0].d; ViewCoordIdx++; ;
    break;}
case 37:
#line 288 "Gmsh.y"
{ if(ViewValueList) List_Add(ViewValueList, &yyvsp[0].d); ;
    break;}
case 38:
#line 290 "Gmsh.y"
{ if(ViewValueList) List_Add(ViewValueList, &yyvsp[0].d); ;
    break;}
case 39:
#line 295 "Gmsh.y"
{
      if(!strcmp(yyvsp[0].c, "SP")){
	ViewElementIdx = 0; ViewNumNodes = 1; ViewNumComp = 1;
	ViewValueList = View->SP; ViewNumList = &View->NbSP;
      }
      else if(!strcmp(yyvsp[0].c, "VP")){
	ViewElementIdx = 1; ViewNumNodes = 1; ViewNumComp = 3;
	ViewValueList = View->VP; ViewNumList = &View->NbVP;
      }
      else if(!strcmp(yyvsp[0].c, "TP")){
	ViewElementIdx = 2; ViewNumNodes = 1; ViewNumComp = 9;
	ViewValueList = View->TP; ViewNumList = &View->NbTP;
      }
      else if(!strcmp(yyvsp[0].c, "SL")){
	ViewElementIdx = 3; ViewNumNodes = 2; ViewNumComp = 1;
	ViewValueList = View->SL; ViewNumList = &View->NbSL;
      }
      else if(!strcmp(yyvsp[0].c, "VL")){
	ViewElementIdx = 4; ViewNumNodes = 2; ViewNumComp = 3;
	ViewValueList = View->VL; ViewNumList = &View->NbVL;
      }
      else if(!strcmp(yyvsp[0].c, "TL")){
	ViewElementIdx = 5; ViewNumNodes = 2; ViewNumComp = 9;
	ViewValueList = View->TL; ViewNumList = &View->NbTL;
      }
      else if(!strcmp(yyvsp[0].c, "ST")){
	ViewElementIdx = 6; ViewNumNodes = 3; ViewNumComp = 1;
	ViewValueList = View->ST; ViewNumList = &View->NbST;
      }
      else if(!strcmp(yyvsp[0].c, "VT")){
	ViewElementIdx = 7; ViewNumNodes = 3; ViewNumComp = 3;
	ViewValueList = View->VT; ViewNumList = &View->NbVT;
      }
      else if(!strcmp(yyvsp[0].c, "TT")){
	ViewElementIdx = 8; ViewNumNodes = 3; ViewNumComp = 9;
	ViewValueList = View->TT; ViewNumList = &View->NbTT;
      }
      else if(!strcmp(yyvsp[0].c, "SQ")){
	ViewElementIdx = 9; ViewNumNodes = 4; ViewNumComp = 1;
	ViewValueList = View->SQ; ViewNumList = &View->NbSQ;
      }
      else if(!strcmp(yyvsp[0].c, "VQ")){
	ViewElementIdx = 10; ViewNumNodes = 4; ViewNumComp = 3;
	ViewValueList = View->VQ; ViewNumList = &View->NbVQ;
      }
      else if(!strcmp(yyvsp[0].c, "TQ")){
	ViewElementIdx = 11; ViewNumNodes = 4; ViewNumComp = 9;
	ViewValueList = View->TQ; ViewNumList = &View->NbTQ;
      }
      else if(!strcmp(yyvsp[0].c, "SS")){
	ViewElementIdx = 12; ViewNumNodes = 4; ViewNumComp = 1;
	ViewValueList = View->SS; ViewNumList = &View->NbSS;
      }
      else if(!strcmp(yyvsp[0].c, "VS")){
	ViewElementIdx = 13; ViewNumNodes = 4; ViewNumComp = 3;
	ViewValueList = View->VS; ViewNumList = &View->NbVS;
      }
      else if(!strcmp(yyvsp[0].c, "TS")){
	ViewElementIdx = 14; ViewNumNodes = 4; ViewNumComp = 9;
	ViewValueList = View->TS; ViewNumList = &View->NbTS;
      }
      else if(!strcmp(yyvsp[0].c, "SH")){
	ViewElementIdx = 15; ViewNumNodes = 8; ViewNumComp = 1;
	ViewValueList = View->SH; ViewNumList = &View->NbSH;
      }
      else if(!strcmp(yyvsp[0].c, "VH")){
	ViewElementIdx = 16; ViewNumNodes = 8; ViewNumComp = 3;
	ViewValueList = View->VH; ViewNumList = &View->NbVH;
      }
      else if(!strcmp(yyvsp[0].c, "TH")){
	ViewElementIdx = 17; ViewNumNodes = 8; ViewNumComp = 9;
	ViewValueList = View->TH; ViewNumList = &View->NbTH;
      }
      else if(!strcmp(yyvsp[0].c, "SI")){
	ViewElementIdx = 18; ViewNumNodes = 6; ViewNumComp = 1;
	ViewValueList = View->SI; ViewNumList = &View->NbSI;
      }
      else if(!strcmp(yyvsp[0].c, "VI")){
	ViewElementIdx = 19; ViewNumNodes = 6; ViewNumComp = 3;
	ViewValueList = View->VI; ViewNumList = &View->NbVI;
      }
      else if(!strcmp(yyvsp[0].c, "TI")){
	ViewElementIdx = 20; ViewNumNodes = 6; ViewNumComp = 9;
	ViewValueList = View->TI; ViewNumList = &View->NbTI;
      }
      else if(!strcmp(yyvsp[0].c, "SY")){
	ViewElementIdx = 21; ViewNumNodes = 5; ViewNumComp = 1;
	ViewValueList = View->SY; ViewNumList = &View->NbSY;
      }
      else if(!strcmp(yyvsp[0].c, "VY")){
	ViewElementIdx = 22; ViewNumNodes = 5; ViewNumComp = 3;
	ViewValueList = View->VY; ViewNumList = &View->NbVY;
      }
      else if(!strcmp(yyvsp[0].c, "TY")){
	ViewElementIdx = 23; ViewNumNodes = 5; ViewNumComp = 9;
	ViewValueList = View->TY; ViewNumList = &View->NbTY;
      }
      else if(!strcmp(yyvsp[0].c, "SL2")){
	ViewElementIdx = 3; ViewNumNodes = 3; ViewNumComp = 1;
	ViewValueList = View->SL2; ViewNumList = &View->NbSL2;
      }
      else if(!strcmp(yyvsp[0].c, "VL2")){
	ViewElementIdx = 4; ViewNumNodes = 3; ViewNumComp = 3;
	ViewValueList = View->VL2; ViewNumList = &View->NbVL2;
      }
      else if(!strcmp(yyvsp[0].c, "TL2")){
	ViewElementIdx = 5; ViewNumNodes = 3; ViewNumComp = 9;
	ViewValueList = View->TL2; ViewNumList = &View->NbTL2;
      }
      else if(!strcmp(yyvsp[0].c, "ST2")){
	ViewElementIdx = 6; ViewNumNodes = 6; ViewNumComp = 1;
	ViewValueList = View->ST2; ViewNumList = &View->NbST2;
      }
      else if(!strcmp(yyvsp[0].c, "VT2")){
	ViewElementIdx = 7; ViewNumNodes = 6; ViewNumComp = 3;
	ViewValueList = View->VT2; ViewNumList = &View->NbVT2;
      }
      else if(!strcmp(yyvsp[0].c, "TT2")){
	ViewElementIdx = 8; ViewNumNodes = 6; ViewNumComp = 9;
	ViewValueList = View->TT2; ViewNumList = &View->NbTT2;
      }
      else if(!strcmp(yyvsp[0].c, "SQ2")){
	ViewElementIdx = 9; ViewNumNodes = 9; ViewNumComp = 1;
	ViewValueList = View->SQ2; ViewNumList = &View->NbSQ2;
      }
      else if(!strcmp(yyvsp[0].c, "VQ2")){
	ViewElementIdx = 10; ViewNumNodes = 9; ViewNumComp = 3;
	ViewValueList = View->VQ2; ViewNumList = &View->NbVQ2;
      }
      else if(!strcmp(yyvsp[0].c, "TQ2")){
	ViewElementIdx = 11; ViewNumNodes = 9; ViewNumComp = 9;
	ViewValueList = View->TQ2; ViewNumList = &View->NbTQ2;
      }
      else if(!strcmp(yyvsp[0].c, "SS2")){
	ViewElementIdx = 12; ViewNumNodes = 10; ViewNumComp = 1;
	ViewValueList = View->SS2; ViewNumList = &View->NbSS2;
      }
      else if(!strcmp(yyvsp[0].c, "VS2")){
	ViewElementIdx = 13; ViewNumNodes = 10; ViewNumComp = 3;
	ViewValueList = View->VS2; ViewNumList = &View->NbVS2;
      }
      else if(!strcmp(yyvsp[0].c, "TS2")){
	ViewElementIdx = 14; ViewNumNodes = 10; ViewNumComp = 9;
	ViewValueList = View->TS2; ViewNumList = &View->NbTS2;
      }
      else if(!strcmp(yyvsp[0].c, "SH2")){
	ViewElementIdx = 15; ViewNumNodes = 27; ViewNumComp = 1;
	ViewValueList = View->SH2; ViewNumList = &View->NbSH2;
      }
      else if(!strcmp(yyvsp[0].c, "VH2")){
	ViewElementIdx = 16; ViewNumNodes = 27; ViewNumComp = 3;
	ViewValueList = View->VH2; ViewNumList = &View->NbVH2;
      }
      else if(!strcmp(yyvsp[0].c, "TH2")){
	ViewElementIdx = 17; ViewNumNodes = 27; ViewNumComp = 9;
	ViewValueList = View->TH2; ViewNumList = &View->NbTH2;
      }
      else if(!strcmp(yyvsp[0].c, "SI2")){
	ViewElementIdx = 18; ViewNumNodes = 18; ViewNumComp = 1;
	ViewValueList = View->SI2; ViewNumList = &View->NbSI2;
      }
      else if(!strcmp(yyvsp[0].c, "VI2")){
	ViewElementIdx = 19; ViewNumNodes = 18; ViewNumComp = 3;
	ViewValueList = View->VI2; ViewNumList = &View->NbVI2;
      }
      else if(!strcmp(yyvsp[0].c, "TI2")){
	ViewElementIdx = 20; ViewNumNodes = 18; ViewNumComp = 9;
	ViewValueList = View->TI2; ViewNumList = &View->NbTI2;
      }
      else if(!strcmp(yyvsp[0].c, "SY2")){
	ViewElementIdx = 21; ViewNumNodes = 14; ViewNumComp = 1;
	ViewValueList = View->SY2; ViewNumList = &View->NbSY2;
      }
      else if(!strcmp(yyvsp[0].c, "VY2")){
	ViewElementIdx = 22; ViewNumNodes = 14; ViewNumComp = 3;
	ViewValueList = View->VY2; ViewNumList = &View->NbVY2;
      }
      else if(!strcmp(yyvsp[0].c, "TY2")){
	ViewElementIdx = 23; ViewNumNodes = 14; ViewNumComp = 9;
	ViewValueList = View->TY2; ViewNumList = &View->NbTY2;
      }
      else{
	yymsg(GERROR, "Unknown element type '%s'", yyvsp[0].c);	
	ViewElementIdx = -1; ViewNumNodes = 0; ViewNumComp = 0;
	ViewValueList = NULL; ViewNumList = NULL;
      }
      Free(yyvsp[0].c);
      ViewCoordIdx = 0;
    ;
    break;}
case 40:
#line 485 "Gmsh.y"
{
      if(ViewValueList){
	if(ViewCoordIdx != 3 * ViewNumNodes){
	  yymsg(GERROR, "Wrong number of node coordinates (%d != %d)", 
		ViewCoordIdx, 3 * ViewNumNodes);
	  double d = 0;
	  for(int i = 0; i < 3 * ViewNumNodes; i++)
	    List_Add(ViewValueList, &d);
	}
	else{
	  for(int i = 0; i < 3; i++)
	    for(int j = 0; j < ViewNumNodes; j++)
	      List_Add(ViewValueList, &ViewCoord[3*j+i]);
	}
	ViewNumListTmp = List_Nbr(ViewValueList);
      }
    ;
    break;}
case 41:
#line 503 "Gmsh.y"
{
      if(ViewValueList){  
	if((List_Nbr(ViewValueList) - ViewNumListTmp) % (ViewNumComp * ViewNumNodes)) 
	  ViewErrorFlags[ViewElementIdx]++;
	(*ViewNumList)++;
      }
    ;
    break;}
case 42:
#line 514 "Gmsh.y"
{ 
      for(int i = 0; i < (int)strlen(yyvsp[0].c)+1; i++) List_Add(View->T2C, &yyvsp[0].c[i]); 
      Free(yyvsp[0].c);
    ;
    break;}
case 43:
#line 519 "Gmsh.y"
{ 
      for(int i = 0; i < (int)strlen(yyvsp[0].c)+1; i++) List_Add(View->T2C, &yyvsp[0].c[i]); 
      Free(yyvsp[0].c);
    ;
    break;}
case 44:
#line 527 "Gmsh.y"
{ 
      List_Add(View->T2D, &yyvsp[-5].d); List_Add(View->T2D, &yyvsp[-3].d);
      List_Add(View->T2D, &yyvsp[-1].d); 
      double d = List_Nbr(View->T2C);
      List_Add(View->T2D, &d); 
    ;
    break;}
case 45:
#line 534 "Gmsh.y"
{
      View->NbT2++;
    ;
    break;}
case 46:
#line 541 "Gmsh.y"
{ 
      for(int i = 0; i < (int)strlen(yyvsp[0].c)+1; i++) List_Add(View->T3C, &yyvsp[0].c[i]); 
      Free(yyvsp[0].c);
    ;
    break;}
case 47:
#line 546 "Gmsh.y"
{ 
      for(int i = 0; i < (int)strlen(yyvsp[0].c)+1; i++) List_Add(View->T3C, &yyvsp[0].c[i]); 
      Free(yyvsp[0].c);
    ;
    break;}
case 48:
#line 554 "Gmsh.y"
{ 
      List_Add(View->T3D, &yyvsp[-7].d); List_Add(View->T3D, &yyvsp[-5].d);
      List_Add(View->T3D, &yyvsp[-3].d); List_Add(View->T3D, &yyvsp[-1].d); 
      double d = List_Nbr(View->T3C);
      List_Add(View->T3D, &d); 
    ;
    break;}
case 49:
#line 561 "Gmsh.y"
{
      View->NbT3++;
    ;
    break;}
case 50:
#line 569 "Gmsh.y"
{
      View->adaptive = new Adaptive_Post_View(View, yyvsp[-5].l, yyvsp[-2].l);
    ;
    break;}
case 51:
#line 576 "Gmsh.y"
{
      ViewValueList = View->Time;
    ;
    break;}
case 52:
#line 580 "Gmsh.y"
{
    ;
    break;}
case 53:
#line 585 "Gmsh.y"
{
      (*View->Grains) [(int)yyvsp[-3].d] = yyvsp[-1].l;
    ;
    break;}
case 54:
#line 593 "Gmsh.y"
{ yyval.i = 0; ;
    break;}
case 55:
#line 594 "Gmsh.y"
{ yyval.i = 1; ;
    break;}
case 56:
#line 595 "Gmsh.y"
{ yyval.i = 2; ;
    break;}
case 57:
#line 596 "Gmsh.y"
{ yyval.i = 3; ;
    break;}
case 58:
#line 597 "Gmsh.y"
{ yyval.i = 4; ;
    break;}
case 59:
#line 601 "Gmsh.y"
{ yyval.i = 1; ;
    break;}
case 60:
#line 602 "Gmsh.y"
{ yyval.i = -1; ;
    break;}
case 61:
#line 610 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-3].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	if(!yyvsp[-2].i){
	  TheSymbol.val = List_Create(1, 1, sizeof(double));
	  List_Put(TheSymbol.val, 0, &yyvsp[-1].d);
	  Tree_Add(Symbol_T, &TheSymbol);
	}
	else{
	  yymsg(GERROR, "Unknown variable '%s'", yyvsp[-3].c);
	  Free(yyvsp[-3].c);
	}
      }
      else{
	double *pd = (double*)List_Pointer_Fast(pSymbol->val, 0); 
	switch(yyvsp[-2].i){
	case 0 : *pd = yyvsp[-1].d; break;
	case 1 : *pd += yyvsp[-1].d; break;
	case 2 : *pd -= yyvsp[-1].d; break;
	case 3 : *pd *= yyvsp[-1].d; break;
	case 4 : 
	  if(yyvsp[-1].d) *pd /= yyvsp[-1].d; 
	  else yymsg(GERROR, "Division by zero in '%s /= %g'", yyvsp[-3].c, yyvsp[-1].d);
	  break;
	}
	Free(yyvsp[-3].c);
      }
    ;
    break;}
case 62:
#line 641 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-6].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	if(!yyvsp[-2].i){
	  TheSymbol.val = List_Create(5, 5, sizeof(double));
	  List_Put(TheSymbol.val, (int)yyvsp[-4].d, &yyvsp[-1].d);
	  Tree_Add(Symbol_T, &TheSymbol);
	}
	else{
	  yymsg(GERROR, "Unknown variable '%s'", yyvsp[-6].c);
	  Free(yyvsp[-6].c);
	}
      }
      else{
	double *pd;
	if((pd = (double*)List_Pointer_Test(pSymbol->val, (int)yyvsp[-4].d))){
	  switch(yyvsp[-2].i){
	  case 0 : *pd = yyvsp[-1].d; break;
	  case 1 : *pd += yyvsp[-1].d; break;
	  case 2 : *pd -= yyvsp[-1].d; break;
	  case 3 : *pd *= yyvsp[-1].d; break;
	  case 4 : 
	    if(yyvsp[-1].d) *pd /= yyvsp[-1].d; 
	    else yymsg(GERROR, "Division by zero in '%s[%d] /= %g'", yyvsp[-6].c, (int)yyvsp[-4].d, yyvsp[-1].d);
	    break;
	  }
	}
	else{
	  if(!yyvsp[-2].i)
	    List_Put(pSymbol->val, (int)yyvsp[-4].d, &yyvsp[-1].d);
	  else
	    yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-6].c, (int)yyvsp[-4].d);
	}
	Free(yyvsp[-6].c);
      }
    ;
    break;}
case 63:
#line 680 "Gmsh.y"
{
      if(List_Nbr(yyvsp[-5].l) != List_Nbr(yyvsp[-1].l)){
	yymsg(GERROR, "Incompatible array dimensions in affectation");
	Free(yyvsp[-8].c);
      }
      else{
	Symbol TheSymbol;
	TheSymbol.Name = yyvsp[-8].c;
	Symbol *pSymbol;
	if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	  if(!yyvsp[-2].i){
	    TheSymbol.val = List_Create(5, 5, sizeof(double));
	    for(int i = 0; i < List_Nbr(yyvsp[-5].l); i++){
	      List_Put(TheSymbol.val, (int)(*(double*)List_Pointer(yyvsp[-5].l, i)),
		       (double*)List_Pointer(yyvsp[-1].l, i));
	    }
	    Tree_Add(Symbol_T, &TheSymbol);
	  }
	  else{
	    yymsg(GERROR, "Unknown variable '%s'", yyvsp[-8].c);
	    Free(yyvsp[-8].c);
	  }
	}
	else{
	  for(int i = 0; i < List_Nbr(yyvsp[-5].l); i++){
	    int j = (int)(*(double*)List_Pointer(yyvsp[-5].l, i));
	    double d = *(double*)List_Pointer(yyvsp[-1].l, i);
	    double *pd;
	    if((pd = (double*)List_Pointer_Test(pSymbol->val, j))){
	      switch(yyvsp[-2].i){
	      case 0 : *pd = d; break;
	      case 1 : *pd += d; break;
	      case 2 : *pd -= d; break;
	      case 3 : *pd *= d; break;
	      case 4 : 
		if(yyvsp[-1].l) *pd /= d; 
		else yymsg(GERROR, "Division by zero in '%s[%d] /= %g'", yyvsp[-8].c, j, d);
		break;
	      }
	    }
	    else{
	      if(!yyvsp[-2].i)
		List_Put(pSymbol->val, j, &d);
	      else
		yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-8].c, j);	  
	    }
	  }
	  Free(yyvsp[-8].c);
	}
      }
      List_Delete(yyvsp[-5].l);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 64:
#line 734 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-5].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	TheSymbol.val = List_Create(5, 5, sizeof(double));
	List_Copy(yyvsp[-1].l, TheSymbol.val);
	Tree_Add(Symbol_T, &TheSymbol);
      }
      else{
	List_Reset(pSymbol->val);
	List_Copy(yyvsp[-1].l, pSymbol->val);
	Free(yyvsp[-5].c);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 65:
#line 751 "Gmsh.y"
{
      // appends to the list
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-5].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	TheSymbol.val = List_Create(5, 5, sizeof(double));
	List_Copy(yyvsp[-1].l, TheSymbol.val);
	Tree_Add(Symbol_T, &TheSymbol);
      }
      else{
	for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++)
	  List_Add(pSymbol->val, List_Pointer(yyvsp[-1].l, i));
	Free(yyvsp[-5].c);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 66:
#line 769 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-2].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol)))
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-2].c); 
      else
	*(double*)List_Pointer_Fast(pSymbol->val, 0) += yyvsp[-1].i;
      Free(yyvsp[-2].c);
    ;
    break;}
case 67:
#line 780 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-5].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol)))
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-5].c); 
      else{
	double *pd;
	if((pd = (double*)List_Pointer_Test(pSymbol->val, (int)yyvsp[-3].d)))
	  *pd += yyvsp[-1].i;
	else
	  yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-5].c, (int)yyvsp[-3].d);
      }
      Free(yyvsp[-5].c);
    ;
    break;}
case 68:
#line 797 "Gmsh.y"
{ 
      Msg(WARNING, "Named string expressions not implemented yet");
    ;
    break;}
case 69:
#line 804 "Gmsh.y"
{ 
      char* (*pStrOpt)(int num, int action, char *value);
      StringXString *pStrCat;
      if(!(pStrCat = Get_StringOptionCategory(yyvsp[-5].c)))
	yymsg(GERROR, "Unknown string option class '%s'", yyvsp[-5].c);
      else{
	if(!(pStrOpt = (char *(*) (int, int, char *))Get_StringOption(yyvsp[-3].c, pStrCat)))
	  yymsg(GERROR, "Unknown string option '%s.%s'", yyvsp[-5].c, yyvsp[-3].c);
	else
	  pStrOpt(0, GMSH_SET|GMSH_GUI, yyvsp[-1].c);
      }
      Free(yyvsp[-5].c); Free(yyvsp[-3].c); //FIXME: somtimes leak $5
    ;
    break;}
case 70:
#line 818 "Gmsh.y"
{ 
      char* (*pStrOpt)(int num, int action, char *value);
      StringXString *pStrCat;
      if(!(pStrCat = Get_StringOptionCategory(yyvsp[-8].c)))
	yymsg(GERROR, "Unknown string option class '%s'", yyvsp[-8].c);
      else{
	if(!(pStrOpt = (char *(*) (int, int, char *))Get_StringOption(yyvsp[-3].c, pStrCat)))
	  yymsg(GERROR, "Unknown string option '%s[%d].%s'", yyvsp[-8].c, (int)yyvsp[-6].d, yyvsp[-3].c);
	else
	  pStrOpt((int)yyvsp[-6].d, GMSH_SET|GMSH_GUI, yyvsp[-1].c);
      }
      Free(yyvsp[-8].c); Free(yyvsp[-3].c); //FIXME: somtimes leak $8
    ;
    break;}
case 71:
#line 835 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-5].c)))
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-5].c);
      else{
	if(!(pNumOpt = (double (*) (int, int, double))Get_NumberOption(yyvsp[-3].c, pNumCat)))
	  yymsg(GERROR, "Unknown numeric option '%s.%s'", yyvsp[-5].c, yyvsp[-3].c);
	else{
	  double d = 0;
	  switch(yyvsp[-2].i){
	  case 0 : d = yyvsp[-1].d; break;
	  case 1 : d = pNumOpt(0, GMSH_GET, 0) + yyvsp[-1].d; break;
	  case 2 : d = pNumOpt(0, GMSH_GET, 0) - yyvsp[-1].d; break;
	  case 3 : d = pNumOpt(0, GMSH_GET, 0) * yyvsp[-1].d; break;
	  case 4 : 
	    if(yyvsp[-1].d) d = pNumOpt(0, GMSH_GET, 0) / yyvsp[-1].d; 
	    else yymsg(GERROR, "Division by zero in '%s.%s /= %g'", yyvsp[-5].c, yyvsp[-3].c, yyvsp[-1].d);
	    break;
	  }
	  pNumOpt(0, GMSH_SET|GMSH_GUI, d);
	}
      }
      Free(yyvsp[-5].c); Free(yyvsp[-3].c);
    ;
    break;}
case 72:
#line 861 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-8].c)))
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-8].c);
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[-3].c, pNumCat)))
	  yymsg(GERROR, "Unknown numeric option '%s[%d].%s'", yyvsp[-8].c, (int)yyvsp[-6].d, yyvsp[-3].c);
	else{
	  double d = 0;
	  switch(yyvsp[-2].i){
	  case 0 : d = yyvsp[-1].d; break;
	  case 1 : d = pNumOpt((int)yyvsp[-6].d, GMSH_GET, 0) + yyvsp[-1].d; break;
	  case 2 : d = pNumOpt((int)yyvsp[-6].d, GMSH_GET, 0) - yyvsp[-1].d; break;
	  case 3 : d = pNumOpt((int)yyvsp[-6].d, GMSH_GET, 0) * yyvsp[-1].d; break;
	  case 4 : 
	    if(yyvsp[-1].d) d = pNumOpt((int)yyvsp[-6].d, GMSH_GET, 0) / yyvsp[-1].d;
	    else yymsg(GERROR, "Division by zero in '%s[%d].%s /= %g'", 
		       yyvsp[-8].c, (int)yyvsp[-6].d, yyvsp[-3].c, yyvsp[-1].d);
	    break;
	  }
	  pNumOpt((int)yyvsp[-6].d, GMSH_SET|GMSH_GUI, d);
	}
      }
      Free(yyvsp[-8].c); Free(yyvsp[-3].c);
    ;
    break;}
case 73:
#line 888 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-4].c)))
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-4].c);
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[-2].c, pNumCat)))
	  yymsg(GERROR, "Unknown numeric option '%s.%s'", yyvsp[-4].c, yyvsp[-2].c);
	else
	  pNumOpt(0, GMSH_SET|GMSH_GUI, pNumOpt(0, GMSH_GET, 0)+yyvsp[-1].i);
      }
      Free(yyvsp[-4].c); Free(yyvsp[-2].c);
    ;
    break;}
case 74:
#line 902 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-7].c)))
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-7].c);
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[-2].c, pNumCat)))
	  yymsg(GERROR, "Unknown numeric option '%s[%d].%s'", yyvsp[-7].c, (int)yyvsp[-5].d, yyvsp[-2].c);
	else
	  pNumOpt((int)yyvsp[-5].d, GMSH_SET|GMSH_GUI, pNumOpt((int)yyvsp[-5].d, GMSH_GET, 0)+yyvsp[-1].i);
      }
      Free(yyvsp[-7].c); Free(yyvsp[-2].c);
    ;
    break;}
case 75:
#line 919 "Gmsh.y"
{
      unsigned int (*pColOpt)(int num, int action, unsigned int value);
      StringXColor *pColCat;
      if(!(pColCat = Get_ColorOptionCategory(yyvsp[-7].c)))
	yymsg(GERROR, "Unknown color option class '%s'", yyvsp[-7].c);
      else{
	if(!(pColOpt =  (unsigned int (*) (int, int, unsigned int))Get_ColorOption(yyvsp[-3].c, pColCat)))
	  yymsg(GERROR, "Unknown color option '%s.Color.%s'", yyvsp[-7].c, yyvsp[-3].c);
	else
	  pColOpt(0, GMSH_SET|GMSH_GUI, yyvsp[-1].u);
      }
      Free(yyvsp[-7].c); Free(yyvsp[-3].c);
    ;
    break;}
case 76:
#line 933 "Gmsh.y"
{
      unsigned int (*pColOpt)(int num, int action, unsigned int value);
      StringXColor *pColCat;
      if(!(pColCat = Get_ColorOptionCategory(yyvsp[-10].c)))
	yymsg(GERROR, "Unknown color option class '%s'", yyvsp[-10].c);
      else{
	if(!(pColOpt =  (unsigned int (*) (int, int, unsigned int))Get_ColorOption(yyvsp[-3].c, pColCat)))
	  yymsg(GERROR, "Unknown color option '%s[%d].Color.%s'", yyvsp[-10].c, (int)yyvsp[-8].d, yyvsp[-3].c);
	else
	  pColOpt((int)yyvsp[-8].d, GMSH_SET|GMSH_GUI, yyvsp[-1].u);
      }
      Free(yyvsp[-10].c); Free(yyvsp[-3].c);
    ;
    break;}
case 77:
#line 950 "Gmsh.y"
{
      GmshColorTable *ct = Get_ColorTable(0);
      if(!ct)
	yymsg(GERROR, "View[%d] does not exist", 0);
      else{
	ct->size = List_Nbr(yyvsp[-1].l);
	if(ct->size > COLORTABLE_NBMAX_COLOR)
	  yymsg(GERROR, "Too many (%d>%d) colors in View[%d].ColorTable", 
		ct->size, COLORTABLE_NBMAX_COLOR, 0);
	else
	  for(int i = 0; i < ct->size; i++) List_Read(yyvsp[-1].l, i, &ct->table[i]);
	if(ct->size == 1){
	  ct->size = 2;
	  ct->table[1] = ct->table[0];
	}
      }
      Free(yyvsp[-5].c);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 78:
#line 970 "Gmsh.y"
{
      GmshColorTable *ct = Get_ColorTable((int)yyvsp[-6].d);
      if(!ct)
	yymsg(GERROR, "View[%d] does not exist", (int)yyvsp[-6].d);
      else{
	ct->size = List_Nbr(yyvsp[-1].l);
	if(ct->size > COLORTABLE_NBMAX_COLOR)
	  yymsg(GERROR, "Too many (%d>%d) colors in View[%d].ColorTable", 
		   ct->size, COLORTABLE_NBMAX_COLOR, (int)yyvsp[-6].d);
	else
	  for(int i = 0; i < ct->size; i++) List_Read(yyvsp[-1].l, i, &ct->table[i]);
	if(ct->size == 1){
	  ct->size = 2;
	  ct->table[1] = ct->table[0];
	}
      }
      Free(yyvsp[-8].c);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 79:
#line 993 "Gmsh.y"
{
      try {
	GMSH_PluginManager::instance()->setPluginOption(yyvsp[-6].c, yyvsp[-3].c, yyvsp[-1].d); 
      }
      catch (...) {
	yymsg(GERROR, "Unknown option '%s' or plugin '%s'", yyvsp[-3].c, yyvsp[-6].c);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-3].c);
    ;
    break;}
case 80:
#line 1003 "Gmsh.y"
{
      try {
	GMSH_PluginManager::instance()->setPluginOption(yyvsp[-6].c, yyvsp[-3].c, yyvsp[-1].c); 
      }
      catch (...) {
	yymsg(GERROR, "Unknown option '%s' or plugin '%s'", yyvsp[-3].c, yyvsp[-6].c);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-3].c); // FIXME: sometimes leak $8
    ;
    break;}
case 81:
#line 1018 "Gmsh.y"
{ 
      yyval.i = (int)yyvsp[0].d; 
    ;
    break;}
case 82:
#line 1022 "Gmsh.y"
{ 
      yyval.i = GMODEL->setPhysicalName(std::string(yyvsp[0].c), ++THEM->MaxPhysicalNum);
      Free(yyvsp[0].c);
    ;
    break;}
case 83:
#line 1034 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindPoint(num)){
	yymsg(GERROR, "Point %d already exists", num);
      }
      else{
	double x = CTX.geom.scaling_factor * yyvsp[-1].v[0];
	double y = CTX.geom.scaling_factor * yyvsp[-1].v[1];
	double z = CTX.geom.scaling_factor * yyvsp[-1].v[2];
	double lc = CTX.geom.scaling_factor * yyvsp[-1].v[3];
	Vertex *v;
	if(!myGmshSurface)
	  v = Create_Vertex(num, x, y, z, lc, 1.0);
	else
	  v = Create_Vertex(num, x, y, myGmshSurface, lc);
	Tree_Add(THEM->Points, &v);
	AddToTemporaryBoundingBox(v->Pos.X, v->Pos.Y, v->Pos.Z);
      }
      yyval.s.Type = MSH_POINT;
      yyval.s.Num = num;
    ;
    break;}
case 84:
#line 1056 "Gmsh.y"
{
      int num = (int)yyvsp[-4].i;
      if(FindPhysicalGroup(num, MSH_PHYSICAL_POINT)){
	yymsg(GERROR, "Physical point %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	PhysicalGroup *p = Create_PhysicalGroup(num, MSH_PHYSICAL_POINT, temp);
	List_Delete(temp);
	List_Add(THEM->PhysicalGroups, &p);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_PHYSICAL_POINT;
      yyval.s.Num = num;
    ;
    break;}
case 85:
#line 1072 "Gmsh.y"
{
      double pars[] = { CTX.lc/10, CTX.lc/100., CTX.lc/20, 10, 3 };
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	if(i > 4) 
	  yymsg(GERROR, "Too many paramaters for attractor line (max = 5)");	  
	else
	  List_Read(yyvsp[-1].l, i, &pars[i]);
      }
      // treshold attractor: first parameter is the treshold, next two
      // are the in and out size fields, last is transition factor
      Attractor *att = tresholdAttractor::New(pars[0], pars[1], pars[2], pars[4]);
      for(int i = 0; i < List_Nbr(yyvsp[-3].l); i++){
	double d;
	List_Read(yyvsp[-3].l, i, &d);
	Vertex *v = FindPoint((int)d); 
	if(v)
	  att->addPoint(v->Pos.X, v->Pos.Y, v->Pos.Z);
	else{
	  GVertex *gv = GMODEL->vertexByTag((int)d);
	  if(gv) 
	    att->addPoint(gv->x(), gv->y(), gv->z());
	}
      }
      att->buildFastSearchStructures();
      // dummy values
      yyval.s.Type = 0;
      yyval.s.Num = 0;
    ;
    break;}
case 86:
#line 1101 "Gmsh.y"
{
      double pars[] = { CTX.lc/10, CTX.lc/100., CTX.lc/20, 10, 3 };
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	if(i > 4) 
	  yymsg(GERROR, "Too many paramaters for attractor line (max = 5)");	  
	else
	  List_Read(yyvsp[-1].l, i, &pars[i]);
      }
      // treshold attractor: first parameter is the treshold, next two
      // are the in and out size fields, last is transition factor
      Attractor *att = tresholdAttractor::New(pars[0], pars[1], pars[2], pars[4]);
      for(int i = 0; i < List_Nbr(yyvsp[-3].l); i++){
	double d;
	List_Read(yyvsp[-3].l, i, &d);
	Curve *c = FindCurve((int)d); 
	if(c){
	  buildListOfPoints(att, c, (int)pars[3]);
	}
	else{
	  GEdge *ge = GMODEL->edgeByTag((int)d);
	  if(ge){
	    buildListOfPoints(att, ge, (int)pars[3]);
	  }
	}
      }
      att->buildFastSearchStructures();
      // dummy values
      yyval.s.Type = 0;
      yyval.s.Num = 0;
    ;
    break;}
case 87:
#line 1132 "Gmsh.y"
{      
      for(int i = 0; i < List_Nbr(yyvsp[-3].l); i++){
	double d;
	List_Read(yyvsp[-3].l, i, &d);
	Vertex *v = FindPoint((int)d); 	 
	if(v)
	  v->lc = yyvsp[-1].d;
	else{
	  GVertex *gv = GMODEL->vertexByTag((int)d);
	  if(gv) 
	    gv->setPrescribedMeshSizeAtVertex(yyvsp[-1].d);
	}
      }
      List_Delete(yyvsp[-3].l);
      // dummy values
      yyval.s.Type = 0;
      yyval.s.Num = 0;
    ;
    break;}
case 88:
#line 1154 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindCurve(num)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	Curve *c = Create_Curve(num, MSH_SEGM_LINE, 1, temp, NULL,
				-1, -1, 0., 1.);
	Tree_Add(THEM->Curves, &c);
	CreateReversedCurve(c);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_LINE;
      yyval.s.Num = num;
    ;
    break;}
case 89:
#line 1172 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindCurve(num)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	Curve *c = Create_Curve(num, MSH_SEGM_SPLN, 3, temp, NULL,
				-1, -1, 0., 1.);
	Tree_Add(THEM->Curves, &c);
	CreateReversedCurve(c);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_SPLN;
      yyval.s.Num = num;
    ;
    break;}
case 90:
#line 1190 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindCurve(num)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	Curve *c = Create_Curve(num, MSH_SEGM_CIRC, 2, temp, NULL,
				-1, -1, 0., 1.);
	Tree_Add(THEM->Curves, &c);
	CreateReversedCurve(c);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_CIRC;
      yyval.s.Num = num;
    ;
    break;}
case 91:
#line 1208 "Gmsh.y"
{
      int num = (int)yyvsp[-6].d;
      if(FindCurve(num)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-3].l);
	Curve *c = Create_Curve(num, MSH_SEGM_CIRC, 2, temp, NULL,
				-1, -1, 0., 1.);
	c->Circle.n[0] = yyvsp[-1].v[0];
	c->Circle.n[1] = yyvsp[-1].v[1];
	c->Circle.n[2] = yyvsp[-1].v[2];
	End_Curve(c);
	Tree_Add(THEM->Curves, &c);
	Curve *rc = CreateReversedCurve(c);
	rc->Circle.n[0] = yyvsp[-1].v[0];
	rc->Circle.n[1] = yyvsp[-1].v[1];
	rc->Circle.n[2] = yyvsp[-1].v[2];
	End_Curve(rc);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-3].l);
      yyval.s.Type = MSH_SEGM_CIRC;
      yyval.s.Num = num;
    ;
    break;}
case 92:
#line 1234 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindCurve(num)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	Curve *c = Create_Curve(num, MSH_SEGM_ELLI, 2, temp, NULL,
				-1, -1, 0., 1.);
	Tree_Add(THEM->Curves, &c);
	CreateReversedCurve(c);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_ELLI;
      yyval.s.Num = num;
    ;
    break;}
case 93:
#line 1252 "Gmsh.y"
{
      int num = (int)yyvsp[-6].d;
      if(FindCurve(num)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-3].l);
	Curve *c = Create_Curve(num, MSH_SEGM_ELLI, 2, temp, NULL,
				-1, -1, 0., 1.);
	c->Circle.n[0] = yyvsp[-1].v[0];
	c->Circle.n[1] = yyvsp[-1].v[1];
	c->Circle.n[2] = yyvsp[-1].v[2];
	End_Curve(c);
	Tree_Add(THEM->Curves, &c);
	Curve *rc = CreateReversedCurve(c);
	rc->Circle.n[0] = yyvsp[-1].v[0];
	rc->Circle.n[1] = yyvsp[-1].v[1];
	rc->Circle.n[2] = yyvsp[-1].v[2];
	End_Curve(c);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-3].l);
      yyval.s.Type = MSH_SEGM_ELLI;
      yyval.s.Num = num;
    ;
    break;}
case 94:
#line 1279 "Gmsh.y"
{
      int num = (int)yyvsp[-14].d;
      if(FindCurve(num)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	Curve *c = Create_Curve(num, MSH_SEGM_PARAMETRIC, 2, NULL, NULL,
				-1, -1, yyvsp[-10].d, yyvsp[-8].d);
	strcpy(c->functu, yyvsp[-6].c);
	strcpy(c->functv, yyvsp[-4].c);
	strcpy(c->functw, yyvsp[-2].c);
	Tree_Add(THEM->Curves, &c);
	CreateReversedCurve(c);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-4].c); Free(yyvsp[-2].c);
      yyval.s.Type = MSH_SEGM_PARAMETRIC;
      yyval.s.Num = num;
    ;
    break;}
case 95:
#line 1298 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(List_Nbr(yyvsp[-1].l) < 4){
	yymsg(GERROR, "Too few control points for BSpline %d (%d < 4)", num,
	      List_Nbr(yyvsp[-1].l));
      }
      else{
	if(FindCurve(num)){
	  yymsg(GERROR, "Curve %d already exists", num);
	}
	else{
	  List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	  Curve *c = Create_Curve(num, MSH_SEGM_BSPLN, 2, temp, NULL,
				  -1, -1, 0., 1.);
	  Tree_Add(THEM->Curves, &c);
	  CreateReversedCurve(c);
	  List_Delete(temp);
	}
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_BSPLN;
      yyval.s.Num = num;
    ;
    break;}
case 96:
#line 1322 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(List_Nbr(yyvsp[-1].l) < 4){
	yymsg(GERROR, "Too few control points for Bezier curve %d (%d < 4)", num,
	      List_Nbr(yyvsp[-1].l));
      }
      else{
	if(FindCurve(num)){
	  yymsg(GERROR, "Curve %d already exists", num);
	}
	else{
	  List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	  Curve *c = Create_Curve(num, MSH_SEGM_BEZIER, 2, temp, NULL,
				  -1, -1, 0., 1.);
	  Tree_Add(THEM->Curves, &c);
	  CreateReversedCurve(c);
	  List_Delete(temp);
	}
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_BEZIER;
      yyval.s.Num = num;
    ;
    break;}
case 97:
#line 1346 "Gmsh.y"
{
      int num = (int)yyvsp[-8].d;
      if(List_Nbr(yyvsp[-5].l) + (int)yyvsp[-1].d + 1 != List_Nbr(yyvsp[-3].l)){
	yymsg(GERROR, "Wrong definition of Nurbs Curve %d: "
	      "got %d knots, need N + D + 1 = %d + %d + 1 = %d",
	      (int)yyvsp[-8].d, List_Nbr(yyvsp[-3].l), List_Nbr(yyvsp[-5].l), (int)yyvsp[-1].d, List_Nbr(yyvsp[-5].l) + (int)yyvsp[-1].d + 1);
      }
      else{
	if(FindCurve(num)){
	  yymsg(GERROR, "Curve %d already exists", num);
	}
	else{
	  List_T *temp = ListOfDouble2ListOfInt(yyvsp[-5].l);
	  Curve *c = Create_Curve(num, MSH_SEGM_NURBS, (int)yyvsp[-1].d, temp, yyvsp[-3].l,
				  -1, -1, 0., 1.);
	  Tree_Add(THEM->Curves, &c);
	  CreateReversedCurve(c);
	  List_Delete(temp);
	}
      }
      List_Delete(yyvsp[-5].l);
      List_Delete(yyvsp[-3].l);
      yyval.s.Type = MSH_SEGM_NURBS;
      yyval.s.Num = num;
    ;
    break;}
case 98:
#line 1372 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindEdgeLoop(num)){
	yymsg(GERROR, "Line loop %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	sortEdgesInLoop(num, temp);
	EdgeLoop *l = Create_EdgeLoop(num, temp);
	Tree_Add(THEM->EdgeLoops, &l);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_LOOP;
      yyval.s.Num = num;
    ;
    break;}
case 99:
#line 1389 "Gmsh.y"
{
      int num = (int)yyvsp[-4].i;
      if(FindPhysicalGroup(num, MSH_PHYSICAL_LINE)){
	yymsg(GERROR, "Physical line %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	PhysicalGroup *p = Create_PhysicalGroup(num, MSH_PHYSICAL_LINE, temp);
	List_Delete(temp);
	List_Add(THEM->PhysicalGroups, &p);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_PHYSICAL_LINE;
      yyval.s.Num = num;
    ;
    break;}
case 100:
#line 1408 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindSurface(num)){
	yymsg(GERROR, "Surface %d already exists", num);
      }
      else{
	Surface *s = Create_Surface(num, MSH_SURF_PLAN);
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	setSurfaceGeneratrices(s, temp);
	List_Delete(temp);
	End_Surface(s);
	Tree_Add(THEM->Surfaces, &s);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SURF_PLAN;
      yyval.s.Num = num;
    ;
    break;}
case 101:
#line 1426 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d, type = 0;
      if(FindSurface(num)){
	yymsg(GERROR, "Surface %d already exists", num);
      }
      else{
	double d;
	List_Read(yyvsp[-1].l, 0, &d);
	EdgeLoop *el = FindEdgeLoop((int)fabs(d));
	if(!el){
	  yymsg(GERROR, "Unknown line loop %d", (int)d);
	}
	else{
	  int j = List_Nbr(el->Curves);
	  if(j == 4){
	    type = MSH_SURF_REGL;
	  }
	  else if(j == 3){
	    type = MSH_SURF_TRIC;
	  }
	  else{
	    yymsg(GERROR, "Wrong definition of Ruled Surface %d: "
		  "%d borders instead of 3 or 4", num, j);
	    type = MSH_SURF_PLAN;
	  }
	  Surface *s = Create_Surface(num, type);
	  List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	  setSurfaceGeneratrices(s, temp);
	  List_Delete(temp);
	  End_Surface(s);
	  Tree_Add(THEM->Surfaces, &s);
	}
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = type;
      yyval.s.Num = num;
    ;
    break;}
case 102:
#line 1465 "Gmsh.y"
{
    myGmshSurface = 0;
  ;
    break;}
case 103:
#line 1470 "Gmsh.y"
{
    myGmshSurface = gmshSurface :: surfaceByTag ( (int) yyvsp[-1].d);
  ;
    break;}
case 104:
#line 1475 "Gmsh.y"
{
    int num = (int)yyvsp[-6].d, type = 0;
    myGmshSurface = gmshParametricSurface::NewParametricSurface ((int)yyvsp[-6].d,yyvsp[-3].c,yyvsp[-2].c,yyvsp[-1].c);
  ;
    break;}
case 105:
#line 1481 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d, type = 0;
      if (List_Nbr(yyvsp[-1].l) != 2){
	yymsg(GERROR, "Sphere %d has to be defined using 2 points (center + "
	      "any point) and not %d", num, List_Nbr(yyvsp[-1].l));
      }
      else{
	double p1,p2;
	List_Read(yyvsp[-1].l, 0, &p1);
	List_Read(yyvsp[-1].l, 1, &p2);
	Vertex *v1 = FindPoint((int)p1);
	Vertex *v2 = FindPoint((int)p2);
	if(!v1) yymsg(GERROR, "Sphere %d : unknown point %d", num, (int)p1);
	if(!v2) yymsg(GERROR, "Sphere %d : unknown point %d", num, (int)p2);
	myGmshSurface = gmshSphere::NewSphere
	  (num, v1->Pos.X, v1->Pos.Y, v1->Pos.Z,
	   sqrt((v2->Pos.X - v1->Pos.X) * (v2->Pos.X - v1->Pos.X) +
		(v2->Pos.Y - v1->Pos.Y) * (v2->Pos.Y - v1->Pos.Y) +
		(v2->Pos.Z - v1->Pos.Z) * (v2->Pos.Z - v1->Pos.Z)));
      }      
    ;
    break;}
case 106:
#line 1503 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d, type = 0;
      if (List_Nbr(yyvsp[-1].l) != 2){
	yymsg(GERROR, "PolarSphere %d has to be defined using 2 points (center + "
	      "any point) and not %d", num, List_Nbr(yyvsp[-1].l));
      }
      else{
	double p1,p2;
	List_Read(yyvsp[-1].l, 0, &p1);
	List_Read(yyvsp[-1].l, 1, &p2);
	Vertex *v1 = FindPoint((int)p1);
	Vertex *v2 = FindPoint((int)p2);
	if(!v1) yymsg(GERROR, "PolarSphere %d : unknown point %d", num, (int)p1);
	if(!v2) yymsg(GERROR, "PolarSphere %d : unknown point %d", num, (int)p2);
	myGmshSurface = gmshPolarSphere::NewPolarSphere
	  (num, v1->Pos.X, v1->Pos.Y, v1->Pos.Z,
	   sqrt((v2->Pos.X - v1->Pos.X) * (v2->Pos.X - v1->Pos.X) +
		(v2->Pos.Y - v1->Pos.Y) * (v2->Pos.Y - v1->Pos.Y) +
		(v2->Pos.Z - v1->Pos.Z) * (v2->Pos.Z - v1->Pos.Z)));
      }      
    ;
    break;}
case 107:
#line 1525 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindSurfaceLoop(num)){
	yymsg(GERROR, "Surface loop %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	SurfaceLoop *l = Create_SurfaceLoop(num, temp);
	Tree_Add(THEM->SurfaceLoops, &l);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SURF_LOOP;
      yyval.s.Num = num;
    ;
    break;}
case 108:
#line 1541 "Gmsh.y"
{
      int num = (int)yyvsp[-4].i;
      if(FindPhysicalGroup(num, MSH_PHYSICAL_SURFACE)){
	yymsg(GERROR, "Physical surface %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	PhysicalGroup *p = Create_PhysicalGroup(num, MSH_PHYSICAL_SURFACE, temp);
	List_Delete(temp);
	List_Add(THEM->PhysicalGroups, &p);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_PHYSICAL_SURFACE;
      yyval.s.Num = num;
    ;
    break;}
case 109:
#line 1561 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindVolume(num)){
	yymsg(GERROR, "Volume %d already exists", num);
      }
      else{
	Volume *v = Create_Volume(num, MSH_VOLUME);
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	setVolumeSurfaces(v, temp);
	List_Delete(temp);
	Tree_Add(THEM->Volumes, &v);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_VOLUME;
      yyval.s.Num = num;
    ;
    break;}
case 110:
#line 1578 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindVolume(num)){
	yymsg(GERROR, "Volume %d already exists", num);
      }
      else{
	Volume *v = Create_Volume(num, MSH_VOLUME);
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	setVolumeSurfaces(v, temp);
	List_Delete(temp);
	Tree_Add(THEM->Volumes, &v);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_VOLUME;
      yyval.s.Num = num;
    ;
    break;}
case 111:
#line 1595 "Gmsh.y"
{
      int num = (int)yyvsp[-4].i;
      if(FindPhysicalGroup(num, MSH_PHYSICAL_VOLUME)){
	yymsg(GERROR, "Physical volume %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	PhysicalGroup *p = Create_PhysicalGroup(num, MSH_PHYSICAL_VOLUME, temp);
	List_Delete(temp);
	List_Add(THEM->PhysicalGroups, &p);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_PHYSICAL_VOLUME;
      yyval.s.Num = num;
    ;
    break;}
case 112:
#line 1616 "Gmsh.y"
{
      TranslateShapes(yyvsp[-3].v[0], yyvsp[-3].v[1], yyvsp[-3].v[2], yyvsp[-1].l);
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 113:
#line 1621 "Gmsh.y"
{
      RotateShapes(yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].d, yyvsp[-1].l);
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 114:
#line 1626 "Gmsh.y"
{
      SymmetryShapes(yyvsp[-3].v[0], yyvsp[-3].v[1], yyvsp[-3].v[2], yyvsp[-3].v[3], yyvsp[-1].l);
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 115:
#line 1631 "Gmsh.y"
{
      DilatShapes(yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].d, yyvsp[-1].l);
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 116:
#line 1638 "Gmsh.y"
{ yyval.l = yyvsp[0].l; ;
    break;}
case 117:
#line 1639 "Gmsh.y"
{ yyval.l = yyvsp[0].l; ;
    break;}
case 118:
#line 1640 "Gmsh.y"
{ yyval.l = yyvsp[0].l; ;
    break;}
case 119:
#line 1645 "Gmsh.y"
{
      yyval.l = List_Create(3, 3, sizeof(Shape));
    ;
    break;}
case 120:
#line 1649 "Gmsh.y"
{
      List_Add(yyval.l, &yyvsp[0].s);
    ;
    break;}
case 121:
#line 1653 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	double d;
	List_Read(yyvsp[-2].l, i, &d);
	Shape TheShape;
	TheShape.Num = (int)d;
	Vertex *v = FindPoint(TheShape.Num);
	if(v){
	  TheShape.Type = MSH_POINT;
	  List_Add(yyval.l, &TheShape);
	}
	else{
	  GVertex *gv = GMODEL->vertexByTag(TheShape.Num);
	  if(gv){
	    TheShape.Type = MSH_POINT_FROM_GMODEL;
	    List_Add(yyval.l, &TheShape);
	  }
	  else
	    yymsg(WARNING, "Unknown point %d", TheShape.Num);
	}
      }
    ;
    break;}
case 122:
#line 1676 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	double d;
	List_Read(yyvsp[-2].l, i, &d);
	Shape TheShape;
	TheShape.Num = (int)d;
	Curve *c = FindCurve(TheShape.Num);
	if(c){
	  TheShape.Type = c->Typ;
	  List_Add(yyval.l, &TheShape);
	}
	else{
	  GEdge *ge = GMODEL->edgeByTag(TheShape.Num);
	  if(ge){
	    TheShape.Type = MSH_SEGM_FROM_GMODEL;
	    List_Add(yyval.l, &TheShape);
	  }
	  else
	    yymsg(WARNING, "Unknown curve %d", TheShape.Num);
	}
      }
    ;
    break;}
case 123:
#line 1699 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	double d;
	List_Read(yyvsp[-2].l, i, &d);
	Shape TheShape;
	TheShape.Num = (int)d;
	Surface *s = FindSurface(TheShape.Num);
	if(s){
	  TheShape.Type = s->Typ;
	  List_Add(yyval.l, &TheShape);
	}
	else{
	  GFace *gf = GMODEL->faceByTag(TheShape.Num);
	  if(gf){
	    TheShape.Type = MSH_SURF_FROM_GMODEL;
	    List_Add(yyval.l, &TheShape);
	  }
	  else
	    yymsg(WARNING, "Unknown surface %d", TheShape.Num);
	}
      }
    ;
    break;}
case 124:
#line 1722 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	double d;
	List_Read(yyvsp[-2].l, i, &d);
	Shape TheShape;
	TheShape.Num = (int)d;
	Volume *v = FindVolume(TheShape.Num);
	if(v){
	  TheShape.Type = v->Typ;
	  List_Add(yyval.l, &TheShape);
	}
	else{
	  GRegion *gr = GMODEL->regionByTag(TheShape.Num);
	  if(gr){
	    TheShape.Type = MSH_VOLUME_FROM_GMODEL;
	    List_Add(yyval.l, &TheShape);
	  }
	  else
	    yymsg(WARNING, "Unknown volume %d", TheShape.Num);
	}
      }
    ;
    break;}
case 125:
#line 1750 "Gmsh.y"
{
      yyval.l = List_Create(3, 3, sizeof(Shape));
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	Shape TheShape;
	List_Read(yyvsp[-1].l, i, &TheShape);
	CopyShape(TheShape.Type, TheShape.Num, &TheShape.Num);
	List_Add(yyval.l, &TheShape);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 126:
#line 1762 "Gmsh.y"
{
      if(!strcmp(yyvsp[-4].c, "View")) AliasView((int)yyvsp[-2].d, 0);
      Free(yyvsp[-4].c);
      yyval.l = NULL;
    ;
    break;}
case 127:
#line 1768 "Gmsh.y"
{
      if(!strcmp(yyvsp[-4].c, "View")) AliasView((int)yyvsp[-2].d, 0);
      Free(yyvsp[-4].c);
      yyval.l = NULL;
    ;
    break;}
case 128:
#line 1774 "Gmsh.y"
{
      if(!strcmp(yyvsp[-4].c, "View")) AliasView((int)yyvsp[-2].d, 1);
      Free(yyvsp[-4].c);
      yyval.l = NULL;
    ;
    break;}
case 129:
#line 1786 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	Shape TheShape;
	List_Read(yyvsp[-1].l, i, &TheShape);
	DeleteShape(TheShape.Type, TheShape.Num);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 130:
#line 1795 "Gmsh.y"
{
      if(!strcmp(yyvsp[-4].c, "View")){
	RemoveViewByIndex((int)yyvsp[-2].d);
      }
      else{
	yymsg(GERROR, "Unknown command 'Delete %s'", yyvsp[-4].c);
      }
      Free(yyvsp[-4].c);
    ;
    break;}
case 131:
#line 1805 "Gmsh.y"
{
      if(!strcmp(yyvsp[-1].c, "Meshes") || !strcmp(yyvsp[-1].c, "All")){
	GMODEL->destroy();
	THEM->destroy();
      }
      else if(!strcmp(yyvsp[-1].c, "Physicals")){
	List_Action(THEM->PhysicalGroups, Free_PhysicalGroup);
	List_Reset(THEM->PhysicalGroups);
	GMODEL->deletePhysicalGroups();
      }
      else{
	yymsg(GERROR, "Unknown command 'Delete %s'", yyvsp[-1].c);
      }
      Free(yyvsp[-1].c);
    ;
    break;}
case 132:
#line 1821 "Gmsh.y"
{
      if(!strcmp(yyvsp[-2].c, "Empty") && !strcmp(yyvsp[-1].c, "Views")){
	for(int i = List_Nbr(CTX.post.list) - 1; i >= 0; i--){
	  Post_View *v = *(Post_View **) List_Pointer(CTX.post.list, i);
	  if(v->empty())
	    RemoveViewByIndex(i);
	}
      }
      else{
	yymsg(GERROR, "Unknown command 'Delete %s %s'", yyvsp[-2].c, yyvsp[-1].c);
      }
      Free(yyvsp[-2].c); Free(yyvsp[-1].c);
    ;
    break;}
case 133:
#line 1840 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	Shape TheShape;
	List_Read(yyvsp[-1].l, i, &TheShape);
	ColorShape(TheShape.Type, TheShape.Num, yyvsp[-3].u);
      }
      List_Delete(yyvsp[-1].l);      
    ;
    break;}
case 134:
#line 1854 "Gmsh.y"
{
      for(int i = 0; i < 4; i++)
	VisibilityShape(yyvsp[-1].c, i, 1);
      Free(yyvsp[-1].c);
    ;
    break;}
case 135:
#line 1860 "Gmsh.y"
{
      for(int i = 0; i < 4; i++)
	VisibilityShape(yyvsp[-1].c, i, 0);
      Free(yyvsp[-1].c);
    ;
    break;}
case 136:
#line 1866 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	Shape TheShape;
	List_Read(yyvsp[-1].l, i, &TheShape);
	VisibilityShape(TheShape.Type, TheShape.Num, 1);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 137:
#line 1875 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	Shape TheShape;
	List_Read(yyvsp[-1].l, i, &TheShape);
	VisibilityShape(TheShape.Type, TheShape.Num, 0);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 138:
#line 1889 "Gmsh.y"
{
      if(!strcmp(yyvsp[-2].c, "Include")){
	char tmpstring[1024];
	FixRelativePath(yyvsp[-1].c, tmpstring);
	// Warning: we *don't* close included files (to allow user
	// functions in these files). If you need to include many many
	// files and don't have functions in the files, use "Merge"
	// instead: some OSes limit the number of files a process can
	// open simultaneously. The right solution would be of course
	// to modify FunctionManager to reopen the files instead of
	// using the FILE pointer, but hey, I'm lazy...
	Msg(STATUS2, "Reading '%s'", tmpstring);
	ParseFile(tmpstring, 0, 1);
	SetBoundingBox();
	Msg(STATUS2, "Read '%s'", tmpstring);
      }
      else if(!strcmp(yyvsp[-2].c, "Print")){
#if defined(HAVE_FLTK)
	// make sure we have the latest data from THEM in GModel
	// (fixes bug where we would have no geometry in the picture if
	// the print command is in the same file as the geometry)
	GMODEL->importTHEM();
	char tmpstring[1024];
	FixRelativePath(yyvsp[-1].c, tmpstring);
	CreateOutputFile(tmpstring, CTX.print.format);
#endif
      }
      else if(!strcmp(yyvsp[-2].c, "Save")){
#if defined(HAVE_FLTK)
	GMODEL->importTHEM();
	char tmpstring[1024];
	FixRelativePath(yyvsp[-1].c, tmpstring);
	CreateOutputFile(tmpstring, CTX.mesh.format);
#endif
      }
      else if(!strcmp(yyvsp[-2].c, "Merge") || !strcmp(yyvsp[-2].c, "MergeWithBoundingBox")){
	// MergeWithBoundingBox is deprecated
	char tmpstring[1024];
	FixRelativePath(yyvsp[-1].c, tmpstring);
	MergeFile(tmpstring, 1);
      }
      else if(!strcmp(yyvsp[-2].c, "System")){
	SystemCall(yyvsp[-1].c);
      }
      else{
	yymsg(GERROR, "Unknown command '%s'", yyvsp[-2].c);
      }
      Free(yyvsp[-2].c); Free(yyvsp[-1].c);
    ;
    break;}
case 139:
#line 1939 "Gmsh.y"
{
      if(!strcmp(yyvsp[-6].c, "Save") && !strcmp(yyvsp[-5].c, "View")){
	Post_View **vv = (Post_View **)List_Pointer_Test(CTX.post.list, (int)yyvsp[-3].d);
	if(vv){
	  char tmpstring[1024];
	  FixRelativePath(yyvsp[-1].c, tmpstring);
	  WriteView(*vv, tmpstring, CTX.post.file_format, 0);
	}
      }
      else{
	yymsg(GERROR, "Unknown command '%s'", yyvsp[-6].c);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-5].c); Free(yyvsp[-1].c);
    ;
    break;}
case 140:
#line 1954 "Gmsh.y"
{
      if(!strcmp(yyvsp[-6].c, "Background") && !strcmp(yyvsp[-5].c, "Mesh")  && !strcmp(yyvsp[-4].c, "View")){
	Post_View **vv = (Post_View **)List_Pointer_Test(CTX.post.list, (int)yyvsp[-2].d);
	if(vv) BGMWithView(*vv);
      }
      else{
	yymsg(GERROR, "Unknown command '%s'", yyvsp[-6].c);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-5].c); Free(yyvsp[-4].c);
    ;
    break;}
case 141:
#line 1965 "Gmsh.y"
{
      if(!strcmp(yyvsp[-2].c, "Sleep")){
	SleepInSeconds(yyvsp[-1].d);
      }
      else if(!strcmp(yyvsp[-2].c, "Remesh")){
	Msg(GERROR, "Surface ReMeshing must be reinterfaced");
	//	ReMesh();
      }
      else if(!strcmp(yyvsp[-2].c, "Mesh")){
	yymsg(GERROR, "Mesh directives are not (yet) allowed in scripts");
      }
      else if(!strcmp(yyvsp[-2].c, "Status")){
	yymsg(GERROR, "Mesh directives are not (yet) allowed in scripts");
      }
      else{
	yymsg(GERROR, "Unknown command '%s'", yyvsp[-2].c);
      }
      Free(yyvsp[-2].c);
    ;
    break;}
case 142:
#line 1985 "Gmsh.y"
{
       try {
	 GMSH_PluginManager::instance()->action(yyvsp[-4].c, yyvsp[-1].c, 0);
       }
       catch(...) {
	 yymsg(GERROR, "Unknown action '%s' or plugin '%s'", yyvsp[-1].c, yyvsp[-4].c);
       }
       Free(yyvsp[-4].c); Free(yyvsp[-1].c);
     ;
    break;}
case 143:
#line 1995 "Gmsh.y"
{
      if(!strcmp(yyvsp[-1].c, "ElementsFromAllViews"))
	CombineViews(0, 1, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "ElementsFromVisibleViews"))
	CombineViews(0, 0, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "ElementsByViewName"))
	CombineViews(0, 2, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "TimeStepsFromAllViews"))
	CombineViews(1, 1, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "TimeStepsFromVisibleViews"))
	CombineViews(1, 0, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "TimeStepsByViewName"))
	CombineViews(1, 2, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "Views"))
	CombineViews(0, 1, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "TimeSteps"))
	CombineViews(1, 2, CTX.post.combine_remove_orig);
      else
	yymsg(GERROR, "Unknown 'Combine' command");
      Free(yyvsp[-1].c);
    ;
    break;}
case 144:
#line 2017 "Gmsh.y"
{
      exit(0);
    ;
    break;}
case 145:
#line 2021 "Gmsh.y"
{
      CTX.forced_bbox = 0;
      SetBoundingBox();
    ;
    break;}
case 146:
#line 2026 "Gmsh.y"
{
      CTX.forced_bbox = 1;
      SetBoundingBox(yyvsp[-12].d, yyvsp[-10].d, yyvsp[-8].d, yyvsp[-6].d, yyvsp[-4].d, yyvsp[-2].d);
    ;
    break;}
case 147:
#line 2031 "Gmsh.y"
{
#if defined(HAVE_FLTK)
      Draw();
#endif
    ;
    break;}
case 148:
#line 2043 "Gmsh.y"
{
      LoopControlVariablesTab[ImbricatedLoop][0] = yyvsp[-3].d;
      LoopControlVariablesTab[ImbricatedLoop][1] = yyvsp[-1].d;
      LoopControlVariablesTab[ImbricatedLoop][2] = 1.0;
      LoopControlVariablesNameTab[ImbricatedLoop] = NULL;
      fgetpos(yyin, &yyposImbricatedLoopsTab[ImbricatedLoop]);
      yylinenoImbricatedLoopsTab[ImbricatedLoop] = yylineno;
      ImbricatedLoop++;
      if(ImbricatedLoop > MAX_RECUR_LOOPS-1){
	yymsg(GERROR, "Reached maximum number of imbricated loops");
	ImbricatedLoop = MAX_RECUR_LOOPS-1;
      }
      if(yyvsp[-3].d > yyvsp[-1].d) skip_until("For", "EndFor");
    ;
    break;}
case 149:
#line 2058 "Gmsh.y"
{
      LoopControlVariablesTab[ImbricatedLoop][0] = yyvsp[-5].d;
      LoopControlVariablesTab[ImbricatedLoop][1] = yyvsp[-3].d;
      LoopControlVariablesTab[ImbricatedLoop][2] = yyvsp[-1].d;
      LoopControlVariablesNameTab[ImbricatedLoop] = NULL;
      fgetpos(yyin, &yyposImbricatedLoopsTab[ImbricatedLoop]);
      yylinenoImbricatedLoopsTab[ImbricatedLoop] = yylineno;
      ImbricatedLoop++;
      if(ImbricatedLoop > MAX_RECUR_LOOPS-1){
	yymsg(GERROR, "Reached maximum number of imbricated loops");
	ImbricatedLoop = MAX_RECUR_LOOPS-1;
      }
      if((yyvsp[-1].d > 0. && yyvsp[-5].d > yyvsp[-3].d) || (yyvsp[-1].d < 0. && yyvsp[-5].d < yyvsp[-3].d))
	skip_until("For", "EndFor");
    ;
    break;}
case 150:
#line 2074 "Gmsh.y"
{
      LoopControlVariablesTab[ImbricatedLoop][0] = yyvsp[-3].d;
      LoopControlVariablesTab[ImbricatedLoop][1] = yyvsp[-1].d;
      LoopControlVariablesTab[ImbricatedLoop][2] = 1.0;
      LoopControlVariablesNameTab[ImbricatedLoop] = yyvsp[-6].c;
      Symbol TheSymbol;      
      TheSymbol.Name = yyvsp[-6].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	TheSymbol.val = List_Create(1, 1, sizeof(double));
	List_Put(TheSymbol.val, 0, &yyvsp[-3].d);
	Tree_Add(Symbol_T, &TheSymbol);
      }
      else{
	List_Write(pSymbol->val, 0, &yyvsp[-3].d);
      }
      fgetpos(yyin, &yyposImbricatedLoopsTab[ImbricatedLoop]);
      yylinenoImbricatedLoopsTab[ImbricatedLoop] = yylineno;
      ImbricatedLoop++;
      if(ImbricatedLoop > MAX_RECUR_LOOPS-1){
	yymsg(GERROR, "Reached maximum number of imbricated loops");
	ImbricatedLoop = MAX_RECUR_LOOPS-1;
      }
      if(yyvsp[-3].d > yyvsp[-1].d) skip_until("For", "EndFor");
    ;
    break;}
case 151:
#line 2100 "Gmsh.y"
{
      LoopControlVariablesTab[ImbricatedLoop][0] = yyvsp[-5].d;
      LoopControlVariablesTab[ImbricatedLoop][1] = yyvsp[-3].d;
      LoopControlVariablesTab[ImbricatedLoop][2] = yyvsp[-1].d;
      LoopControlVariablesNameTab[ImbricatedLoop] = yyvsp[-8].c;
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-8].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	TheSymbol.val = List_Create(1, 1, sizeof(double));
	List_Put(TheSymbol.val, 0, &yyvsp[-5].d);
	Tree_Add(Symbol_T, &TheSymbol);
      }
      else{
	List_Write(pSymbol->val, 0, &yyvsp[-5].d);
      }
      fgetpos(yyin, &yyposImbricatedLoopsTab[ImbricatedLoop]);
      yylinenoImbricatedLoopsTab[ImbricatedLoop] = yylineno;
      ImbricatedLoop++;
      if(ImbricatedLoop > MAX_RECUR_LOOPS-1){
	yymsg(GERROR, "Reached maximum number of imbricated loops");
	ImbricatedLoop = MAX_RECUR_LOOPS-1;
      }
      if((yyvsp[-1].d > 0. && yyvsp[-5].d > yyvsp[-3].d) || (yyvsp[-1].d < 0. && yyvsp[-5].d < yyvsp[-3].d))
	skip_until("For", "EndFor");
    ;
    break;}
case 152:
#line 2127 "Gmsh.y"
{
      if(ImbricatedLoop <= 0){
	yymsg(GERROR, "Invalid For/EndFor loop");
	ImbricatedLoop = 0;
      }
      else{
	double x0 = LoopControlVariablesTab[ImbricatedLoop-1][0];
	double x1 = LoopControlVariablesTab[ImbricatedLoop-1][1];
	double step = LoopControlVariablesTab[ImbricatedLoop-1][2];
	int do_next = (step > 0.) ? (x0+step <= x1) : (x0+step >= x1);
	if(do_next){
	  LoopControlVariablesTab[ImbricatedLoop-1][0] +=
	    LoopControlVariablesTab[ImbricatedLoop-1][2];
	  if(LoopControlVariablesNameTab[ImbricatedLoop-1]){
	    Symbol TheSymbol;
	    TheSymbol.Name = LoopControlVariablesNameTab[ImbricatedLoop-1];
	    Symbol *pSymbol;
	    if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol)))
	      yymsg(GERROR, "Unknown loop variable");
	    else
	      *(double*)List_Pointer_Fast(pSymbol->val, 0) += 
		LoopControlVariablesTab[ImbricatedLoop-1][2];
	  }
	  fsetpos(yyin, &yyposImbricatedLoopsTab[ImbricatedLoop-1]);
	  yylineno = yylinenoImbricatedLoopsTab[ImbricatedLoop-1];
	}
	else{
	  ImbricatedLoop--;
	}
      }
    ;
    break;}
case 153:
#line 2159 "Gmsh.y"
{
      if(!FunctionManager::Instance()->createFunction(yyvsp[0].c, yyin, yyname, yylineno))
	yymsg(GERROR, "Redefinition of function %s", yyvsp[0].c);
      skip_until(NULL, "Return");
      //FIXME: wee leak $2
    ;
    break;}
case 154:
#line 2166 "Gmsh.y"
{
      if(!FunctionManager::Instance()->leaveFunction(&yyin, yyname, yylineno))
	yymsg(GERROR, "Error while exiting function");
    ;
    break;}
case 155:
#line 2171 "Gmsh.y"
{
      if(!FunctionManager::Instance()->enterFunction(yyvsp[-1].c, &yyin, yyname, yylineno))
	yymsg(GERROR, "Unknown function %s", yyvsp[-1].c);
      //FIXME: wee leak $2
    ;
    break;}
case 156:
#line 2177 "Gmsh.y"
{
      if(!yyvsp[-1].d) skip_until("If", "EndIf");
    ;
    break;}
case 157:
#line 2181 "Gmsh.y"
{
    ;
    break;}
case 158:
#line 2190 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(TRANSLATE, yyvsp[-1].l, 
		    yyvsp[-3].v[0], yyvsp[-3].v[1], yyvsp[-3].v[2], 0., 0., 0., 0., 0., 0., 0.,
		    NULL, yyval.l);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 159:
#line 2198 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(ROTATE, yyvsp[-1].l, 
		    0., 0., 0., yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].d,
		    NULL, yyval.l);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 160:
#line 2206 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(TRANSLATE_ROTATE, yyvsp[-1].l, 
		    yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].d,
		    NULL, yyval.l);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 161:
#line 2214 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 162:
#line 2218 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(TRANSLATE, yyvsp[-3].l, 
		    yyvsp[-5].v[0], yyvsp[-5].v[1], yyvsp[-5].v[2], 0., 0., 0., 0., 0., 0., 0.,
		    &extr, yyval.l);
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 163:
#line 2226 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 164:
#line 2230 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(ROTATE, yyvsp[-3].l, 
		    0., 0., 0., yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		    &extr, yyval.l);
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 165:
#line 2238 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 166:
#line 2242 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(TRANSLATE_ROTATE, yyvsp[-3].l, 
		    yyvsp[-12].v[0], yyvsp[-12].v[1], yyvsp[-12].v[2], yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		    &extr, yyval.l);
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 167:
#line 2250 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 168:
#line 2254 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(BOUNDARY_LAYER, yyvsp[-3].l, 0., 0., 0., 0., 0., 0., 0., 0., 0., 0.,
		    &extr, yyval.l);
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 169:
#line 2261 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 170:
#line 2265 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      extr.mesh.ViewIndex = yyvsp[-6].d;
      ExtrudeShapes(BOUNDARY_LAYER, yyvsp[-3].l, 0., 0., 0., 0., 0., 0., 0., 0., 0., 0.,
		    &extr, yyval.l);
      extr.mesh.ViewIndex = -1;
      Free(yyvsp[-8].c);
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 171:
#line 2277 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_POINT, (int)yyvsp[-4].d, 
		   yyvsp[-2].v[0], yyvsp[-2].v[1], yyvsp[-2].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   NULL, yyval.l);
    ;
    break;}
case 172:
#line 2284 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_SEGM_LINE, (int)yyvsp[-4].d, 
		   yyvsp[-2].v[0], yyvsp[-2].v[1], yyvsp[-2].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   NULL, yyval.l);
    ;
    break;}
case 173:
#line 2291 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_SURF_PLAN, (int)yyvsp[-4].d, 
		   yyvsp[-2].v[0], yyvsp[-2].v[1], yyvsp[-2].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   NULL, yyval.l);
    ;
    break;}
case 174:
#line 2298 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_POINT, (int)yyvsp[-8].d, 
		   0., 0., 0., yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 175:
#line 2305 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_SEGM_LINE, (int)yyvsp[-8].d, 
		   0., 0., 0., yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 176:
#line 2312 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_SURF_PLAN, (int)yyvsp[-8].d, 
		   0., 0., 0., yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 177:
#line 2319 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_POINT, (int)yyvsp[-10].d, 
		   yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 178:
#line 2326 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_SEGM_LINE, (int)yyvsp[-10].d, 
		   yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 179:
#line 2333 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_SURF_PLAN, (int)yyvsp[-10].d, 
		   yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 180:
#line 2340 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 181:
#line 2344 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_POINT, (int)yyvsp[-8].d, 
		   yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   &extr, yyval.l);
    ;
    break;}
case 182:
#line 2351 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 183:
#line 2355 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_SEGM_LINE, (int)yyvsp[-8].d, 
		   yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   &extr, yyval.l);
    ;
    break;}
case 184:
#line 2362 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 185:
#line 2366 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_SURF_PLAN, (int)yyvsp[-8].d, 
		   yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   &extr, yyval.l);
    ;
    break;}
case 186:
#line 2373 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 187:
#line 2377 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_POINT, (int)yyvsp[-12].d, 
		   0., 0., 0., yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 188:
#line 2384 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 189:
#line 2388 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_SEGM_LINE, (int)yyvsp[-12].d, 
		   0., 0., 0., yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 190:
#line 2395 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 191:
#line 2399 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_SURF_PLAN, (int)yyvsp[-12].d, 
		   0., 0., 0., yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 192:
#line 2406 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 193:
#line 2410 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_POINT, (int)yyvsp[-14].d, 
		   yyvsp[-12].v[0], yyvsp[-12].v[1], yyvsp[-12].v[2], yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 194:
#line 2417 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 195:
#line 2421 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_SEGM_LINE, (int)yyvsp[-14].d, 
		   yyvsp[-12].v[0], yyvsp[-12].v[1], yyvsp[-12].v[2], yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 196:
#line 2428 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 197:
#line 2432 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_SURF_PLAN, (int)yyvsp[-14].d, 
		   yyvsp[-12].v[0], yyvsp[-12].v[1], yyvsp[-12].v[2], yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 198:
#line 2443 "Gmsh.y"
{
    ;
    break;}
case 199:
#line 2446 "Gmsh.y"
{
    ;
    break;}
case 200:
#line 2452 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = true;
      extr.mesh.NbLayer = 1;
      extr.mesh.NbElmLayer.clear();
      extr.mesh.hLayer.clear();
      extr.mesh.NbElmLayer.push_back((int)fabs(yyvsp[-2].d));
      extr.mesh.hLayer.push_back(1.);
    ;
    break;}
case 201:
#line 2461 "Gmsh.y"
{
      double d;
      extr.mesh.ExtrudeMesh = true;
      extr.mesh.NbLayer = List_Nbr(yyvsp[-4].l);
      if(List_Nbr(yyvsp[-4].l) == List_Nbr(yyvsp[-2].l)){
	extr.mesh.NbElmLayer.clear();
	extr.mesh.hLayer.clear();
	for(int i = 0; i < List_Nbr(yyvsp[-4].l); i++){
	  List_Read(yyvsp[-4].l, i, &d);
	  extr.mesh.NbElmLayer.push_back((d > 0) ? (int)d : 1);
	  List_Read(yyvsp[-2].l, i, &d);
	  extr.mesh.hLayer.push_back(d);
	}
      }
      else{
	yymsg(GERROR, "Wrong layer definition {%d, %d}", 
	      List_Nbr(yyvsp[-4].l), List_Nbr(yyvsp[-2].l));
      }
      List_Delete(yyvsp[-4].l);
      List_Delete(yyvsp[-2].l);
    ;
    break;}
case 202:
#line 2483 "Gmsh.y"
{
      yymsg(WARNING, "Explicit region numbers in layers are deprecated");
      double d;
      extr.mesh.ExtrudeMesh = true;
      extr.mesh.NbLayer = List_Nbr(yyvsp[-6].l);
      if(List_Nbr(yyvsp[-6].l) == List_Nbr(yyvsp[-4].l) && List_Nbr(yyvsp[-6].l) == List_Nbr(yyvsp[-2].l)){
	extr.mesh.NbElmLayer.clear();
	extr.mesh.hLayer.clear();
	for(int i = 0; i < List_Nbr(yyvsp[-6].l); i++){
	  List_Read(yyvsp[-6].l, i, &d);
	  extr.mesh.NbElmLayer.push_back((d > 0) ? (int)d : 1);
	  List_Read(yyvsp[-2].l, i, &d);
	  extr.mesh.hLayer.push_back(d);
	}
      }
      else{
	yymsg(GERROR, "Wrong layer definition {%d, %d, %d}", 
	      List_Nbr(yyvsp[-6].l), List_Nbr(yyvsp[-4].l), List_Nbr(yyvsp[-2].l));
      }
      List_Delete(yyvsp[-6].l);
      List_Delete(yyvsp[-4].l);
      List_Delete(yyvsp[-2].l);
    ;
    break;}
case 203:
#line 2507 "Gmsh.y"
{
      extr.mesh.Recombine = true;
    ;
    break;}
case 204:
#line 2511 "Gmsh.y"
{
      int num = (int)yyvsp[-6].d;
      if(FindSurface(num)){
	yymsg(GERROR, "Surface %d already exists", num);
      }
      else{
	Surface *s = Create_Surface(num, MSH_SURF_DISCRETE);
	Tree_Add(THEM->Surfaces, &s);
	extr.mesh.Holes[num].first = yyvsp[-1].d;
	extr.mesh.Holes[num].second.clear();
	for(int i = 0; i < List_Nbr(yyvsp[-3].l); i++){
	  double d;
	  List_Read(yyvsp[-3].l, i, &d);
	  extr.mesh.Holes[num].second.push_back((int)d);
	}
      }
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 205:
#line 2535 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-3].l); i++){
	double d;
	List_Read(yyvsp[-3].l, i, &d);
	int j = (int)fabs(d);
        Curve *c = FindCurve(j);
	if(!c)
	  yymsg(WARNING, "Unknown curve %d", j);
	else{
	  c->Method = TRANSFINI;
	  c->ipar[0] = (yyvsp[-1].d>2)?(int)yyvsp[-1].d:2;
	  c->ipar[1] = sign(d);
	  c->dpar[0] = 1.0;
	}
      }
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 206:
#line 2553 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-6].l); i++){
	double d;
	List_Read(yyvsp[-6].l, i, &d);
	int j = (int)fabs(d);
        Curve *c = FindCurve(j);
	if(!c)
	  yymsg(WARNING, "Unknown curve %d", j);
	else{
	  c->Method = TRANSFINI;
	  c->ipar[0] = (yyvsp[-4].d>2)?(int)yyvsp[-4].d:2;
	  c->ipar[1] = sign(d); /* Progresion : code 1 ou -1 */
	  c->dpar[0] = fabs(yyvsp[-1].d);
	}
      }
      List_Delete(yyvsp[-6].l);
    ;
    break;}
case 207:
#line 2571 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-6].l); i++){
	double d;
	List_Read(yyvsp[-6].l, i, &d);
	int j = (int)fabs(d);
        Curve *c = FindCurve(j);
	if(!c)
	  yymsg(WARNING, "Unknown curve %d", j);
	else{
	  c->Method = TRANSFINI;
	  c->ipar[0] = (yyvsp[-4].d>2)?(int)yyvsp[-4].d:2;
	  c->ipar[1] = 2*sign(d); /* Bump : code 2 ou -2 */
	  c->dpar[0] = fabs(yyvsp[-1].d);
	}
      }
      List_Delete(yyvsp[-6].l);
    ;
    break;}
case 208:
#line 2589 "Gmsh.y"
{
      Surface *s = FindSurface((int)yyvsp[-4].d);
      if(!s)
	yymsg(WARNING, "Unknown surface %d", (int)yyvsp[-4].d);
      else{
	s->Method = TRANSFINI;
	s->Recombine_Dir = -1;
	int k = List_Nbr(yyvsp[-1].l);
	if(k != 3 && k != 4){
	  yymsg(GERROR, "Wrong definition of Transfinite Surface %d: "
		"%d points instead of 3 or 4" , (int)yyvsp[-4].d, k);
	}
	else{
	  List_Reset(s->TrsfPoints);
	  for(int i = 0; i < k; i++){
	    double d;
	    List_Read(yyvsp[-1].l, i, &d);
	    int j = (int)fabs(d);
	    Vertex *v = FindPoint(j);
	    if(!v)
	      yymsg(WARNING, "Unknown point %d", j);
	    else
	      List_Add(s->TrsfPoints, &v);
	  }
	}
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 209:
#line 2618 "Gmsh.y"
{
      Surface *s = FindSurface((int)yyvsp[-5].d);
      if(!s)
	yymsg(WARNING, "Unknown surface %d", (int)yyvsp[-5].d);
      else{
	s->Method = TRANSFINI;
	int k = List_Nbr(yyvsp[-2].l);
	if(k != 3 && k != 4){
	  yymsg(GERROR, "Wrong definition of Transfinite Surface %d: "
		"%d points instead of 3 or 4" , (int)yyvsp[-5].d, k);
	}
	else{
	  List_Reset(s->TrsfPoints);
	  if (!strcmp(yyvsp[-1].c, "Right"))
	    s->Recombine_Dir = 1;
	  else if (!strcmp(yyvsp[-1].c, "Left"))
	    s->Recombine_Dir = -1;
	  else
	    s->Recombine_Dir = 0;
	  for(int i = 0; i < k; i++){
	    double d;
	    List_Read(yyvsp[-2].l, i, &d);
	    int j = (int)fabs(d);
	    Vertex *v = FindPoint(j);
	    if(!v)
	      yymsg(WARNING, "Unknown point %d", j);
	    else
	      List_Add(s->TrsfPoints, &v);
	  }
	}
      }
      List_Delete(yyvsp[-2].l);
      Free(yyvsp[-1].c);
    ;
    break;}
case 210:
#line 2653 "Gmsh.y"
{
      yymsg(WARNING, "Elliptic Surface is deprecated: use Transfinite instead (with smoothing)");
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 211:
#line 2658 "Gmsh.y"
{
      Volume *v = FindVolume((int)yyvsp[-4].d);
      if(!v)
	yymsg(WARNING, "Unknown volume %d", (int)yyvsp[-4].d);
      else{
	v->Method = TRANSFINI;
	int k = List_Nbr(yyvsp[-1].l);
	if(k != 6 && k != 8)
	  yymsg(GERROR, "Wrong definition of Transfinite Volume %d: "
		"%d points instead of 6 or 8" , (int)yyvsp[-4].d, k);
	else{
	  List_Reset(v->TrsfPoints);
	  for(int i = 0; i < k; i++){
	    double d;
	    List_Read(yyvsp[-1].l, i, &d);
	    int j = (int)fabs(d);
	    Vertex *vert = FindPoint(j);
	    if(!vert)
	      yymsg(WARNING, "Unknown point %d", j);
	    else
	      List_Add(v->TrsfPoints, &vert);
	  }
	}
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 212:
#line 2685 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-3].l); i++){
	double d;
	List_Read(yyvsp[-3].l, i, &d);
	int j = (int)d;
	Surface *s = FindSurface(j);
	if(s){
	  s->Recombine = 1;
	  s->RecombineAngle = (yyvsp[-1].d > 0 && yyvsp[-1].d < 90) ? yyvsp[-1].d : 90;
	}
      }
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 213:
#line 2699 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	double d;
	List_Read(yyvsp[-1].l, i, &d);
	int j = (int)d;
        Surface *s = FindSurface(j);
	if(s){
	  s->Recombine = 1;
        }
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 214:
#line 2718 "Gmsh.y"
{ 
      Surface *s = FindSurface((int)yyvsp[-2].d);
      if(s)
	setSurfaceEmbeddedPoints(s, yyvsp[-7].l);
    ;
    break;}
case 215:
#line 2724 "Gmsh.y"
{
      Surface *s = FindSurface((int)yyvsp[-2].d);
      if(s)
	setSurfaceEmbeddedCurves(s, yyvsp[-7].l);
    ;
    break;}
case 216:
#line 2730 "Gmsh.y"
{
    ;
    break;}
case 217:
#line 2733 "Gmsh.y"
{
    ;
    break;}
case 218:
#line 2742 "Gmsh.y"
{ 
      ReplaceAllDuplicates();
    ;
    break;}
case 219:
#line 2751 "Gmsh.y"
{ yyval.d = yyvsp[0].d;           ;
    break;}
case 220:
#line 2752 "Gmsh.y"
{ yyval.d = yyvsp[-1].d;           ;
    break;}
case 221:
#line 2753 "Gmsh.y"
{ yyval.d = -yyvsp[0].d;          ;
    break;}
case 222:
#line 2754 "Gmsh.y"
{ yyval.d = yyvsp[0].d;           ;
    break;}
case 223:
#line 2755 "Gmsh.y"
{ yyval.d = !yyvsp[0].d;          ;
    break;}
case 224:
#line 2756 "Gmsh.y"
{ yyval.d = yyvsp[-2].d - yyvsp[0].d;      ;
    break;}
case 225:
#line 2757 "Gmsh.y"
{ yyval.d = yyvsp[-2].d + yyvsp[0].d;      ;
    break;}
case 226:
#line 2758 "Gmsh.y"
{ yyval.d = yyvsp[-2].d * yyvsp[0].d;      ;
    break;}
case 227:
#line 2760 "Gmsh.y"
{ 
      if(!yyvsp[0].d)
	yymsg(GERROR, "Division by zero in '%g / %g'", yyvsp[-2].d, yyvsp[0].d);
      else
	yyval.d = yyvsp[-2].d / yyvsp[0].d;     
    ;
    break;}
case 228:
#line 2766 "Gmsh.y"
{ yyval.d = (int)yyvsp[-2].d % (int)yyvsp[0].d;  ;
    break;}
case 229:
#line 2767 "Gmsh.y"
{ yyval.d = pow(yyvsp[-2].d, yyvsp[0].d);  ;
    break;}
case 230:
#line 2768 "Gmsh.y"
{ yyval.d = yyvsp[-2].d < yyvsp[0].d;      ;
    break;}
case 231:
#line 2769 "Gmsh.y"
{ yyval.d = yyvsp[-2].d > yyvsp[0].d;      ;
    break;}
case 232:
#line 2770 "Gmsh.y"
{ yyval.d = yyvsp[-2].d <= yyvsp[0].d;     ;
    break;}
case 233:
#line 2771 "Gmsh.y"
{ yyval.d = yyvsp[-2].d >= yyvsp[0].d;     ;
    break;}
case 234:
#line 2772 "Gmsh.y"
{ yyval.d = yyvsp[-2].d == yyvsp[0].d;     ;
    break;}
case 235:
#line 2773 "Gmsh.y"
{ yyval.d = yyvsp[-2].d != yyvsp[0].d;     ;
    break;}
case 236:
#line 2774 "Gmsh.y"
{ yyval.d = yyvsp[-2].d && yyvsp[0].d;     ;
    break;}
case 237:
#line 2775 "Gmsh.y"
{ yyval.d = yyvsp[-2].d || yyvsp[0].d;     ;
    break;}
case 238:
#line 2776 "Gmsh.y"
{ yyval.d = yyvsp[-4].d? yyvsp[-2].d : yyvsp[0].d;  ;
    break;}
case 239:
#line 2777 "Gmsh.y"
{ yyval.d = exp(yyvsp[-1].d);      ;
    break;}
case 240:
#line 2778 "Gmsh.y"
{ yyval.d = log(yyvsp[-1].d);      ;
    break;}
case 241:
#line 2779 "Gmsh.y"
{ yyval.d = log10(yyvsp[-1].d);    ;
    break;}
case 242:
#line 2780 "Gmsh.y"
{ yyval.d = sqrt(yyvsp[-1].d);     ;
    break;}
case 243:
#line 2781 "Gmsh.y"
{ yyval.d = sin(yyvsp[-1].d);      ;
    break;}
case 244:
#line 2782 "Gmsh.y"
{ yyval.d = asin(yyvsp[-1].d);     ;
    break;}
case 245:
#line 2783 "Gmsh.y"
{ yyval.d = cos(yyvsp[-1].d);      ;
    break;}
case 246:
#line 2784 "Gmsh.y"
{ yyval.d = acos(yyvsp[-1].d);     ;
    break;}
case 247:
#line 2785 "Gmsh.y"
{ yyval.d = tan(yyvsp[-1].d);      ;
    break;}
case 248:
#line 2786 "Gmsh.y"
{ yyval.d = atan(yyvsp[-1].d);     ;
    break;}
case 249:
#line 2787 "Gmsh.y"
{ yyval.d = atan2(yyvsp[-3].d, yyvsp[-1].d);;
    break;}
case 250:
#line 2788 "Gmsh.y"
{ yyval.d = sinh(yyvsp[-1].d);     ;
    break;}
case 251:
#line 2789 "Gmsh.y"
{ yyval.d = cosh(yyvsp[-1].d);     ;
    break;}
case 252:
#line 2790 "Gmsh.y"
{ yyval.d = tanh(yyvsp[-1].d);     ;
    break;}
case 253:
#line 2791 "Gmsh.y"
{ yyval.d = fabs(yyvsp[-1].d);     ;
    break;}
case 254:
#line 2792 "Gmsh.y"
{ yyval.d = floor(yyvsp[-1].d);    ;
    break;}
case 255:
#line 2793 "Gmsh.y"
{ yyval.d = ceil(yyvsp[-1].d);     ;
    break;}
case 256:
#line 2794 "Gmsh.y"
{ yyval.d = fmod(yyvsp[-3].d, yyvsp[-1].d); ;
    break;}
case 257:
#line 2795 "Gmsh.y"
{ yyval.d = fmod(yyvsp[-3].d, yyvsp[-1].d); ;
    break;}
case 258:
#line 2796 "Gmsh.y"
{ yyval.d = sqrt(yyvsp[-3].d*yyvsp[-3].d+yyvsp[-1].d*yyvsp[-1].d); ;
    break;}
case 259:
#line 2797 "Gmsh.y"
{ yyval.d = yyvsp[-1].d*(double)rand()/(double)RAND_MAX; ;
    break;}
case 260:
#line 2799 "Gmsh.y"
{ yyval.d = exp(yyvsp[-1].d);      ;
    break;}
case 261:
#line 2800 "Gmsh.y"
{ yyval.d = log(yyvsp[-1].d);      ;
    break;}
case 262:
#line 2801 "Gmsh.y"
{ yyval.d = log10(yyvsp[-1].d);    ;
    break;}
case 263:
#line 2802 "Gmsh.y"
{ yyval.d = sqrt(yyvsp[-1].d);     ;
    break;}
case 264:
#line 2803 "Gmsh.y"
{ yyval.d = sin(yyvsp[-1].d);      ;
    break;}
case 265:
#line 2804 "Gmsh.y"
{ yyval.d = asin(yyvsp[-1].d);     ;
    break;}
case 266:
#line 2805 "Gmsh.y"
{ yyval.d = cos(yyvsp[-1].d);      ;
    break;}
case 267:
#line 2806 "Gmsh.y"
{ yyval.d = acos(yyvsp[-1].d);     ;
    break;}
case 268:
#line 2807 "Gmsh.y"
{ yyval.d = tan(yyvsp[-1].d);      ;
    break;}
case 269:
#line 2808 "Gmsh.y"
{ yyval.d = atan(yyvsp[-1].d);     ;
    break;}
case 270:
#line 2809 "Gmsh.y"
{ yyval.d = atan2(yyvsp[-3].d, yyvsp[-1].d);;
    break;}
case 271:
#line 2810 "Gmsh.y"
{ yyval.d = sinh(yyvsp[-1].d);     ;
    break;}
case 272:
#line 2811 "Gmsh.y"
{ yyval.d = cosh(yyvsp[-1].d);     ;
    break;}
case 273:
#line 2812 "Gmsh.y"
{ yyval.d = tanh(yyvsp[-1].d);     ;
    break;}
case 274:
#line 2813 "Gmsh.y"
{ yyval.d = fabs(yyvsp[-1].d);     ;
    break;}
case 275:
#line 2814 "Gmsh.y"
{ yyval.d = floor(yyvsp[-1].d);    ;
    break;}
case 276:
#line 2815 "Gmsh.y"
{ yyval.d = ceil(yyvsp[-1].d);     ;
    break;}
case 277:
#line 2816 "Gmsh.y"
{ yyval.d = fmod(yyvsp[-3].d, yyvsp[-1].d); ;
    break;}
case 278:
#line 2817 "Gmsh.y"
{ yyval.d = fmod(yyvsp[-3].d, yyvsp[-1].d); ;
    break;}
case 279:
#line 2818 "Gmsh.y"
{ yyval.d = sqrt(yyvsp[-3].d*yyvsp[-3].d+yyvsp[-1].d*yyvsp[-1].d); ;
    break;}
case 280:
#line 2819 "Gmsh.y"
{ yyval.d = yyvsp[-1].d*(double)rand()/(double)RAND_MAX; ;
    break;}
case 281:
#line 2828 "Gmsh.y"
{ yyval.d = yyvsp[0].d; ;
    break;}
case 282:
#line 2829 "Gmsh.y"
{ yyval.d = 3.141592653589793; ;
    break;}
case 283:
#line 2830 "Gmsh.y"
{ yyval.d = ParUtil::Instance()->rank(); ;
    break;}
case 284:
#line 2831 "Gmsh.y"
{ yyval.d = ParUtil::Instance()->size(); ;
    break;}
case 285:
#line 2832 "Gmsh.y"
{ yyval.d = Get_GmshMajorVersion(); ;
    break;}
case 286:
#line 2833 "Gmsh.y"
{ yyval.d = Get_GmshMinorVersion(); ;
    break;}
case 287:
#line 2834 "Gmsh.y"
{ yyval.d = Get_GmshPatchVersion(); ;
    break;}
case 288:
#line 2839 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[0].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[0].c);
	yyval.d = 0.;
      }
      else
	yyval.d = *(double*)List_Pointer_Fast(pSymbol->val, 0);
      Free(yyvsp[0].c);
    ;
    break;}
case 289:
#line 2855 "Gmsh.y"
{
      char tmpstring[1024];
      sprintf(tmpstring, "%s_%d", yyvsp[-4].c, (int)yyvsp[-1].d) ;
      Symbol TheSymbol;
      TheSymbol.Name = tmpstring;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", tmpstring);
	yyval.d = 0.;
      }
      else
	yyval.d = *(double*)List_Pointer_Fast(pSymbol->val, 0);
      Free(yyvsp[-4].c);
    ;
    break;}
case 290:
#line 2870 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-3].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-3].c);
	yyval.d = 0.;
      }
      else{
	double *pd;
	if((pd = (double*)List_Pointer_Test(pSymbol->val, (int)yyvsp[-1].d)))
	  yyval.d = *pd;
	else{
	  yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-3].c, (int)yyvsp[-1].d);
	  yyval.d = 0.;
	}
      }
      Free(yyvsp[-3].c);
    ;
    break;}
case 291:
#line 2890 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-2].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-2].c);
	yyval.d = 0.;
      }
      else{
	yyval.d = List_Nbr(pSymbol->val);
      }
      Free(yyvsp[-2].c);
    ;
    break;}
case 292:
#line 2904 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-1].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-1].c);
	yyval.d = 0.;
      }
      else
	yyval.d = (*(double*)List_Pointer_Fast(pSymbol->val, 0) += yyvsp[0].i);
      Free(yyvsp[-1].c);
    ;
    break;}
case 293:
#line 2917 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-4].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-4].c);
	yyval.d = 0.;
      }
      else{
	double *pd;
	if((pd = (double*)List_Pointer_Test(pSymbol->val, (int)yyvsp[-2].d)))
	  yyval.d = (*pd += yyvsp[0].i);
	else{
	  yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-4].c, (int)yyvsp[-2].d);
	  yyval.d = 0.;
	}
      }
      Free(yyvsp[-4].c);
    ;
    break;}
case 294:
#line 2940 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-2].c))){
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-2].c);
	yyval.d = 0.;
      }
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[0].c, pNumCat))){
	  yymsg(GERROR, "Unknown numeric option '%s.%s'", yyvsp[-2].c, yyvsp[0].c);
	  yyval.d = 0.;
	}
	else
	  yyval.d = pNumOpt(0, GMSH_GET, 0);
      }
      Free(yyvsp[-2].c); Free(yyvsp[0].c);
    ;
    break;}
case 295:
#line 2958 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-5].c))){
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-5].c);
	yyval.d = 0.;
      }
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[0].c, pNumCat))){
	  yymsg(GERROR, "Unknown numeric option '%s[%d].%s'", yyvsp[-5].c, (int)yyvsp[-3].d, yyvsp[0].c);
	  yyval.d = 0.;
	}
	else
	  yyval.d = pNumOpt((int)yyvsp[-3].d, GMSH_GET, 0);
      }
      Free(yyvsp[-5].c); Free(yyvsp[0].c);
    ;
    break;}
case 296:
#line 2976 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-3].c))){
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-3].c);
	yyval.d = 0.;
      }
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[-1].c, pNumCat))){
	  yymsg(GERROR, "Unknown numeric option '%s.%s'", yyvsp[-3].c, yyvsp[-1].c);
	  yyval.d = 0.;
	}
	else
	  yyval.d = pNumOpt(0, GMSH_SET|GMSH_GUI, pNumOpt(0, GMSH_GET, 0)+yyvsp[0].i);
      }
      Free(yyvsp[-3].c); Free(yyvsp[-1].c);
    ;
    break;}
case 297:
#line 2994 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-6].c))){
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-6].c);
	yyval.d = 0.;
      }
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[-1].c, pNumCat))){
	  yymsg(GERROR, "Unknown numeric option '%s[%d].%s'", yyvsp[-6].c, (int)yyvsp[-4].d, yyvsp[-1].c);
	  yyval.d = 0.;
	}
	else
	  yyval.d = pNumOpt((int)yyvsp[-4].d, GMSH_SET|GMSH_GUI, pNumOpt((int)yyvsp[-4].d, GMSH_GET, 0)+yyvsp[0].i);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-1].c);
    ;
    break;}
case 298:
#line 3012 "Gmsh.y"
{ 
      yyval.d = GetValue(yyvsp[-3].c, yyvsp[-1].d);
      Free(yyvsp[-3].c);
    ;
    break;}
case 299:
#line 3020 "Gmsh.y"
{
      memcpy(yyval.v, yyvsp[0].v, 5*sizeof(double));
    ;
    break;}
case 300:
#line 3024 "Gmsh.y"
{
      for(int i = 0; i < 5; i++) yyval.v[i] = -yyvsp[0].v[i];
    ;
    break;}
case 301:
#line 3028 "Gmsh.y"
{ 
      for(int i = 0; i < 5; i++) yyval.v[i] = yyvsp[0].v[i];
    ;
    break;}
case 302:
#line 3032 "Gmsh.y"
{ 
      for(int i = 0; i < 5; i++) yyval.v[i] = yyvsp[-2].v[i] - yyvsp[0].v[i];
    ;
    break;}
case 303:
#line 3036 "Gmsh.y"
{
      for(int i = 0; i < 5; i++) yyval.v[i] = yyvsp[-2].v[i] + yyvsp[0].v[i];
    ;
    break;}
case 304:
#line 3043 "Gmsh.y"
{ 
      yyval.v[0] = yyvsp[-9].d;  yyval.v[1] = yyvsp[-7].d;  yyval.v[2] = yyvsp[-5].d;  yyval.v[3] = yyvsp[-3].d; yyval.v[4] = yyvsp[-1].d;
    ;
    break;}
case 305:
#line 3047 "Gmsh.y"
{ 
      yyval.v[0] = yyvsp[-7].d;  yyval.v[1] = yyvsp[-5].d;  yyval.v[2] = yyvsp[-3].d;  yyval.v[3] = yyvsp[-1].d; yyval.v[4] = 1.0;
    ;
    break;}
case 306:
#line 3051 "Gmsh.y"
{
      yyval.v[0] = yyvsp[-5].d;  yyval.v[1] = yyvsp[-3].d;  yyval.v[2] = yyvsp[-1].d;  yyval.v[3] = 0.0; yyval.v[4] = 1.0;
    ;
    break;}
case 307:
#line 3055 "Gmsh.y"
{
      yyval.v[0] = yyvsp[-5].d;  yyval.v[1] = yyvsp[-3].d;  yyval.v[2] = yyvsp[-1].d;  yyval.v[3] = 0.0; yyval.v[4] = 1.0;
    ;
    break;}
case 308:
#line 3062 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(List_T*));
      List_Add(yyval.l, &(yyvsp[0].l));
    ;
    break;}
case 309:
#line 3067 "Gmsh.y"
{
      List_Add(yyval.l, &(yyvsp[0].l));
    ;
    break;}
case 310:
#line 3075 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double));
      List_Add(yyval.l, &(yyvsp[0].d));
    ;
    break;}
case 311:
#line 3080 "Gmsh.y"
{
      yyval.l = yyvsp[0].l;
    ;
    break;}
case 312:
#line 3084 "Gmsh.y"
{
      // creates an empty list
      yyval.l = List_Create(2, 1, sizeof(double));
    ;
    break;}
case 313:
#line 3089 "Gmsh.y"
{
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 314:
#line 3093 "Gmsh.y"
{
      yyval.l = yyvsp[-1].l;
      for(int i = 0; i < List_Nbr(yyval.l); i++){
	double *pd = (double*)List_Pointer(yyval.l, i);
	(*pd) = - (*pd);
      }
    ;
    break;}
case 315:
#line 3101 "Gmsh.y"
{
      yyval.l = yyvsp[-1].l;
      for(int i = 0; i < List_Nbr(yyval.l); i++){
	double *pd = (double*)List_Pointer(yyval.l, i);
	(*pd) *= yyvsp[-4].d;
      }
    ;
    break;}
case 316:
#line 3112 "Gmsh.y"
{
      yyval.l = yyvsp[0].l;
      for(int i = 0; i < List_Nbr(yyval.l); i++){
	double *pd = (double*)List_Pointer(yyval.l, i);
	(*pd) = - (*pd);
      }
    ;
    break;}
case 317:
#line 3120 "Gmsh.y"
{
      yyval.l = yyvsp[0].l;
      for(int i = 0; i < List_Nbr(yyval.l); i++){
	double *pd = (double*)List_Pointer(yyval.l, i);
	(*pd) *= yyvsp[-2].d;
      }
    ;
    break;}
case 318:
#line 3128 "Gmsh.y"
{ 
      yyval.l = List_Create(2, 1, sizeof(double)); 
      for(double d = yyvsp[-2].d; (yyvsp[-2].d < yyvsp[0].d) ? (d <= yyvsp[0].d) : (d >= yyvsp[0].d); (yyvsp[-2].d < yyvsp[0].d) ? (d += 1.) : (d -= 1.)) 
	List_Add(yyval.l, &d);
    ;
    break;}
case 319:
#line 3134 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double)); 
      if(!yyvsp[0].d || (yyvsp[-4].d < yyvsp[-2].d && yyvsp[0].d < 0) || (yyvsp[-4].d > yyvsp[-2].d && yyvsp[0].d > 0)){
        yymsg(GERROR, "Wrong increment in '%g:%g:%g'", yyvsp[-4].d, yyvsp[-2].d, yyvsp[0].d);
	List_Add(yyval.l, &(yyvsp[-4].d));
      }
      else
	for(double d = yyvsp[-4].d; (yyvsp[0].d > 0) ? (d <= yyvsp[-2].d) : (d >= yyvsp[-2].d); d += yyvsp[0].d)
	  List_Add(yyval.l, &d);
   ;
    break;}
case 320:
#line 3145 "Gmsh.y"
{
      // Returns the coordinates of a point and fills a list with it.
      // This allows to ensure e.g. that relative point positions are
      // always conserved
      Vertex *v = FindPoint((int)yyvsp[-1].d);
      yyval.l = List_Create(3, 1, sizeof(double));      
      if(!v) {
	yymsg(GERROR, "Unknown point '%d'", (int) yyvsp[-1].d);
	double d = 0.0;
	List_Add(yyval.l, &d);
	List_Add(yyval.l, &d);
	List_Add(yyval.l, &d);
      }
      else{
	List_Add(yyval.l, &v->Pos.X);
	List_Add(yyval.l, &v->Pos.Y);
	List_Add(yyval.l, &v->Pos.Z);
      }
    ;
    break;}
case 321:
#line 3165 "Gmsh.y"
{
      yyval.l = List_Create(List_Nbr(yyvsp[0].l), 1, sizeof(double));
      for(int i = 0; i < List_Nbr(yyvsp[0].l); i++){
	Shape *s = (Shape*) List_Pointer(yyvsp[0].l, i);
	double d = s->Num;
	List_Add(yyval.l, &d);
      }
      List_Delete(yyvsp[0].l);
    ;
    break;}
case 322:
#line 3175 "Gmsh.y"
{
      yyval.l = List_Create(List_Nbr(yyvsp[0].l), 1, sizeof(double));
      for(int i = 0; i < List_Nbr(yyvsp[0].l); i++){
	Shape *s = (Shape*) List_Pointer(yyvsp[0].l, i);
	double d = s->Num;
	List_Add(yyval.l, &d);
      }
      List_Delete(yyvsp[0].l);
    ;
    break;}
case 323:
#line 3185 "Gmsh.y"
{
      yyval.l = List_Create(List_Nbr(yyvsp[0].l), 1, sizeof(double));
      for(int i = 0; i < List_Nbr(yyvsp[0].l); i++){
	Shape *s = (Shape*) List_Pointer(yyvsp[0].l, i);
	double d = s->Num;
	List_Add(yyval.l, &d);
      }
      List_Delete(yyvsp[0].l);
    ;
    break;}
case 324:
#line 3195 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double));
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-2].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-2].c);
	double d = 0.0;
	List_Add(yyval.l, &d);
      }
      else{
	for(int i = 0; i < List_Nbr(pSymbol->val); i++)
	  List_Add(yyval.l, (double*)List_Pointer_Fast(pSymbol->val, i));
      }
      Free(yyvsp[-2].c);
    ;
    break;}
case 325:
#line 3212 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double));
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-5].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-5].c);
	double d = 0.0;
	List_Add(yyval.l, &d);
      }
      else{
	for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	  int j = (int)(*(double*)List_Pointer_Fast(yyvsp[-2].l, i));
	  double *pd;
	  if((pd = (double*)List_Pointer_Test(pSymbol->val, j)))
	    List_Add(yyval.l, pd);
	  else
	    yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-5].c, j);	  
	}
      }
      Free(yyvsp[-5].c);
      List_Delete(yyvsp[-2].l);
    ;
    break;}
case 326:
#line 3239 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double));
      List_Add(yyval.l, &(yyvsp[0].d));
    ;
    break;}
case 327:
#line 3244 "Gmsh.y"
{
      yyval.l = yyvsp[0].l;
    ;
    break;}
case 328:
#line 3248 "Gmsh.y"
{
      List_Add(yyval.l, &(yyvsp[0].d));
    ;
    break;}
case 329:
#line 3252 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[0].l); i++){
	double d;
	List_Read(yyvsp[0].l, i, &d);
	List_Add(yyval.l, &d);
      }
      List_Delete(yyvsp[0].l);
    ;
    break;}
case 330:
#line 3265 "Gmsh.y"
{
      yyval.u = CTX.PACK_COLOR((int)yyvsp[-7].d, (int)yyvsp[-5].d, (int)yyvsp[-3].d, (int)yyvsp[-1].d);
    ;
    break;}
case 331:
#line 3269 "Gmsh.y"
{
      yyval.u = CTX.PACK_COLOR((int)yyvsp[-5].d, (int)yyvsp[-3].d, (int)yyvsp[-1].d, 255);
    ;
    break;}
case 332:
#line 3281 "Gmsh.y"
{
      int flag;
      yyval.u = Get_ColorForString(ColorString, -1, yyvsp[0].c, &flag);
      if(flag) yymsg(GERROR, "Unknown color '%s'", yyvsp[0].c);
      Free(yyvsp[0].c);
    ;
    break;}
case 333:
#line 3288 "Gmsh.y"
{
      unsigned int (*pColOpt)(int num, int action, unsigned int value);
      StringXColor *pColCat;
      if(!(pColCat = Get_ColorOptionCategory(yyvsp[-4].c))){
	yymsg(GERROR, "Unknown color option class '%s'", yyvsp[-4].c);
	yyval.u = 0;
      }
      else{
	if(!(pColOpt =  (unsigned int (*) (int, int, unsigned int))Get_ColorOption(yyvsp[0].c, pColCat))){
	  yymsg(GERROR, "Unknown color option '%s.Color.%s'", yyvsp[-4].c, yyvsp[0].c);
	  yyval.u = 0;
	}
	else{
	  yyval.u = pColOpt(0, GMSH_GET, 0);
	}
      }
      Free(yyvsp[-4].c); Free(yyvsp[0].c);
    ;
    break;}
case 334:
#line 3310 "Gmsh.y"
{
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 335:
#line 3314 "Gmsh.y"
{
      yyval.l = List_Create(256, 10, sizeof(unsigned int));
      GmshColorTable *ct = Get_ColorTable((int)yyvsp[-3].d);
      if(!ct)
	yymsg(GERROR, "View[%d] does not exist", (int)yyvsp[-3].d);
      else{
	for(int i = 0; i < ct->size; i++) 
	  List_Add(yyval.l, &ct->table[i]);
      }
      Free(yyvsp[-5].c);
    ;
    break;}
case 336:
#line 3329 "Gmsh.y"
{
      yyval.l = List_Create(256, 10, sizeof(unsigned int));
      List_Add(yyval.l, &(yyvsp[0].u));
    ;
    break;}
case 337:
#line 3334 "Gmsh.y"
{
      List_Add(yyval.l, &(yyvsp[0].u));
    ;
    break;}
case 338:
#line 3341 "Gmsh.y"
{
      yyval.c = yyvsp[0].c;
    ;
    break;}
case 339:
#line 3345 "Gmsh.y"
{
      Msg(WARNING, "Named string expressions not implemented yet");
    ;
    break;}
case 340:
#line 3352 "Gmsh.y"
{
      yyval.c = yyvsp[0].c;
    ;
    break;}
case 341:
#line 3356 "Gmsh.y"
{
      yyval.c = (char *)Malloc(32*sizeof(char));
      time_t now;
      time(&now);
      strcpy(yyval.c, ctime(&now));
      yyval.c[strlen(yyval.c) - 1] = '\0';
    ;
    break;}
case 342:
#line 3364 "Gmsh.y"
{
      yyval.c = (char *)Malloc((strlen(yyvsp[-3].c)+strlen(yyvsp[-1].c)+1)*sizeof(char));
      strcpy(yyval.c, yyvsp[-3].c);
      strcat(yyval.c, yyvsp[-1].c);
      Free(yyvsp[-3].c);
      Free(yyvsp[-1].c);
    ;
    break;}
case 343:
#line 3372 "Gmsh.y"
{
      yyval.c = (char *)Malloc((strlen(yyvsp[-1].c)+1)*sizeof(char));
      int i;
      for(i = strlen(yyvsp[-1].c)-1; i >= 0; i--){
	if(yyvsp[-1].c[i] == '.'){
	  strncpy(yyval.c, yyvsp[-1].c, i);
	  yyval.c[i]='\0';
	  break;
	}
      }
      if(i <= 0) strcpy(yyval.c, yyvsp[-1].c);
      Free(yyvsp[-1].c);
    ;
    break;}
case 344:
#line 3386 "Gmsh.y"
{
      yyval.c = (char *)Malloc((strlen(yyvsp[-1].c)+1)*sizeof(char));
      int i;
      for(i = strlen(yyvsp[-1].c)-1; i >= 0; i--){
	if(yyvsp[-1].c[i] == '/' || yyvsp[-1].c[i] == '\\')
	  break;
      }
      if(i <= 0)
	strcpy(yyval.c, yyvsp[-1].c);
      else
	strcpy(yyval.c, &yyvsp[-1].c[i+1]);
      Free(yyvsp[-1].c);
    ;
    break;}
case 345:
#line 3400 "Gmsh.y"
{
      yyval.c = yyvsp[-1].c;
    ;
    break;}
case 346:
#line 3404 "Gmsh.y"
{
      char tmpstring[1024];
      int i = PrintListOfDouble(yyvsp[-3].c, yyvsp[-1].l, tmpstring);
      if(i < 0){
	yymsg(GERROR, "Too few arguments in Sprintf");
	yyval.c = yyvsp[-3].c;
      }
      else if(i > 0){
	yymsg(GERROR, "%d extra argument%s in Sprintf", i, (i>1)?"s":"");
	yyval.c = yyvsp[-3].c;
      }
      else{
	yyval.c = (char*)Malloc((strlen(tmpstring)+1)*sizeof(char));
	strcpy(yyval.c, tmpstring);
	Free(yyvsp[-3].c);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 347:
#line 3423 "Gmsh.y"
{ 
      char* (*pStrOpt)(int num, int action, char *value);
      StringXString *pStrCat;
      if(!(pStrCat = Get_StringOptionCategory(yyvsp[-3].c))){
	yymsg(GERROR, "Unknown string option class '%s'", yyvsp[-3].c);
	yyval.c = (char*)Malloc(sizeof(char));
	yyval.c[0] = '\0';
      }
      else{
	if(!(pStrOpt = (char *(*) (int, int, char *))Get_StringOption(yyvsp[-1].c, pStrCat))){
	  yymsg(GERROR, "Unknown string option '%s.%s'", yyvsp[-3].c, yyvsp[-1].c);
	  yyval.c = (char*)Malloc(sizeof(char));
	  yyval.c[0] = '\0';
	}
	else{
	  char *str = pStrOpt(0, GMSH_GET, NULL);
	  yyval.c = (char*)Malloc((strlen(str)+1)*sizeof(char));
	  strcpy(yyval.c, str);
	}
      }
    ;
    break;}
case 348:
#line 3445 "Gmsh.y"
{ 
      char* (*pStrOpt)(int num, int action, char *value);
      StringXString *pStrCat;
      if(!(pStrCat = Get_StringOptionCategory(yyvsp[-6].c))){
	yymsg(GERROR, "Unknown string option class '%s'", yyvsp[-6].c);
	yyval.c = (char*)Malloc(sizeof(char));
	yyval.c[0] = '\0';
      }
      else{
	if(!(pStrOpt = (char *(*) (int, int, char *))Get_StringOption(yyvsp[-1].c, pStrCat))){
	  yymsg(GERROR, "Unknown string option '%s[%d].%s'", yyvsp[-6].c, (int)yyvsp[-4].d, yyvsp[-1].c);
	  yyval.c = (char*)Malloc(sizeof(char));
	  yyval.c[0] = '\0';
	}
	else{
	  char *str = pStrOpt((int)yyvsp[-4].d, GMSH_GET, NULL);
	  yyval.c = (char*)Malloc((strlen(str)+1)*sizeof(char));
	  strcpy(yyval.c, str);
	}
      }
    ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 3468 "Gmsh.y"


void DeleteSymbol(void *a, void *b){
  Symbol *s = (Symbol*)a;
  Free(s->Name);
  List_Delete(s->val);
}

int CompareSymbols (const void *a, const void *b){
  return(strcmp(((Symbol*)a)->Name, ((Symbol*)b)->Name));
}

void InitSymbols(void){
  if(Symbol_T){
    Tree_Action(Symbol_T, DeleteSymbol);
    Tree_Delete(Symbol_T);
  }
  Symbol_T = Tree_Create(sizeof(Symbol), CompareSymbols);
}

int PrintListOfDouble(char *format, List_T *list, char *buffer){
  int j, k;
  char tmp1[256], tmp2[256];

  j = 0;
  buffer[j] = '\0';

  while(j < (int)strlen(format) && format[j] != '%') j++;
  strncpy(buffer, format, j); 
  buffer[j]='\0'; 
  for(int i = 0; i < List_Nbr(list); i++){
    k = j;
    j++;
    if(j < (int)strlen(format)){
      if(format[j] == '%'){
	strcat(buffer, "%");
	j++;
      }
      while(j < (int)strlen(format) && format[j] != '%') j++;
      if(k != j){
	strncpy(tmp1, &(format[k]), j-k);
	tmp1[j-k] = '\0';
	sprintf(tmp2, tmp1, *(double*)List_Pointer(list, i)); 
	strcat(buffer, tmp2);
      }
    }
    else{
      return List_Nbr(list)-i;
    }
  }
  if(j != (int)strlen(format))
    return -1;
  return 0;
}

int CheckViewErrorFlags(Post_View *v){
  if(View->adaptive) return 0; // hope for the best :-)

  char *name[8] = { "point", "line", "triangle", "quadrangle", 
		    "tetrahedron", "hexahedron", "prism", "pyramid" };
  char *type[3] = { "scalar", "vector", "tensor" };

  if(8 * 3 != VIEW_NB_ELEMENT_TYPES){
    Msg(GERROR, "Please upgrade CheckViewErrorFlags!");
    return 0;
  }
  
  for(int i = 0; i < VIEW_NB_ELEMENT_TYPES; i++)
    if(ViewErrorFlags[i])
      Msg(GERROR, "%d %s %s%s in View[%d] contain%s a wrong number of values",
	  ViewErrorFlags[i], type[i%3], name[i/3], (ViewErrorFlags[i] > 1) ? "s" : "",
	  v->Index, (ViewErrorFlags[i] > 1) ? "" : "s");
  
  return 0;
}

void yyerror(char *s){
  Msg(GERROR, "'%s', line %d : %s (%s)", yyname, yylineno-1, s, yytext);
  yyerrorstate++;
}

void yymsg(int type, char *fmt, ...){
  va_list args;
  char tmp[1024];

  va_start (args, fmt);
  vsprintf (tmp, fmt, args);
  va_end (args);

  Msg(type, "'%s', line %d : %s", yyname, yylineno-1, tmp);

  if(type == GERROR) yyerrorstate++;
}
